#ifndef EE_HPP
#define EE_HPP
/**
	@mainpage eepp - Entropia Engine++

	Developed by: Martín Lucas Golini

	eepp is an open source cross-platform game and application development
	framework heavily focused on the development of rich graphical user interfaces.
*/

// General includes and declarations
#include <eepp/core.hpp>
#include <eepp/version.hpp>
using namespace EE;

// Math
#include <eepp/math.hpp>
using namespace EE::Math;

// System
#include <eepp/system.hpp>
using namespace EE::System;

// Audio
#include <eepp/audio.hpp>
using namespace EE::Audio;

// Window
#include <eepp/window.hpp>
using namespace EE::Window;

// Graphics
#include <eepp/graphics.hpp>
using namespace EE::Graphics;

// Network
#include <eepp/network.hpp>
using namespace EE::Network;
using namespace EE::Network::SSL;

// Scene
#include <eepp/scene.hpp>
using namespace EE::Scene;

// UI
#include <eepp/ui.hpp>
using namespace EE::UI;
using namespace EE::UI::Tools;

#endif
