#include <eepp/ui/doc/languages/cmake.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addCMake() {

	SyntaxDefinitionManager::instance()->add(

		{ "CMake",
		  { "%.cmake$", "CMakeLists%.txt$" },
		  {
			  { { "#", "\n" }, "comment" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'", "'", "\\" }, "string" },
			  { { "[%a_][%w_]*%s?%f[(]" }, "function" },
			  { { "CMAKE_[%w%d_]+" }, "keyword" },
			  { { "CTEST_[%w%d_]+" }, "keyword" },
			  { { "!?%[([^%]].-)%]%((%#+[%w-]*)%)" }, { "keyword", "function", "link" } },
			  { { "https?://[%w_.~!*:@&+$/?%%#-]-%w[-.%w]*%.%w%w%w?%w?:?%d*/?[%w_.~!*:@&+$/"
				  "?%%#=-]*" },
				"link" },
			  { { "/?[%w_]+/[%w_][%w_/]+%.?%w+" }, "normal" },
			  { { "%u[%u%d_]*_[%u%d_]+" }, "keyword" },
			  { { "%${[%a_][%w_]*%}" }, "keyword2" },
			  { { "[%a_][%w_]*" }, "symbol" },
		  },
		  {
			  { "REPLACE", "literal" },
			  { "SOURCES", "keyword2" },
			  { "REGEX", "literal" },
			  { "RUNTIME", "literal" },
			  { "LANGUAGE", "keyword2" },
			  { "C", "literal" },
			  { "TOLOWER", "literal" },
			  { "FALSE", "literal" },
			  { "DEPRECATION", "keyword2" },
			  { "LIBTYPE", "literal" },
			  { "DISABLED", "keyword2" },
			  { "VARIABLES", "keyword2" },
			  { "PREFIX", "keyword2" },
			  { "APPEND", "literal" },
			  { "OFF", "literal" },
			  { "XCTEST", "keyword2" },
			  { "HELPSTRING", "keyword2" },
			  { "AUTORCC", "keyword2" },
			  { "TESTS", "keyword2" },
			  { "TARGET", "literal" },
			  { "NAME", "keyword2" },
			  { "LABELS", "keyword2" },
			  { "VALUE", "keyword2" },
			  { "TYPE", "keyword2" },
			  { "TRUE", "literal" },
			  { "EchoString", "keyword2" },
			  { "ARCHIVE", "literal" },
			  { "IMMEDIATE", "literal" },
			  { "DESTINATION", "literal" },
			  { "INTERFACE", "literal" },
			  { "PROCESSORS", "keyword2" },
			  { "ENVIRONMENT", "keyword2" },
			  { "SUFFIX", "keyword2" },
			  { "TOUPPER", "literal" },
			  { "ENV", "keyword2" },
			  { "STATUS", "literal" },
			  { "BUNDLE", "keyword2" },
			  { "SOVERSION", "keyword2" },
			  { "SUBDIRECTORIES", "keyword2" },
			  { "SYMBOLIC", "keyword2" },
			  { "COST", "keyword2" },
			  { "ABSTRACT", "keyword2" },
			  { "IMPORTED", "keyword2" },
			  { "MODIFIED", "keyword2" },
			  { "GLOB", "literal" },
			  { "MACROS", "keyword2" },
			  { "LOCATION", "keyword2" },
			  { "CXX", "literal" },
			  { "WARNING", "literal" },
			  { "TIMEOUT", "keyword2" },
			  { "CACHE", "keyword2" },
			  { "EXPR", "literal" },
			  { "FRAMEWORK", "keyword2" },
			  { "DEPENDS", "keyword2" },
			  { "LIBRARY", "literal" },
			  { "MEASUREMENT", "keyword2" },
			  { "GENERATED", "keyword2" },
			  { "STRINGS", "keyword2" },
			  { "VERSION", "keyword2" },
			  { "KEEP_EXTENSION", "keyword2" },
			  { "RESOURCE", "keyword2" },
			  { "ADVANCED", "keyword2" },
			  { "LANGUAGES", "keyword2" },
			  { "ON", "literal" },
			  { "OFF", "literal" },
			  { "On", "literal" },
			  { "Off", "literal" },
			  { "STRING", "keyword2" },
			  { "COMMENT", "keyword2" },

			  { "IF", "keyword" },
			  { "BOOL", "keyword" },
			  { "VERSION_LESS", "keyword" },
			  { "VERSION_GREATER", "keyword" },
			  { "VERSION_EQUAL", "keyword" },
			  { "VERSION_LESS_EQUAL", "keyword" },
			  { "VERSION_GREATER_EQUAL", "keyword" },
			  { "LOWER_CASE", "keyword" },
			  { "UPPER_CASE", "keyword" },
			  { "MAKE_C_IDENTIFIER", "keyword" },
			  { "IN_LIST", "keyword" },
			  { "JOIN", "keyword" },
			  { "REMOVE_DUPLICATES", "keyword" },
			  { "FILTER", "keyword" },
			  { "PATH_EQUAL", "keyword" },
			  { "PATH", "keyword" },
			  { "SHELL_PATH", "keyword" },
			  { "CONFIG", "keyword" },
			  { "OUTPUT_CONFIG", "keyword" },
			  { "COMMAND_CONFIG", "keyword" },
			  { "PLATFORM_ID", "keyword" },
			  { "C_COMPILER_VERSION", "keyword" },
			  { "CXX_COMPILER_VERSION", "keyword" },
			  { "CUDA_COMPILER_VERSION", "keyword" },
			  { "OBJC_COMPILER_VERSION", "keyword" },
			  { "OBJCXX_COMPILER_VERSION", "keyword" },
			  { "Fortran_COMPILER_VERSION", "keyword" },
			  { "HIP_COMPILER_VERSION", "keyword" },
			  { "ISPC_COMPILER_VERSION", "keyword" },
			  { "C_COMPILER_ID", "keyword" },
			  { "CXX_COMPILER_ID", "keyword" },
			  { "CUDA_COMPILER_ID", "keyword" },
			  { "OBJC_COMPILER_ID", "keyword" },
			  { "OBJCXX_COMPILER_ID", "keyword" },
			  { "Fortran_COMPILER_ID", "keyword" },
			  { "HIP_COMPILER_ID", "keyword" },
			  { "ISPC_COMPILER_ID", "keyword" },
			  { "COMPILE_LANGUAGE", "keyword" },
			  { "COMPILE_LANG_AND_ID", "keyword" },
			  { "COMPILE_FEATURES", "keyword" },
			  { "LINK_LANGUAGE", "keyword" },
			  { "LINK_LANG_AND_ID", "keyword" },
			  { "LINK_LIBRARY", "keyword" },
			  { "LINK_GROUP", "keyword" },
			  { "LINK_ONLY", "keyword" },
			  { "DEVICE_LINK", "keyword" },
			  { "HOST_LINK", "keyword" },
			  { "TARGET_EXISTS", "keyword" },
			  { "TARGET_NAME_IF_EXISTS", "keyword" },
			  { "TARGET_NAME", "keyword" },
			  { "TARGET_PROPERTY", "keyword" },
			  { "TARGET_OBJECTS", "keyword" },
			  { "TARGET_POLICY", "keyword" },
			  { "TARGET_FILE", "keyword" },
			  { "TARGET_FILE_BASE_NAME", "keyword" },
			  { "TARGET_FILE_PREFIX", "keyword" },
			  { "TARGET_FILE_SUFFIX", "keyword" },
			  { "TARGET_FILE_NAME", "keyword" },
			  { "TARGET_FILE_DIR", "keyword" },
			  { "TARGET_LINKER_FILE", "keyword" },
			  { "TARGET_LINKER_FILE_BASE_NAME", "keyword" },
			  { "TARGET_LINKER_FILE_PREFIX", "keyword" },
			  { "TARGET_LINKER_FILE_SUFFIX", "keyword" },
			  { "TARGET_LINKER_FILE_NAME", "keyword" },
			  { "TARGET_LINKER_FILE_DIR", "keyword" },
			  { "TARGET_SONAME_FILE", "keyword" },
			  { "TARGET_SONAME_FILE_NAME", "keyword" },
			  { "TARGET_SONAME_FILE_DIR", "keyword" },
			  { "TARGET_PDB_FILE", "keyword" },
			  { "TARGET_PDB_FILE_BASE_NAME", "keyword" },
			  { "TARGET_PDB_FILE_NAME", "keyword" },
			  { "TARGET_PDB_FILE_DIR", "keyword" },
			  { "TARGET_BUNDLE_DIR", "keyword" },
			  { "TARGET_BUNDLE_DIR_NAME", "keyword" },
			  { "TARGET_BUNDLE_CONTENT_DIR", "keyword" },
			  { "TARGET_RUNTIME_DLLS", "keyword" },
			  { "INSTALL_INTERFACE", "keyword" },
			  { "BUILD_INTERFACE", "keyword" },
			  { "INSTALL_PREFIX", "keyword" },
			  { "GENEX_EVAL", "keyword" },
			  { "TARGET_GENEX_EVAL", "keyword" },
			  { "ANGLE-R", "keyword" },
			  { "COMMA", "keyword" },
			  { "SEMICOLON", "keyword" },

			  { "EXISTS", "operator" },
			  { "COMMAND", "operator" },
			  { "DEFINED", "operator" },
			  { "EQUAL", "operator" },
			  { "LESS", "operator" },
			  { "LESS_EQUAL", "operator" },
			  { "GREATER", "operator" },
			  { "GREATER_EQUAL", "operator" },
			  { "STREQUAL", "operator" },
			  { "STRLESS", "operator" },
			  { "STRLESS_EQUAL", "operator" },
			  { "STRGREATER", "operator" },
			  { "STRGREATER_EQUAL", "operator" },
			  { "VERSION_EQUAL", "operator" },
			  { "VERSION_LESS", "operator" },
			  { "VERSION_LESS_EQUAL", "operator" },
			  { "VERSION_GREATER", "operator" },
			  { "VERSION_GREATER_EQUAL", "operator" },
			  { "PATH_EQUAL", "operator" },
			  { "MATCHES", "operator" },
			  { "NOT", "operator" },
			  { "AND", "operator" },
			  { "OR", "operator" },

			  { "block", "function" },
			  { "break", "function" },
			  { "cmake_host_system_information", "function" },
			  { "cmake_language", "function" },
			  { "cmake_minimum_required", "function" },
			  { "cmake_parse_arguments", "function" },
			  { "cmake_path", "function" },
			  { "cmake_policy", "function" },
			  { "configure_file", "function" },
			  { "continue", "function" },
			  { "else", "function" },
			  { "elseif", "function" },
			  { "endblock", "function" },
			  { "endforeach", "function" },
			  { "endfunction", "function" },
			  { "endif", "function" },
			  { "endmacro", "function" },
			  { "endwhile", "function" },
			  { "execute_process", "function" },
			  { "file", "function" },
			  { "find_file", "function" },
			  { "find_library", "function" },
			  { "find_package", "function" },
			  { "find_path", "function" },
			  { "find_program", "function" },
			  { "foreach", "function" },
			  { "function", "function" },
			  { "get_cmake_property", "function" },
			  { "get_directory_property", "function" },
			  { "get_filename_component", "function" },
			  { "get_property", "function" },
			  { "if", "function" },
			  { "include", "function" },
			  { "include_guard", "function" },
			  { "list", "function" },
			  { "macro", "function" },
			  { "mark_as_advanced", "function" },
			  { "math", "function" },
			  { "message", "function" },
			  { "option", "function" },
			  { "return", "function" },
			  { "separate_arguments", "function" },
			  { "set", "function" },
			  { "set_directory_properties", "function" },
			  { "set_property", "function" },
			  { "site_name", "function" },
			  { "string", "function" },
			  { "unset", "function" },
			  { "variable_watch", "function" },
			  { "while", "function" },
			  { "add_compile_definitions", "function" },
			  { "add_compile_options", "function" },
			  { "add_custom_command", "function" },
			  { "add_custom_target", "function" },
			  { "add_definitions", "function" },
			  { "add_dependencies", "function" },
			  { "add_executable", "function" },
			  { "add_library", "function" },
			  { "add_link_options", "function" },
			  { "add_subdirectory", "function" },
			  { "add_test", "function" },
			  { "aux_source_directory", "function" },
			  { "build_command", "function" },
			  { "create_test_sourcelist", "function" },
			  { "define_property", "function" },
			  { "enable_language", "function" },
			  { "enable_testing", "function" },
			  { "export", "function" },
			  { "fltk_wrap_ui", "function" },
			  { "get_source_file_property", "function" },
			  { "get_target_property", "function" },
			  { "get_test_property", "function" },
			  { "include_directories", "function" },
			  { "include_external_msproject", "function" },
			  { "include_regular_expression", "function" },
			  { "install", "function" },
			  { "link_directories", "function" },
			  { "link_libraries", "function" },
			  { "load_cache", "function" },
			  { "project", "function" },
			  { "remove_definitions", "function" },
			  { "set_source_files_properties", "function" },
			  { "set_target_properties", "function" },
			  { "set_tests_properties", "function" },
			  { "source_group", "function" },
			  { "target_compile_definitions", "function" },
			  { "target_compile_features", "function" },
			  { "target_compile_options", "function" },
			  { "target_include_directories", "function" },
			  { "target_link_directories", "function" },
			  { "target_link_libraries", "function" },
			  { "target_link_options", "function" },
			  { "target_precompile_headers", "function" },
			  { "target_sources", "function" },
			  { "try_compile", "function" },
			  { "try_run", "function" },
			  { "ctest_build", "function" },
			  { "ctest_configure", "function" },
			  { "ctest_coverage", "function" },
			  { "ctest_empty_binary_directory", "function" },
			  { "ctest_memcheck", "function" },
			  { "ctest_read_custom_files", "function" },
			  { "ctest_run_script", "function" },
			  { "ctest_sleep", "function" },
			  { "ctest_start", "function" },
			  { "ctest_submit", "function" },
			  { "ctest_test", "function" },
			  { "ctest_update", "function" },
			  { "ctest_upload", "function" },

			  { "on", "literal" },
			  { "yes", "literal" },
			  { "true", "literal" },
			  { "y", "literal" },
			  { "off", "literal" },
			  { "no", "literal" },
			  { "false", "literal" },
			  { "n", "literal" },
			  { "ignore", "literal" },
			  { "notfound", "literal" },

			  { "AndroidTestUtilities", "keyword" },
			  { "BundleUtilities", "keyword" },
			  { "CheckCCompilerFlag", "keyword" },
			  { "CheckCompilerFlag", "keyword" },
			  { "CheckCSourceCompiles", "keyword" },
			  { "CheckCSourceRuns", "keyword" },
			  { "CheckCXXCompilerFlag", "keyword" },
			  { "CheckCXXSourceCompiles", "keyword" },
			  { "CheckCXXSourceRuns", "keyword" },
			  { "CheckCXXSymbolExists", "keyword" },
			  { "CheckFortranCompilerFlag", "keyword" },
			  { "CheckFortranFunctionExists", "keyword" },
			  { "CheckFortranSourceCompiles", "keyword" },
			  { "CheckFortranSourceRuns", "keyword" },
			  { "CheckFunctionExists", "keyword" },
			  { "CheckIncludeFileCXX", "keyword" },
			  { "CheckIncludeFile", "keyword" },
			  { "CheckIncludeFiles", "keyword" },
			  { "CheckIPOSupported", "keyword" },
			  { "CheckLanguage", "keyword" },
			  { "CheckLibraryExists", "keyword" },
			  { "CheckLinkerFlag", "keyword" },
			  { "CheckOBJCCompilerFlag", "keyword" },
			  { "CheckOBJCSourceCompiles", "keyword" },
			  { "CheckOBJCSourceRuns", "keyword" },
			  { "CheckOBJCXXCompilerFlag", "keyword" },
			  { "CheckOBJCXXSourceCompiles", "keyword" },
			  { "CheckOBJCXXSourceRuns", "keyword" },
			  { "CheckPIESupported", "keyword" },
			  { "CheckPrototypeDefinition", "keyword" },
			  { "CheckSourceCompiles", "keyword" },
			  { "CheckSourceRuns", "keyword" },
			  { "CheckStructHasMember", "keyword" },
			  { "CheckSymbolExists", "keyword" },
			  { "CheckTypeSize", "keyword" },
			  { "CheckVariableExists", "keyword" },
			  { "CMakeAddFortranSubdirectory", "keyword" },
			  { "CMakeBackwardCompatibilityCXX", "keyword" },
			  { "CMakeDependentOption", "keyword" },
			  { "CMakeFindDependencyMacro", "keyword" },
			  { "CMakeFindFrameworks", "keyword" },
			  { "CMakeFindPackageMode", "keyword" },
			  { "CMakeGraphVizOptions", "keyword" },
			  { "CMakePackageConfigHelpers", "keyword" },
			  { "CMakePrintHelpers", "keyword" },
			  { "CMakePrintSystemInformation", "keyword" },
			  { "CMakePushCheckState", "keyword" },
			  { "CMakeVerifyManifest", "keyword" },
			  { "CPack", "keyword" },
			  { "CPackComponent", "keyword" },
			  { "CPackIFW", "keyword" },
			  { "CPackIFWConfigureFile", "keyword" },
			  { "CSharpUtilities", "keyword" },
			  { "CTest", "keyword" },
			  { "CTestCoverageCollectGCOV", "keyword" },
			  { "CTestScriptMode", "keyword" },
			  { "CTestUseLaunchers", "keyword" },
			  { "Dart", "keyword" },
			  { "DeployQt4", "keyword" },
			  { "ExternalData", "keyword" },
			  { "ExternalProject", "keyword" },
			  { "FeatureSummary", "keyword" },
			  { "FetchContent", "keyword" },
			  { "FindPackageHandleStandardArgs", "keyword" },
			  { "FindPackageMessage", "keyword" },
			  { "FortranCInterface", "keyword" },
			  { "GenerateExportHeader", "keyword" },
			  { "GetPrerequisites", "keyword" },
			  { "GNUInstallDirs", "keyword" },
			  { "GoogleTest", "keyword" },
			  { "InstallRequiredSystemLibraries", "keyword" },
			  { "ProcessorCount", "keyword" },
			  { "SelectLibraryConfigurations", "keyword" },
			  { "SquishTestScript", "keyword" },
			  { "TestBigEndian", "keyword" },
			  { "TestForANSIForScope", "keyword" },
			  { "TestForANSIStreamHeaders", "keyword" },
			  { "TestForSSTREAM", "keyword" },
			  { "TestForSTDNamespace", "keyword" },
			  { "UseEcos", "keyword" },
			  { "UseJava", "keyword" },
			  { "UseSWIG", "keyword" },
			  { "UsewxWidgets", "keyword" },

			  { "CMAKE_AR", "keyword2" },
			  { "CMAKE_ARGC", "keyword2" },
			  { "CMAKE_ARGV0", "keyword2" },
			  { "CMAKE_BINARY_DIR", "keyword2" },
			  { "CMAKE_BUILD_TOOL", "keyword2" },
			  { "CMAKE_CACHE_MAJOR_VERSION", "keyword2" },
			  { "CMAKE_CACHE_MINOR_VERSION", "keyword2" },
			  { "CMAKE_CACHE_PATCH_VERSION", "keyword2" },
			  { "CMAKE_CACHEFILE_DIR", "keyword2" },
			  { "CMAKE_CFG_INTDIR", "keyword2" },
			  { "CMAKE_COMMAND", "keyword2" },
			  { "CMAKE_CPACK_COMMAND", "keyword2" },
			  { "CMAKE_CROSSCOMPILING", "keyword2" },
			  { "CMAKE_CROSSCOMPILING_EMULATOR", "keyword2" },
			  { "CMAKE_CTEST_COMMAND", "keyword2" },
			  { "CMAKE_CURRENT_BINARY_DIR", "keyword2" },
			  { "CMAKE_CURRENT_FUNCTION", "keyword2" },
			  { "CMAKE_CURRENT_FUNCTION_LIST_DIR", "keyword2" },
			  { "CMAKE_CURRENT_FUNCTION_LIST_FILE", "keyword2" },
			  { "CMAKE_CURRENT_FUNCTION_LIST_LINE", "keyword2" },
			  { "CMAKE_CURRENT_LIST_DIR", "keyword2" },
			  { "CMAKE_CURRENT_LIST_FILE", "keyword2" },
			  { "CMAKE_CURRENT_LIST_LINE", "keyword2" },
			  { "CMAKE_CURRENT_SOURCE_DIR", "keyword2" },
			  { "CMAKE_DEBUG_TARGET_PROPERTIES", "keyword2" },
			  { "CMAKE_DIRECTORY_LABELS", "keyword2" },
			  { "CMAKE_DL_LIBS", "keyword2" },
			  { "CMAKE_DOTNET_SDK", "keyword2" },
			  { "CMAKE_DOTNET_TARGET_FRAMEWORK", "keyword2" },
			  { "CMAKE_DOTNET_TARGET_FRAMEWORK_VERSION", "keyword2" },
			  { "CMAKE_EDIT_COMMAND", "keyword2" },
			  { "CMAKE_EXECUTABLE_SUFFIX", "keyword2" },
			  { "CMAKE_EXTRA_GENERATOR", "keyword2" },
			  { "CMAKE_EXTRA_SHARED_LIBRARY_SUFFIXES", "keyword2" },
			  { "CMAKE_FIND_DEBUG_MODE", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_NAME", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_REDIRECTS_DIR", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_SORT_DIRECTION", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_SORT_ORDER", "keyword2" },
			  { "CMAKE_GENERATOR", "keyword2" },
			  { "CMAKE_GENERATOR_INSTANCE", "keyword2" },
			  { "CMAKE_GENERATOR_PLATFORM", "keyword2" },
			  { "CMAKE_GENERATOR_TOOLSET", "keyword2" },
			  { "CMAKE_IMPORT_LIBRARY_PREFIX", "keyword2" },
			  { "CMAKE_IMPORT_LIBRARY_SUFFIX", "keyword2" },
			  { "CMAKE_JOB_POOL_COMPILE", "keyword2" },
			  { "CMAKE_JOB_POOL_LINK", "keyword2" },
			  { "CMAKE_JOB_POOL_PRECOMPILE_HEADER", "keyword2" },
			  { "CMAKE_JOB_POOLS", "keyword2" },
			  { "CMAKE_LINK_LIBRARY_SUFFIX", "keyword2" },
			  { "CMAKE_LINK_SEARCH_END_STATIC", "keyword2" },
			  { "CMAKE_LINK_SEARCH_START_STATIC", "keyword2" },
			  { "CMAKE_MAJOR_VERSION", "keyword2" },
			  { "CMAKE_MAKE_PROGRAM", "keyword2" },
			  { "CMAKE_MATCH_COUNT", "keyword2" },
			  { "CMAKE_MINIMUM_REQUIRED_VERSION", "keyword2" },
			  { "CMAKE_MINOR_VERSION", "keyword2" },
			  { "CMAKE_NETRC", "keyword2" },
			  { "CMAKE_NETRC_FILE", "keyword2" },
			  { "CMAKE_PARENT_LIST_FILE", "keyword2" },
			  { "CMAKE_PATCH_VERSION", "keyword2" },
			  { "CMAKE_PROJECT_DESCRIPTION", "keyword2" },
			  { "CMAKE_PROJECT_HOMEPAGE_URL", "keyword2" },
			  { "CMAKE_PROJECT_NAME", "keyword2" },
			  { "CMAKE_PROJECT_VERSION", "keyword2" },
			  { "CMAKE_PROJECT_VERSION_MAJOR", "keyword2" },
			  { "CMAKE_PROJECT_VERSION_MINOR", "keyword2" },
			  { "CMAKE_PROJECT_VERSION_PATCH", "keyword2" },
			  { "CMAKE_PROJECT_VERSION_TWEAK", "keyword2" },
			  { "CMAKE_RANLIB", "keyword2" },
			  { "CMAKE_ROOT", "keyword2" },
			  { "CMAKE_RULE_MESSAGES", "keyword2" },
			  { "CMAKE_SCRIPT_MODE_FILE", "keyword2" },
			  { "CMAKE_SHARED_LIBRARY_PREFIX", "keyword2" },
			  { "CMAKE_SHARED_LIBRARY_SUFFIX", "keyword2" },
			  { "CMAKE_SHARED_MODULE_PREFIX", "keyword2" },
			  { "CMAKE_SHARED_MODULE_SUFFIX", "keyword2" },
			  { "CMAKE_SIZEOF_VOID_P", "keyword2" },
			  { "CMAKE_SKIP_INSTALL_RULES", "keyword2" },
			  { "CMAKE_SKIP_RPATH", "keyword2" },
			  { "CMAKE_SOURCE_DIR", "keyword2" },
			  { "CMAKE_STATIC_LIBRARY_PREFIX", "keyword2" },
			  { "CMAKE_STATIC_LIBRARY_SUFFIX", "keyword2" },
			  { "CMAKE_Swift_MODULE_DIRECTORY", "keyword2" },
			  { "CMAKE_Swift_NUM_THREADS", "keyword2" },
			  { "CMAKE_TOOLCHAIN_FILE", "keyword2" },
			  { "CMAKE_TWEAK_VERSION", "keyword2" },
			  { "CMAKE_VERBOSE_MAKEFILE", "keyword2" },
			  { "CMAKE_VERSION", "keyword2" },
			  { "CMAKE_VS_DEVENV_COMMAND", "keyword2" },
			  { "CMAKE_VS_MSBUILD_COMMAND", "keyword2" },
			  { "CMAKE_VS_NsightTegra_VERSION", "keyword2" },
			  { "CMAKE_VS_NUGET_PACKAGE_RESTORE", "keyword2" },
			  { "CMAKE_VS_PLATFORM_NAME", "keyword2" },
			  { "CMAKE_VS_PLATFORM_NAME_DEFAULT", "keyword2" },
			  { "CMAKE_VS_PLATFORM_TOOLSET", "keyword2" },
			  { "CMAKE_VS_PLATFORM_TOOLSET_CUDA", "keyword2" },
			  { "CMAKE_VS_PLATFORM_TOOLSET_CUDA_CUSTOM_DIR", "keyword2" },
			  { "CMAKE_VS_PLATFORM_TOOLSET_HOST_ARCHITECTURE", "keyword2" },
			  { "CMAKE_VS_PLATFORM_TOOLSET_VERSION", "keyword2" },
			  { "CMAKE_VS_TARGET_FRAMEWORK_IDENTIFIER", "keyword2" },
			  { "CMAKE_VS_TARGET_FRAMEWORK_TARGETS_VERSION", "keyword2" },
			  { "CMAKE_VS_TARGET_FRAMEWORK_VERSION", "keyword2" },
			  { "CMAKE_VS_WINDOWS_TARGET_PLATFORM_VERSION", "keyword2" },
			  { "CMAKE_VS_WINDOWS_TARGET_PLATFORM_VERSION_MAXIMUM", "keyword2" },
			  { "CMAKE_XCODE_BUILD_SYSTEM", "keyword2" },
			  { "CMAKE_XCODE_PLATFORM_TOOLSET", "keyword2" },
			  { "PROJECT_BINARY_DIR", "keyword2" },
			  { "PROJECT_DESCRIPTION", "keyword2" },
			  { "PROJECT_HOMEPAGE_URL", "keyword2" },
			  { "PROJECT_IS_TOP_LEVEL", "keyword2" },
			  { "PROJECT_NAME", "keyword2" },
			  { "PROJECT_SOURCE_DIR", "keyword2" },
			  { "PROJECT_VERSION", "keyword2" },
			  { "PROJECT_VERSION_MAJOR", "keyword2" },
			  { "PROJECT_VERSION_MINOR", "keyword2" },
			  { "PROJECT_VERSION_PATCH", "keyword2" },
			  { "PROJECT_VERSION_TWEAK", "keyword2" },
			  { "BUILD_SHARED_LIBS", "keyword2" },
			  { "BUILD_STATIC_LIBS", "keyword2" },
			  { "CMAKE_ABSOLUTE_DESTINATION_FILES", "keyword2" },
			  { "CMAKE_APPBUNDLE_PATH", "keyword2" },
			  { "CMAKE_AUTOMOC_RELAXED_MODE", "keyword2" },
			  { "CMAKE_BACKWARDS_COMPATIBILITY", "keyword2" },
			  { "CMAKE_BUILD_TYPE", "keyword2" },
			  { "CMAKE_CLANG_VFS_OVERLAY", "keyword2" },
			  { "CMAKE_CODEBLOCKS_COMPILER_ID", "keyword2" },
			  { "CMAKE_CODEBLOCKS_EXCLUDE_EXTERNAL_FILES", "keyword2" },
			  { "CMAKE_CODELITE_USE_TARGETS", "keyword2" },
			  { "CMAKE_COLOR_DIAGNOSTICS", "keyword2" },
			  { "CMAKE_COLOR_MAKEFILE", "keyword2" },
			  { "CMAKE_CONFIGURATION_TYPES", "keyword2" },
			  { "CMAKE_DEPENDS_IN_PROJECT_ONLY", "keyword2" },
			  { "CMAKE_ECLIPSE_GENERATE_LINKED_RESOURCES", "keyword2" },
			  { "CMAKE_ECLIPSE_GENERATE_SOURCE_PROJECT", "keyword2" },
			  { "CMAKE_ECLIPSE_MAKE_ARGUMENTS", "keyword2" },
			  { "CMAKE_ECLIPSE_RESOURCE_ENCODING", "keyword2" },
			  { "CMAKE_ECLIPSE_VERSION", "keyword2" },
			  { "CMAKE_ERROR_DEPRECATED", "keyword2" },
			  { "CMAKE_ERROR_ON_ABSOLUTE_INSTALL_DESTINATION", "keyword2" },
			  { "CMAKE_EXECUTE_PROCESS_COMMAND_ECHO", "keyword2" },
			  { "CMAKE_EXPORT_COMPILE_COMMANDS", "keyword2" },
			  { "CMAKE_EXPORT_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_EXPORT_NO_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_FIND_APPBUNDLE", "keyword2" },
			  { "CMAKE_FIND_FRAMEWORK", "keyword2" },
			  { "CMAKE_FIND_LIBRARY_CUSTOM_LIB_SUFFIX", "keyword2" },
			  { "CMAKE_FIND_LIBRARY_PREFIXES", "keyword2" },
			  { "CMAKE_FIND_LIBRARY_SUFFIXES", "keyword2" },
			  { "CMAKE_FIND_NO_INSTALL_PREFIX", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_NO_SYSTEM_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_PREFER_CONFIG", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_RESOLVE_SYMLINKS", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_TARGETS_GLOBAL", "keyword2" },
			  { "CMAKE_FIND_PACKAGE_WARN_NO_MODULE", "keyword2" },
			  { "CMAKE_FIND_ROOT_PATH", "keyword2" },
			  { "CMAKE_FIND_ROOT_PATH_MODE_INCLUDE", "keyword2" },
			  { "CMAKE_FIND_ROOT_PATH_MODE_LIBRARY", "keyword2" },
			  { "CMAKE_FIND_ROOT_PATH_MODE_PACKAGE", "keyword2" },
			  { "CMAKE_FIND_ROOT_PATH_MODE_PROGRAM", "keyword2" },
			  { "CMAKE_FIND_USE_CMAKE_ENVIRONMENT_PATH", "keyword2" },
			  { "CMAKE_FIND_USE_CMAKE_PATH", "keyword2" },
			  { "CMAKE_FIND_USE_CMAKE_SYSTEM_PATH", "keyword2" },
			  { "CMAKE_FIND_USE_INSTALL_PREFIX", "keyword2" },
			  { "CMAKE_FIND_USE_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_FIND_USE_PACKAGE_ROOT_PATH", "keyword2" },
			  { "CMAKE_FIND_USE_SYSTEM_ENVIRONMENT_PATH", "keyword2" },
			  { "CMAKE_FIND_USE_SYSTEM_PACKAGE_REGISTRY", "keyword2" },
			  { "CMAKE_FRAMEWORK_PATH", "keyword2" },
			  { "CMAKE_IGNORE_PATH", "keyword2" },
			  { "CMAKE_IGNORE_PREFIX_PATH", "keyword2" },
			  { "CMAKE_INCLUDE_DIRECTORIES_BEFORE", "keyword2" },
			  { "CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE", "keyword2" },
			  { "CMAKE_INCLUDE_PATH", "keyword2" },
			  { "CMAKE_INSTALL_DEFAULT_COMPONENT_NAME", "keyword2" },
			  { "CMAKE_INSTALL_DEFAULT_DIRECTORY_PERMISSIONS", "keyword2" },
			  { "CMAKE_INSTALL_MESSAGE", "keyword2" },
			  { "CMAKE_INSTALL_PREFIX", "keyword2" },
			  { "CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT", "keyword2" },
			  { "CMAKE_LIBRARY_PATH", "keyword2" },
			  { "CMAKE_LINK_DIRECTORIES_BEFORE", "keyword2" },
			  { "CMAKE_LINK_LIBRARIES_ONLY_TARGETS", "keyword2" },
			  { "CMAKE_MAXIMUM_RECURSION_DEPTH", "keyword2" },
			  { "CMAKE_MESSAGE_CONTEXT", "keyword2" },
			  { "CMAKE_MESSAGE_CONTEXT_SHOW", "keyword2" },
			  { "CMAKE_MESSAGE_INDENT", "keyword2" },
			  { "CMAKE_MESSAGE_LOG_LEVEL", "keyword2" },
			  { "CMAKE_MFC_FLAG", "keyword2" },
			  { "CMAKE_MODULE_PATH", "keyword2" },
			  { "CMAKE_PREFIX_PATH", "keyword2" },
			  { "CMAKE_PROGRAM_PATH", "keyword2" },
			  { "CMAKE_PROJECT_INCLUDE", "keyword2" },
			  { "CMAKE_PROJECT_INCLUDE_BEFORE", "keyword2" },
			  { "CMAKE_PROJECT_TOP_LEVEL_INCLUDES", "keyword2" },
			  { "CMAKE_SKIP_INSTALL_ALL_DEPENDENCY", "keyword2" },
			  { "CMAKE_STAGING_PREFIX", "keyword2" },
			  { "CMAKE_SUBLIME_TEXT_2_ENV_SETTINGS", "keyword2" },
			  { "CMAKE_SUBLIME_TEXT_2_EXCLUDE_BUILD_TREE", "keyword2" },
			  { "CMAKE_SUPPRESS_REGENERATION", "keyword2" },
			  { "CMAKE_SYSROOT", "keyword2" },
			  { "CMAKE_SYSROOT_COMPILE", "keyword2" },
			  { "CMAKE_SYSROOT_LINK", "keyword2" },
			  { "CMAKE_SYSTEM_APPBUNDLE_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_FRAMEWORK_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_IGNORE_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_IGNORE_PREFIX_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_INCLUDE_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_LIBRARY_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_PREFIX_PATH", "keyword2" },
			  { "CMAKE_SYSTEM_PROGRAM_PATH", "keyword2" },
			  { "CMAKE_TLS_CAINFO", "keyword2" },
			  { "CMAKE_TLS_VERIFY", "keyword2" },
			  { "CMAKE_USER_MAKE_RULES_OVERRIDE", "keyword2" },
			  { "CMAKE_WARN_DEPRECATED", "keyword2" },
			  { "CMAKE_WARN_ON_ABSOLUTE_INSTALL_DESTINATION", "keyword2" },
			  { "CMAKE_XCODE_GENERATE_SCHEME", "keyword2" },
			  { "CMAKE_XCODE_GENERATE_TOP_LEVEL_PROJECT_ONLY", "keyword2" },
			  { "CMAKE_XCODE_LINK_BUILD_PHASE_MODE", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ADDRESS_SANITIZER", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ADDRESS_SANITIZER_USE_AFTER_RETURN", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_DEBUG_DOCUMENT_VERSIONING", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_DISABLE_MAIN_THREAD_CHECKER", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_DYNAMIC_LIBRARY_LOADS", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_DYNAMIC_LINKER_API_USAGE", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ENABLE_GPU_API_VALIDATION", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ENABLE_GPU_FRAME_CAPTURE_MODE", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ENABLE_GPU_SHADER_VALIDATION", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ENVIRONMENT", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_GUARD_MALLOC", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_LAUNCH_CONFIGURATION", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_LAUNCH_MODE", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_MAIN_THREAD_CHECKER_STOP", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_MALLOC_GUARD_EDGES", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_MALLOC_SCRIBBLE", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_MALLOC_STACK", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_THREAD_SANITIZER", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_THREAD_SANITIZER_STOP", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_UNDEFINED_BEHAVIOUR_SANITIZER", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_UNDEFINED_BEHAVIOUR_SANITIZER_STOP", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_WORKING_DIRECTORY", "keyword2" },
			  { "CMAKE_XCODE_SCHEME_ZOMBIE_OBJECTS", "keyword2" },
			  { "CMAKE_XCODE_XCCONFIG", "keyword2" },
			  { "ANDROID", "keyword2" },
			  { "APPLE", "keyword2" },
			  { "BORLAND", "keyword2" },
			  { "BSD", "keyword2" },
			  { "CMAKE_ANDROID_NDK_VERSION", "keyword2" },
			  { "CMAKE_CL_64", "keyword2" },
			  { "CMAKE_COMPILER_2005", "keyword2" },
			  { "CMAKE_HOST_APPLE", "keyword2" },
			  { "CMAKE_HOST_BSD", "keyword2" },
			  { "CMAKE_HOST_LINUX", "keyword2" },
			  { "CMAKE_HOST_SOLARIS", "keyword2" },
			  { "CMAKE_HOST_SYSTEM", "keyword2" },
			  { "CMAKE_HOST_SYSTEM_NAME", "keyword2" },
			  { "CMAKE_HOST_SYSTEM_PROCESSOR", "keyword2" },
			  { "CMAKE_HOST_SYSTEM_VERSION", "keyword2" },
			  { "CMAKE_HOST_UNIX", "keyword2" },
			  { "CMAKE_HOST_WIN32", "keyword2" },
			  { "CMAKE_LIBRARY_ARCHITECTURE", "keyword2" },
			  { "CMAKE_LIBRARY_ARCHITECTURE_REGEX", "keyword2" },
			  { "CMAKE_OBJECT_PATH_MAX", "keyword2" },
			  { "CMAKE_SYSTEM", "keyword2" },
			  { "CMAKE_SYSTEM_NAME", "keyword2" },
			  { "CMAKE_SYSTEM_PROCESSOR", "keyword2" },
			  { "CMAKE_SYSTEM_VERSION", "keyword2" },
			  { "CYGWIN", "keyword2" },
			  { "GHSMULTI", "keyword2" },
			  { "IOS", "keyword2" },
			  { "LINUX", "keyword2" },
			  { "MINGW", "keyword2" },
			  { "MSVC", "keyword2" },
			  { "MSVC10", "keyword2" },
			  { "MSVC11", "keyword2" },
			  { "MSVC12", "keyword2" },
			  { "MSVC14", "keyword2" },
			  { "MSVC60", "keyword2" },
			  { "MSVC70", "keyword2" },
			  { "MSVC71", "keyword2" },
			  { "MSVC80", "keyword2" },
			  { "MSVC90", "keyword2" },
			  { "MSVC_IDE", "keyword2" },
			  { "MSVC_TOOLSET_VERSION", "keyword2" },
			  { "MSVC_VERSION", "keyword2" },
			  { "MSYS", "keyword2" },
			  { "UNIX", "keyword2" },
			  { "WIN32", "keyword2" },
			  { "WINCE", "keyword2" },
			  { "WINDOWS_PHONE", "keyword2" },
			  { "WINDOWS_STORE", "keyword2" },
			  { "XCODE", "keyword2" },
			  { "XCODE_VERSION", "keyword2" },
			  { "CMAKE_ADSP_ROOT", "keyword2" },
			  { "CMAKE_AIX_EXPORT_ALL_SYMBOLS", "keyword2" },
			  { "CMAKE_ANDROID_ANT_ADDITIONAL_OPTIONS", "keyword2" },
			  { "CMAKE_ANDROID_API", "keyword2" },
			  { "CMAKE_ANDROID_API_MIN", "keyword2" },
			  { "CMAKE_ANDROID_ARCH", "keyword2" },
			  { "CMAKE_ANDROID_ARCH_ABI", "keyword2" },
			  { "CMAKE_ANDROID_ARM_MODE", "keyword2" },
			  { "CMAKE_ANDROID_ARM_NEON", "keyword2" },
			  { "CMAKE_ANDROID_ASSETS_DIRECTORIES", "keyword2" },
			  { "CMAKE_ANDROID_EXCEPTIONS", "keyword2" },
			  { "CMAKE_ANDROID_GUI", "keyword2" },
			  { "CMAKE_ANDROID_JAR_DEPENDENCIES", "keyword2" },
			  { "CMAKE_ANDROID_JAR_DIRECTORIES", "keyword2" },
			  { "CMAKE_ANDROID_JAVA_SOURCE_DIR", "keyword2" },
			  { "CMAKE_ANDROID_NATIVE_LIB_DEPENDENCIES", "keyword2" },
			  { "CMAKE_ANDROID_NATIVE_LIB_DIRECTORIES", "keyword2" },
			  { "CMAKE_ANDROID_NDK", "keyword2" },
			  { "CMAKE_ANDROID_NDK_DEPRECATED_HEADERS", "keyword2" },
			  { "CMAKE_ANDROID_NDK_TOOLCHAIN_HOST_TAG", "keyword2" },
			  { "CMAKE_ANDROID_NDK_TOOLCHAIN_VERSION", "keyword2" },
			  { "CMAKE_ANDROID_PROCESS_MAX", "keyword2" },
			  { "CMAKE_ANDROID_PROGUARD", "keyword2" },
			  { "CMAKE_ANDROID_PROGUARD_CONFIG_PATH", "keyword2" },
			  { "CMAKE_ANDROID_RTTI", "keyword2" },
			  { "CMAKE_ANDROID_SECURE_PROPS_PATH", "keyword2" },
			  { "CMAKE_ANDROID_SKIP_ANT_STEP", "keyword2" },
			  { "CMAKE_ANDROID_STANDALONE_TOOLCHAIN", "keyword2" },
			  { "CMAKE_ANDROID_STL_TYPE", "keyword2" },
			  { "CMAKE_APPLE_SILICON_PROCESSOR", "keyword2" },
			  { "CMAKE_ARCHIVE_OUTPUT_DIRECTORY", "keyword2" },
			  { "CMAKE_AUTOGEN_ORIGIN_DEPENDS", "keyword2" },
			  { "CMAKE_AUTOGEN_PARALLEL", "keyword2" },
			  { "CMAKE_AUTOGEN_VERBOSE", "keyword2" },
			  { "CMAKE_AUTOMOC", "keyword2" },
			  { "CMAKE_AUTOMOC_COMPILER_PREDEFINES", "keyword2" },
			  { "CMAKE_AUTOMOC_DEPEND_FILTERS", "keyword2" },
			  { "CMAKE_AUTOMOC_MACRO_NAMES", "keyword2" },
			  { "CMAKE_AUTOMOC_MOC_OPTIONS", "keyword2" },
			  { "CMAKE_AUTOMOC_PATH_PREFIX", "keyword2" },
			  { "CMAKE_AUTORCC", "keyword2" },
			  { "CMAKE_AUTORCC_OPTIONS", "keyword2" },
			  { "CMAKE_AUTOUIC", "keyword2" },
			  { "CMAKE_AUTOUIC_OPTIONS", "keyword2" },
			  { "CMAKE_AUTOUIC_SEARCH_PATHS", "keyword2" },
			  { "CMAKE_BUILD_RPATH", "keyword2" },
			  { "CMAKE_BUILD_RPATH_USE_ORIGIN", "keyword2" },
			  { "CMAKE_BUILD_WITH_INSTALL_NAME_DIR", "keyword2" },
			  { "CMAKE_BUILD_WITH_INSTALL_RPATH", "keyword2" },
			  { "CMAKE_COMPILE_PDB_OUTPUT_DIRECTORY", "keyword2" },
			  { "CMAKE_COMPILE_WARNING_AS_ERROR", "keyword2" },
			  { "CMAKE_CROSS_CONFIGS", "keyword2" },
			  { "CMAKE_CTEST_ARGUMENTS", "keyword2" },
			  { "CMAKE_CUDA_RESOLVE_DEVICE_SYMBOLS", "keyword2" },
			  { "CMAKE_CUDA_RUNTIME_LIBRARY", "keyword2" },
			  { "CMAKE_CUDA_SEPARABLE_COMPILATION", "keyword2" },
			  { "CMAKE_DEBUG_POSTFIX", "keyword2" },
			  { "CMAKE_DEFAULT_BUILD_TYPE", "keyword2" },
			  { "CMAKE_DEFAULT_CONFIGS", "keyword2" },
			  { "CMAKE_DEPENDS_USE_COMPILER", "keyword2" },
			  { "CMAKE_DISABLE_PRECOMPILE_HEADERS", "keyword2" },
			  { "CMAKE_ENABLE_EXPORTS", "keyword2" },
			  { "CMAKE_EXE_LINKER_FLAGS", "keyword2" },
			  { "CMAKE_EXE_LINKER_FLAGS_INIT", "keyword2" },
			  { "CMAKE_FOLDER", "keyword2" },
			  { "CMAKE_Fortran_FORMAT", "keyword2" },
			  { "CMAKE_Fortran_MODULE_DIRECTORY", "keyword2" },
			  { "CMAKE_Fortran_PREPROCESS", "keyword2" },
			  { "CMAKE_FRAMEWORK", "keyword2" },
			  { "CMAKE_GHS_NO_SOURCE_GROUP_FILE", "keyword2" },
			  { "CMAKE_GLOBAL_AUTOGEN_TARGET", "keyword2" },
			  { "CMAKE_GLOBAL_AUTOGEN_TARGET_NAME", "keyword2" },
			  { "CMAKE_GLOBAL_AUTORCC_TARGET", "keyword2" },
			  { "CMAKE_GLOBAL_AUTORCC_TARGET_NAME", "keyword2" },
			  { "CMAKE_GNUtoMS", "keyword2" },
			  { "CMAKE_INCLUDE_CURRENT_DIR", "keyword2" },
			  { "CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE", "keyword2" },
			  { "CMAKE_INSTALL_NAME_DIR", "keyword2" },
			  { "CMAKE_INSTALL_REMOVE_ENVIRONMENT_RPATH", "keyword2" },
			  { "CMAKE_INSTALL_RPATH", "keyword2" },
			  { "CMAKE_INSTALL_RPATH_USE_LINK_PATH", "keyword2" },
			  { "CMAKE_INTERPROCEDURAL_OPTIMIZATION", "keyword2" },
			  { "CMAKE_IOS_INSTALL_COMBINED", "keyword2" },
			  { "CMAKE_LIBRARY_OUTPUT_DIRECTORY", "keyword2" },
			  { "CMAKE_LIBRARY_PATH_FLAG", "keyword2" },
			  { "CMAKE_LINK_DEF_FILE_FLAG", "keyword2" },
			  { "CMAKE_LINK_DEPENDS_NO_SHARED", "keyword2" },
			  { "CMAKE_LINK_INTERFACE_LIBRARIES", "keyword2" },
			  { "CMAKE_LINK_LIBRARY_FILE_FLAG", "keyword2" },
			  { "CMAKE_LINK_LIBRARY_FLAG", "keyword2" },
			  { "CMAKE_LINK_WHAT_YOU_USE", "keyword2" },
			  { "CMAKE_LINK_WHAT_YOU_USE_CHECK", "keyword2" },
			  { "CMAKE_MACOSX_BUNDLE", "keyword2" },
			  { "CMAKE_MACOSX_RPATH", "keyword2" },
			  { "CMAKE_MODULE_LINKER_FLAGS", "keyword2" },
			  { "CMAKE_MODULE_LINKER_FLAGS_INIT", "keyword2" },
			  { "CMAKE_MSVC_DEBUG_INFORMATION_FORMAT", "keyword2" },
			  { "CMAKE_MSVC_RUNTIME_LIBRARY", "keyword2" },
			  { "CMAKE_MSVCIDE_RUN_PATH", "keyword2" },
			  { "CMAKE_NINJA_OUTPUT_PATH_PREFIX", "keyword2" },
			  { "CMAKE_NO_BUILTIN_CHRPATH", "keyword2" },
			  { "CMAKE_NO_SYSTEM_FROM_IMPORTED", "keyword2" },
			  { "CMAKE_OPTIMIZE_DEPENDENCIES", "keyword2" },
			  { "CMAKE_OSX_ARCHITECTURES", "keyword2" },
			  { "CMAKE_OSX_DEPLOYMENT_TARGET", "keyword2" },
			  { "CMAKE_OSX_SYSROOT", "keyword2" },
			  { "CMAKE_PCH_INSTANTIATE_TEMPLATES", "keyword2" },
			  { "CMAKE_PCH_WARN_INVALID", "keyword2" },
			  { "CMAKE_PDB_OUTPUT_DIRECTORY", "keyword2" },
			  { "CMAKE_PLATFORM_NO_VERSIONED_SONAME", "keyword2" },
			  { "CMAKE_POSITION_INDEPENDENT_CODE", "keyword2" },
			  { "CMAKE_RUNTIME_OUTPUT_DIRECTORY", "keyword2" },
			  { "CMAKE_SHARED_LINKER_FLAGS", "keyword2" },
			  { "CMAKE_SHARED_LINKER_FLAGS_INIT", "keyword2" },
			  { "CMAKE_SKIP_BUILD_RPATH", "keyword2" },
			  { "CMAKE_SKIP_INSTALL_RPATH", "keyword2" },
			  { "CMAKE_STATIC_LINKER_FLAGS", "keyword2" },
			  { "CMAKE_STATIC_LINKER_FLAGS_INIT", "keyword2" },
			  { "CMAKE_TASKING_TOOLSET", "keyword2" },
			  { "CMAKE_TRY_COMPILE_CONFIGURATION", "keyword2" },
			  { "CMAKE_TRY_COMPILE_NO_PLATFORM_VARIABLES", "keyword2" },
			  { "CMAKE_TRY_COMPILE_PLATFORM_VARIABLES", "keyword2" },
			  { "CMAKE_TRY_COMPILE_TARGET_TYPE", "keyword2" },
			  { "CMAKE_UNITY_BUILD", "keyword2" },
			  { "CMAKE_UNITY_BUILD_BATCH_SIZE", "keyword2" },
			  { "CMAKE_UNITY_BUILD_UNIQUE_ID", "keyword2" },
			  { "CMAKE_USE_RELATIVE_PATHS", "keyword2" },
			  { "CMAKE_VERIFY_INTERFACE_HEADER_SETS", "keyword2" },
			  { "CMAKE_VISIBILITY_INLINES_HIDDEN", "keyword2" },
			  { "CMAKE_VS_GLOBALS", "keyword2" },
			  { "CMAKE_VS_INCLUDE_INSTALL_TO_DEFAULT_BUILD", "keyword2" },
			  { "CMAKE_VS_INCLUDE_PACKAGE_TO_DEFAULT_BUILD", "keyword2" },
			  { "CMAKE_VS_JUST_MY_CODE_DEBUGGING", "keyword2" },
			  { "CMAKE_VS_NO_COMPILE_BATCHING", "keyword2" },
			  { "CMAKE_VS_SDK_EXCLUDE_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_EXECUTABLE_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_INCLUDE_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_LIBRARY_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_LIBRARY_WINRT_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_REFERENCE_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_SDK_SOURCE_DIRECTORIES", "keyword2" },
			  { "CMAKE_VS_WINRT_BY_DEFAULT", "keyword2" },
			  { "CMAKE_WATCOM_RUNTIME_LIBRARY", "keyword2" },
			  { "CMAKE_WIN32_EXECUTABLE", "keyword2" },
			  { "CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS", "keyword2" },
			  { "EXECUTABLE_OUTPUT_PATH", "keyword2" },
			  { "LIBRARY_OUTPUT_PATH", "keyword2" },
			  { "CMAKE_C_COMPILE_FEATURES", "keyword2" },
			  { "CMAKE_C_EXTENSIONS", "keyword2" },
			  { "CMAKE_C_STANDARD", "keyword2" },
			  { "CMAKE_C_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_COMPILER_IS_GNUCC", "keyword2" },
			  { "CMAKE_COMPILER_IS_GNUCXX", "keyword2" },
			  { "CMAKE_COMPILER_IS_GNUG77", "keyword2" },
			  { "CMAKE_CUDA_ARCHITECTURES", "keyword2" },
			  { "CMAKE_CUDA_COMPILE_FEATURES", "keyword2" },
			  { "CMAKE_CUDA_EXTENSIONS", "keyword2" },
			  { "CMAKE_CUDA_HOST_COMPILER", "keyword2" },
			  { "CMAKE_CUDA_STANDARD", "keyword2" },
			  { "CMAKE_CUDA_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES", "keyword2" },
			  { "CMAKE_CXX_COMPILE_FEATURES", "keyword2" },
			  { "CMAKE_CXX_EXTENSIONS", "keyword2" },
			  { "CMAKE_CXX_STANDARD", "keyword2" },
			  { "CMAKE_CXX_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_Fortran_MODDIR_DEFAULT", "keyword2" },
			  { "CMAKE_Fortran_MODDIR_FLAG", "keyword2" },
			  { "CMAKE_Fortran_MODOUT_FLAG", "keyword2" },
			  { "CMAKE_HIP_ARCHITECTURES", "keyword2" },
			  { "CMAKE_HIP_EXTENSIONS", "keyword2" },
			  { "CMAKE_HIP_STANDARD", "keyword2" },
			  { "CMAKE_HIP_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_ISPC_HEADER_DIRECTORY", "keyword2" },
			  { "CMAKE_ISPC_HEADER_SUFFIX", "keyword2" },
			  { "CMAKE_ISPC_INSTRUCTION_SETS", "keyword2" },
			  { "CMAKE_OBJC_EXTENSIONS", "keyword2" },
			  { "CMAKE_OBJC_STANDARD", "keyword2" },
			  { "CMAKE_OBJC_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_OBJCXX_EXTENSIONS", "keyword2" },
			  { "CMAKE_OBJCXX_STANDARD", "keyword2" },
			  { "CMAKE_OBJCXX_STANDARD_REQUIRED", "keyword2" },
			  { "CMAKE_Swift_LANGUAGE_VERSION", "keyword2" },
			  { "CTEST_BINARY_DIRECTORY", "keyword2" },
			  { "CTEST_BUILD_COMMAND", "keyword2" },
			  { "CTEST_BUILD_NAME", "keyword2" },
			  { "CTEST_BZR_COMMAND", "keyword2" },
			  { "CTEST_BZR_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_CHANGE_ID", "keyword2" },
			  { "CTEST_CHECKOUT_COMMAND", "keyword2" },
			  { "CTEST_CONFIGURATION_TYPE", "keyword2" },
			  { "CTEST_CONFIGURE_COMMAND", "keyword2" },
			  { "CTEST_COVERAGE_COMMAND", "keyword2" },
			  { "CTEST_COVERAGE_EXTRA_FLAGS", "keyword2" },
			  { "CTEST_CURL_OPTIONS", "keyword2" },
			  { "CTEST_CUSTOM_COVERAGE_EXCLUDE", "keyword2" },
			  { "CTEST_CUSTOM_ERROR_EXCEPTION", "keyword2" },
			  { "CTEST_CUSTOM_ERROR_MATCH", "keyword2" },
			  { "CTEST_CUSTOM_ERROR_POST_CONTEXT", "keyword2" },
			  { "CTEST_CUSTOM_ERROR_PRE_CONTEXT", "keyword2" },
			  { "CTEST_CUSTOM_MAXIMUM_FAILED_TEST_OUTPUT_SIZE", "keyword2" },
			  { "CTEST_CUSTOM_MAXIMUM_NUMBER_OF_ERRORS", "keyword2" },
			  { "CTEST_CUSTOM_MAXIMUM_NUMBER_OF_WARNINGS", "keyword2" },
			  { "CTEST_CUSTOM_MAXIMUM_PASSED_TEST_OUTPUT_SIZE", "keyword2" },
			  { "CTEST_CUSTOM_MEMCHECK_IGNORE", "keyword2" },
			  { "CTEST_CUSTOM_POST_MEMCHECK", "keyword2" },
			  { "CTEST_CUSTOM_POST_TEST", "keyword2" },
			  { "CTEST_CUSTOM_PRE_MEMCHECK", "keyword2" },
			  { "CTEST_CUSTOM_PRE_TEST", "keyword2" },
			  { "CTEST_CUSTOM_TEST_OUTPUT_TRUNCATION", "keyword2" },
			  { "CTEST_CUSTOM_TESTS_IGNORE", "keyword2" },
			  { "CTEST_CUSTOM_WARNING_EXCEPTION", "keyword2" },
			  { "CTEST_CUSTOM_WARNING_MATCH", "keyword2" },
			  { "CTEST_CVS_CHECKOUT", "keyword2" },
			  { "CTEST_CVS_COMMAND", "keyword2" },
			  { "CTEST_CVS_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_DROP_LOCATION", "keyword2" },
			  { "CTEST_DROP_METHOD", "keyword2" },
			  { "CTEST_DROP_SITE", "keyword2" },
			  { "CTEST_DROP_SITE_CDASH", "keyword2" },
			  { "CTEST_DROP_SITE_PASSWORD", "keyword2" },
			  { "CTEST_DROP_SITE_USER", "keyword2" },
			  { "CTEST_EXTRA_COVERAGE_GLOB", "keyword2" },
			  { "CTEST_GIT_COMMAND", "keyword2" },
			  { "CTEST_GIT_INIT_SUBMODULES", "keyword2" },
			  { "CTEST_GIT_UPDATE_CUSTOM", "keyword2" },
			  { "CTEST_GIT_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_HG_COMMAND", "keyword2" },
			  { "CTEST_HG_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_LABELS_FOR_SUBPROJECTS", "keyword2" },
			  { "CTEST_MEMORYCHECK_COMMAND", "keyword2" },
			  { "CTEST_MEMORYCHECK_COMMAND_OPTIONS", "keyword2" },
			  { "CTEST_MEMORYCHECK_SANITIZER_OPTIONS", "keyword2" },
			  { "CTEST_MEMORYCHECK_SUPPRESSIONS_FILE", "keyword2" },
			  { "CTEST_MEMORYCHECK_TYPE", "keyword2" },
			  { "CTEST_NIGHTLY_START_TIME", "keyword2" },
			  { "CTEST_P4_CLIENT", "keyword2" },
			  { "CTEST_P4_COMMAND", "keyword2" },
			  { "CTEST_P4_OPTIONS", "keyword2" },
			  { "CTEST_P4_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_RESOURCE_SPEC_FILE", "keyword2" },
			  { "CTEST_RUN_CURRENT_SCRIPT", "keyword2" },
			  { "CTEST_SCP_COMMAND", "keyword2" },
			  { "CTEST_SCRIPT_DIRECTORY", "keyword2" },
			  { "CTEST_SITE", "keyword2" },
			  { "CTEST_SOURCE_DIRECTORY", "keyword2" },
			  { "CTEST_SUBMIT_INACTIVITY_TIMEOUT", "keyword2" },
			  { "CTEST_SUBMIT_URL", "keyword2" },
			  { "CTEST_SVN_COMMAND", "keyword2" },
			  { "CTEST_SVN_OPTIONS", "keyword2" },
			  { "CTEST_SVN_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_TEST_LOAD", "keyword2" },
			  { "CTEST_TEST_TIMEOUT", "keyword2" },
			  { "CTEST_TRIGGER_SITE", "keyword2" },
			  { "CTEST_UPDATE_COMMAND", "keyword2" },
			  { "CTEST_UPDATE_OPTIONS", "keyword2" },
			  { "CTEST_UPDATE_VERSION_ONLY", "keyword2" },
			  { "CTEST_UPDATE_VERSION_OVERRIDE", "keyword2" },
			  { "CTEST_USE_LAUNCHERS", "keyword2" },
			  { "CPACK_ABSOLUTE_DESTINATION_FILES", "keyword2" },
			  { "CPACK_COMPONENT_INCLUDE_TOPLEVEL_DIRECTORY", "keyword2" },
			  { "CPACK_CUSTOM_INSTALL_VARIABLES", "keyword2" },
			  { "CPACK_ERROR_ON_ABSOLUTE_INSTALL_DESTINATION", "keyword2" },
			  { "CPACK_INCLUDE_TOPLEVEL_DIRECTORY", "keyword2" },
			  { "CPACK_INSTALL_DEFAULT_DIRECTORY_PERMISSIONS", "keyword2" },
			  { "CPACK_PACKAGING_INSTALL_PREFIX", "keyword2" },
			  { "CPACK_SET_DESTDIR", "keyword2" },
			  { "CPACK_WARN_ON_ABSOLUTE_INSTALL_DESTINATION", "keyword2" },

		  },
		  "#",
		  { "^cmake_minimum_required.*%c" }

		} );
}

}}}} // namespace EE::UI::Doc::Language
