#include <eepp/ui/doc/languages/x86assembly.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addHtaccessFile() {

	SyntaxDefinitionManager::instance()->add(
		{ ".htaccess",
		  { "^%.htaccess$" },
		  {
			  { { "#.*\n" }, "comment" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'", "'", "\\" }, "string" },
			  { { "`", "`", "\\" }, "string" },
			  { { "%[!%[([^%]].-)%]%((https?://[%w_.~!*:@&+$/?%%#-]-%w[-.%w]*%.%w%w%w?%w?:?%d*/"
				  "?[%w_.~!*:@&+$/?%%#=-]*)%)%]%((https?://[%w_.~!*:@&+$/"
				  "?%%#-]-%w[-.%w]*%.%w%w%w?%w?:?%d*/?[%w_.~!*:@&+$/?%%#=-]*)%)" },
				{ "keyword", "function", "link", "link" } },
			  { { "%f[%w]application/[%w%._+-]+" }, "keyword2" },
			  { { "%f[%w]font/[%w%._+-]+" }, "keyword2" },
			  { { "%f[%w]image/[%w%._+-]+" }, "keyword2" },
			  { { "%f[%w]text/[%w%._+-]+" }, "keyword2" },
			  { { "%f[%w]audio/[%w%._+-]+" }, "keyword2" },
			  { { "%f[%w]video/[%w%._+-]+" }, "keyword2" },
			  { { "%d+%.%d+%.%d+%.%d+" }, "keyword2" },
			  { { "%d+%.%d+%.%d+%.%d+/%d+" }, "keyword2" },
			  { { "%w+@%w+%.%w+" }, "keyword2" },
			  { { "%f[%S]%b[]" }, "number" },
			  { { "</?%w+", ">" }, "literal" },
			  { { "[%%$]%d+" }, "keyword2" },
			  { { "[%%$]%{[%w_:%-]+%}" }, "keyword2" },
			  { { "A?%d+" }, "number" },
			  { { "%f[%S][!=+%-]+" }, "operator" },
			  { { "%f[^%s!]%^%S*" }, "literal" },
			  { { "%f[^%s!]%S*%$" }, "literal" },
			  { { "%f[^%s!]%b()" }, "literal" },
			  { { "[%a_][%w_-]*" }, "symbol" },
			  { { "%s+" }, "normal" },
			  { { "%w+%f[%s]" }, "normal" },
		  },
		  {
			  { "xml2EncDefault", "keyword" },
			  { "unset", "literal" },
			  { "php_value", "keyword" },
			  { "php_flag", "keyword" },
			  { "php_admin_flag", "keyword" },
			  { "on", "literal" },
			  { "off", "literal" },
			  { "mmapfile", "keyword" },
			  { "eq", "literal" },
			  { "email", "literal" },
			  { "denied", "literal" },
			  { "append", "literal" },
			  { "allow", "literal" },
			  { "xml2StartParse", "keyword" },
			  { "all", "literal" },
			  { "_ROUTING__allow_POST", "keyword" },
			  { "XBitHack", "keyword" },
			  { "VirtualScriptAlias", "keyword" },
			  { "VirtualHost", "keyword" },
			  { "VHostUser", "keyword" },
			  { "VHostPrivs", "keyword" },
			  { "VHostGroup", "keyword" },
			  { "VHostCGIMode", "keyword" },
			  { "UserDir", "keyword" },
			  { "UseCanonicalPhysicalPort", "keyword" },
			  { "UseCanonicalName", "keyword" },
			  { "UnsetEnv", "keyword" },
			  { "UnDefine", "keyword" },
			  { "TypesConfig", "keyword" },
			  { "TrustedProxy", "keyword" },
			  { "ThreadStackSize", "keyword" },
			  { "ThreadLimit", "keyword" },
			  { "SuexecUserGroup", "keyword" },
			  { "VHostSecure", "keyword" },
			  { "SimpleThreadCount", "keyword" },
			  { "SimpleProcCount", "keyword" },
			  { "SetOutputFilter", "keyword" },
			  { "SetInputFilter", "keyword" },
			  { "SetHandler", "keyword" },
			  { "Set", "literal" },
			  { "SessionExclude", "keyword" },
			  { "SessionDBDSelectLabel", "keyword" },
			  { "php_admin_value", "keyword" },
			  { "SessionDBDDeleteLabel", "keyword" },
			  { "SessionDBDPerUser", "keyword" },
			  { "SessionDBDCookieName", "keyword" },
			  { "SessionCryptoPassphraseFile", "keyword" },
			  { "SessionCookieRemove", "keyword" },
			  { "SessionMaxAge", "keyword" },
			  { "SessionCookieName2", "keyword" },
			  { "SessionCookieName", "keyword" },
			  { "Session", "keyword" },
			  { "ServerTokens", "keyword" },
			  { "ServerSignature", "keyword" },
			  { "ServerRoot", "keyword" },
			  { "ServerAlias", "keyword" },
			  { "SetEnv", "keyword" },
			  { "ServerAdmin", "keyword" },
			  { "SeeRequestTail", "keyword" },
			  { "SecFilterEngine", "keyword" },
			  { "SetEnvIfExpr", "keyword" },
			  { "Scriptsock", "keyword" },
			  { "ScriptSock", "keyword" },
			  { "ExtFilterDefine", "keyword" },
			  { "ISAPIReadAheadBuffer", "keyword" },
			  { "Options", "keyword" },
			  { "ExpiresByType", "keyword" },
			  { "ErrorLogFormat", "keyword" },
			  { "SessionDBDUpdateLabel", "keyword" },
			  { "ProxyIOBufferSize", "keyword" },
			  { "DirectorySlash", "keyword" },
			  { "AllowCONNECT", "keyword" },
			  { "CharsetSourceEnc", "keyword" },
			  { "AddOutputFilterByType", "keyword" },
			  { "DeflateWindowSize", "keyword" },
			  { "DeflateMemLevel", "keyword" },
			  { "DeflateInflateLimitRequestBody", "keyword" },
			  { "DumpIOLogLevel", "keyword" },
			  { "DefaultIcon", "keyword" },
			  { "CacheSocacheMaxSize", "keyword" },
			  { "AuthFormUsername", "keyword" },
			  { "CookieStyle", "keyword" },
			  { "EnableExceptionHook", "keyword" },
			  { "AuthGroupFile", "keyword" },
			  { "CookieExpires", "keyword" },
			  { "SessionEnv", "keyword" },
			  { "ProxyFtpDirCharset", "keyword" },
			  { "CookieDomain", "keyword" },
			  { "AddDefaultCharset", "keyword" },
			  { "ClientRecheckTime", "keyword" },
			  { "LDAPSharedCacheFile", "keyword" },
			  { "MultiviewsMatch", "keyword" },
			  { "CheckCaseOnly", "keyword" },
			  { "AuthFormLocation", "keyword" },
			  { "DeflateCompressionLevel", "keyword" },
			  { "EnableMMAP", "keyword" },
			  { "MaxClients", "keyword" },
			  { "AuthFormDisableNoStore", "keyword" },
			  { "NWSSLTrustedCerts", "keyword" },
			  { "ScoreBoardFile", "keyword" },
			  { "CaseFilter", "keyword" },
			  { "ProxyHTMLLinks", "keyword" },
			  { "MaxSpareThreads", "keyword" },
			  { "CacheSocacheMaxTime", "keyword" },
			  { "H2MaxWorkerIdleSeconds", "keyword" },
			  { "MCacheSize", "keyword" },
			  { "MaxClientConnections", "keyword" },
			  { "CacheMinFileSize", "keyword" },
			  { "Location", "keyword" },
			  { "ContentDigest", "keyword" },
			  { "CustomLog", "keyword" },
			  { "CacheLockMaxAge", "keyword" },
			  { "LuaHookCheckUserID", "keyword" },
			  { "VHostCGIPrivs", "keyword" },
			  { "LuaMapHandler", "keyword" },
			  { "DBDMax", "keyword" },
			  { "DTracePrivileges", "keyword" },
			  { "CacheKeyBaseURL", "keyword" },
			  { "SSILegacyExprParser", "keyword" },
			  { "CacheIgnoreHeaders", "keyword" },
			  { "CacheHeader", "keyword" },
			  { "CacheGcUnused", "keyword" },
			  { "AuthLDAPAuthoritative", "keyword" },
			  { "LDAPSharedCacheSize", "keyword" },
			  { "MaxSpareServers", "keyword" },
			  { "Protocols", "keyword" },
			  { "ScriptAliasMatch", "keyword" },
			  { "CacheEnable", "keyword" },
			  { "TransferLog", "keyword" },
			  { "CacheSocacheMinTime", "keyword" },
			  { "AuthzDefaultAuthoritative", "keyword" },
			  { "SSLLogLevel", "keyword" },
			  { "CacheDisable", "keyword" },
			  { "DAVDepthInfinity", "keyword" },
			  { "CacheMaxExpire", "keyword" },
			  { "ProxyHCTPsize", "keyword" },
			  { "RemoteIPInternalProxy", "keyword" },
			  { "CacheSocache", "keyword" },
			  { "CacheDetailHeader", "keyword" },
			  { "DAVLockDB", "keyword" },
			  { "DefaultLanguage", "keyword" },
			  { "QualifyRedirectURL", "keyword" },
			  { "CacheDirLevels", "keyword" },
			  { "SessionCryptoDriver", "keyword" },
			  { "CacheStoreExpired", "keyword" },
			  { "CacheTimeMargin", "keyword" },
			  { "LuaQuickHandler", "keyword" },
			  { "CacheDefaultExpire", "keyword" },
			  { "ProxyTimeout", "keyword" },
			  { "RemoteIPInternalProxyList", "keyword" },
			  { "CGIVar", "keyword" },
			  { "DBDMin", "keyword" },
			  { "SessionCryptoPassphrase", "keyword" },
			  { "DirectoryIndexRedirect", "keyword" },
			  { "CGIDScriptTimeout", "keyword" },
			  { "CookieTracking", "keyword" },
			  { "AuthDBDUserPWQuery", "keyword" },
			  { "FilterProtocol", "keyword" },
			  { "CacheGcMemUsage", "keyword" },
			  { "CacheIgnoreURLSessionIdentifiers", "keyword" },
			  { "BufferedLogs", "keyword" },
			  { "BufferSize", "keyword" },
			  { "RemoveLanguage", "keyword" },
			  { "BrowserMatchNoCase", "keyword" },
			  { "AuthDigestGroupFile", "keyword" },
			  { "Basic", "literal" },
			  { "CacheIgnoreQueryString", "keyword" },
			  { "AuthzDBMAuthoritative", "keyword" },
			  { "SetEnvIf", "keyword" },
			  { "AuthLDAPBindAuthoritative", "keyword" },
			  { "ProxyHTMLStripComments", "keyword" },
			  { "BalancerNonce", "keyword" },
			  { "AllowOverrideList", "keyword" },
			  { "IfModule", "keyword" },
			  { "AuthDefaultAuthoritative", "keyword" },
			  { "AddIconByEncoding", "keyword" },
			  { "AllowOverride", "keyword" },
			  { "AuthDBMGroupFile", "keyword" },
			  { "Eq", "literal" },
			  { "DAVGenericLockDB", "keyword" },
			  { "AsyncRequestWorkerFactor", "keyword" },
			  { "AuthBasicProvider", "keyword" },
			  { "AuthDigestAlgorithm", "keyword" },
			  { "AuthDBDUserRealmQuery", "keyword" },
			  { "HeartbeatAddress", "keyword" },
			  { "ProxyReceiveBufferSize", "keyword" },
			  { "AuthBasicUseDigestAlgorithm", "keyword" },
			  { "VirtualDocumentRootIP", "keyword" },
			  { "DirectoryMatch", "keyword" },
			  { "CacheStoreNoStore", "keyword" },
			  { "AuthLDAPGroupAttribute", "keyword" },
			  { "LDAPLibraryDebug", "keyword" },
			  { "DBDPersist", "keyword" },
			  { "ScriptAlias", "keyword" },
			  { "AuthzUserAuthoritative", "keyword" },
			  { "AuthBasicFake", "keyword" },
			  { "ForensicLog", "keyword" },
			  { "ProxySourceAddress", "keyword" },
			  { "AuthLDAPAuthzEnabled", "keyword" },
			  { "AuthLDAPCharsetConfig", "keyword" },
			  { "AuthDBMUserFile", "keyword" },
			  { "LDAPReferrals", "keyword" },
			  { "CacheNegotiatedDocs", "keyword" },
			  { "CaseFilterIn", "keyword" },
			  { "AssignUserID", "keyword" },
			  { "Any", "literal" },
			  { "AuthLDAPBindDN", "keyword" },
			  { "Anonymous_NoUserID", "keyword" },
			  { "AuthFormSize", "keyword" },
			  { "DBDriver", "keyword" },
			  { "CacheIgnoreCacheControl", "keyword" },
			  { "H2SessionExtraFiles", "keyword" },
			  { "ProtocolEcho", "keyword" },
			  { "EnableSendfile", "keyword" },
			  { "Anonymous_Authoritative", "keyword" },
			  { "Email", "literal" },
			  { "ForceLanguagePriority", "keyword" },
			  { "CharsetOptions", "keyword" },
			  { "AuthnCacheSOCache", "keyword" },
			  { "Substitute", "keyword" },
			  { "AuthLDAPCompareAsUser", "keyword" },
			  { "H2Direct", "keyword" },
			  { "Deny", "keyword" },
			  { "AuthLDAPCompareDNOnServer", "keyword" },
			  { "AuthLDAPSubGroupClass", "keyword" },
			  { "AuthnCacheProvideFor", "keyword" },
			  { "ChrootDir", "keyword" },
			  { "_ROUTING__allow_GET", "keyword" },
			  { "AddAltByType", "keyword" },
			  { "ProxyHTMLExtended", "keyword" },
			  { "AuthDBMType", "keyword" },
			  { "ExtendedStatus", "keyword" },
			  { "ModMimeUsePathInfo", "keyword" },
			  { "AuthnCacheProvider", "keyword" },
			  { "AuthDigestFile", "keyword" },
			  { "H2AltSvc", "keyword" },
			  { "IndexStyleSheet", "keyword" },
			  { "AcceptFilter", "keyword" },
			  { "ExpiresDefault", "keyword" },
			  { "CheckSpelling", "keyword" },
			  { "DBDParams", "keyword" },
			  { "AddDescription", "keyword" },
			  { "AcceptPathInfo", "keyword" },
			  { "ProxyMaxForwards", "keyword" },
			  { "DumpIOOutput", "keyword" },
			  { "DeflateBufferSize", "keyword" },
			  { "AddEncoding", "keyword" },
			  { "AuthDigestNonceFormat", "keyword" },
			  { "ProxyPassReverseCookiePath", "keyword" },
			  { "AddInputFilter", "keyword" },
			  { "AddIcon", "keyword" },
			  { "AuthBasicAuthoritative", "keyword" },
			  { "Define", "keyword" },
			  { "HeartbeatListen", "keyword" },
			  { "AddAltByEncoding", "keyword" },
			  { "AccessFileName", "keyword" },
			  { "RedirectMatch", "keyword" },
			  { "DAV", "keyword" },
			  { "IndexOrderDefault", "keyword" },
			  { "AuthLDAPRemoteUserAttribute", "keyword" },
			  { "AddAlt", "keyword" },
			  { "H2PushDiarySize", "keyword" },
			  { "LDAPTrustedCA", "keyword" },
			  { "ProxyPassInherit", "keyword" },
			  { "LuaHookLog", "keyword" },
			  { "Anonymous_VerifyEmail", "keyword" },
			  { "CacheDirLength", "keyword" },
			  { "AcceptMutex", "keyword" },
			  { "CacheReadTime", "keyword" },
			  { "AuthFormProvider", "keyword" },
			  { "ProxyMatch", "keyword" },
			  { "Action", "keyword" },
			  { "ProxyPass", "keyword" },
			  { "DBDInitSQL", "keyword" },
			  { "AddCharset", "keyword" },
			  { "SSITimeFormat", "keyword" },
			  { "CacheGcClean", "keyword" },
			  { "AuthzLDAPAuthoritative", "keyword" },
			  { "AuthnCacheContext", "keyword" },
			  { "SessionDBDInsertLabel", "keyword" },
			  { "SSLRequire", "keyword" },
			  { "CacheGcInterval", "keyword" },
			  { "Anonymous_LogEmail", "keyword" },
			  { "Anonymous_MustGiveEmail", "keyword" },
			  { "CGIPassAuth", "keyword" },
			  { "CoreDumpDirectory", "keyword" },
			  { "AddOutputFilter", "keyword" },
			  { "CacheExpiryCheck", "keyword" },
			  { "ReflectorHeader", "keyword" },
			  { "ScriptLogLength", "keyword" },
			  { "AuthDigestQop", "keyword" },
			  { "LDAPCacheTTL", "keyword" },
			  { "AuthDigestDomain", "keyword" },
			  { "ErrorDocument", "keyword" },
			  { "BalancerGrowth", "keyword" },
			  { "AuthzSendForbiddenOnFailure", "keyword" },
			  { "DeflateFilterNote", "keyword" },
			  { "CacheStaleOnError", "keyword" },
			  { "DAVMinTimeout", "keyword" },
			  { "AddLanguage", "keyword" },
			  { "AuthDBMAuthoritative", "keyword" },
			  { "CacheRoot", "keyword" },
			  { "CacheMinExpire", "keyword" },
			  { "ProxyFtpEscapeWildcards", "keyword" },
			  { "AuthAuthoritative", "keyword" },
			  { "RemoveOutputFilter", "keyword" },
			  { "AuthFormFakeBasicAuth", "keyword" },
			  { "FilterChain", "keyword" },
			  { "IdentityCheckTimeout", "keyword" },
			  { "TraceEnable", "keyword" },
			  { "DefaultType", "keyword" },
			  { "LuaHookTranslateName", "keyword" },
			  { "ProxyHTMLFixups", "keyword" },
			  { "AddModuleInfo", "keyword" },
			  { "AuthzGroupFileAuthoritative", "keyword" },
			  { "MaxRequestWorkers", "keyword" },
			  { "LuaHookTypeChecker", "keyword" },
			  { "Alias", "keyword" },
			  { "basic", "literal" },
			  { "CacheIgnoreNoLastMod", "keyword" },
			  { "DocumentRoot", "keyword" },
			  { "Header", "keyword" },
			  { "valid-user", "literal" },
			  { "All", "literal" },
			  { "MaxRangeOverlaps", "keyword" },
			  { "AddIconByType", "keyword" },
			  { "Allow", "keyword" },
			  { "SetEnvIfNoCase", "keyword" },
			  { "DeflateInflateRatioBurst", "keyword" },
			  { "AuthFormLoginRequiredLocation", "keyword" },
			  { "AllowEncodedSlashes", "keyword" },
			  { "CacheGcDaily", "keyword" },
			  { "AuthDigestNonceLifetime", "keyword" },
			  { "AuthzDBMType", "keyword" },
			  { "CacheQuickHandler", "keyword" },
			  { "PidFile", "keyword" },
			  { "CGIMapExtension", "keyword" },
			  { "AuthLDAPInitialBindAsUser", "keyword" },
			  { "AuthFormAuthoritative", "keyword" },
			  { "SerfPass", "keyword" },
			  { "RewriteRule", "keyword" },
			  { "User", "keyword" },
			  { "AuthDigestProvider", "keyword" },
			  { "AuthFormBody", "keyword" },
			  { "AuthFormLoginSuccessLocation", "keyword" },
			  { "ServerLimit", "keyword" },
			  { "AuthLDAPAuthorizePrefix", "keyword" },
			  { "KeepAliveTimeout", "keyword" },
			  { "AuthzDBDQuery", "keyword" },
			  { "NWSSLUpgradeable", "keyword" },
			  { "AuthDigestNcCheck", "keyword" },
			  { "BalancerMember", "keyword" },
			  { "Valid-User", "literal" },
			  { "AuthzDBDLoginToReferer", "keyword" },
			  { "LimitInternalRecursion", "keyword" },
			  { "AuthLDAPFrontPageHack", "keyword" },
			  { "AuthFormMimetype", "keyword" },
			  { "BrowserMatch", "keyword" },
			  { "BalancerPersist", "keyword" },
			  { "AuthFormPassword", "keyword" },
			  { "BS2000Account", "keyword" },
			  { "LDAPOpCacheTTL", "keyword" },
			  { "Win32DisableAcceptEx", "keyword" },
			  { "SubstituteInheritBefore", "keyword" },
			  { "DirectoryCheckHandler", "keyword" },
			  { "SSIErrorMsg", "keyword" },
			  { "CacheSocacheReadSize", "keyword" },
			  { "GlobalLog", "keyword" },
			  { "ProxyExpressDBMFile", "keyword" },
			  { "AuthLDAPDereferenceAliases", "keyword" },
			  { "DBDKeep", "keyword" },
			  { "ThreadsPerChild", "keyword" },
			  { "Redirect", "keyword" },
			  { "Unset", "literal" },
			  { "Suexec", "keyword" },
			  { "AuthLDAPEnabled", "keyword" },
			  { "ProxyPassMatch", "keyword" },
			  { "AuthUserFile", "keyword" },
			  { "AliasMatch", "keyword" },
			  { "MimeMagicFile", "keyword" },
			  { "RewriteLogLevel", "keyword" },
			  { "_ROUTING__allow_HEAD", "keyword" },
			  { "CookieName", "keyword" },
			  { "ProxyVia", "keyword" },
			  { "AuthLDAPGroupAttributeIsDN", "keyword" },
			  { "LuaScope", "keyword" },
			  { "AddType", "keyword" },
			  { "FancyIndexing", "keyword" },
			  { "CookieLog", "keyword" },
			  { "AuthLDAPInitialBindPattern", "keyword" },
			  { "ErrorLog", "keyword" },
			  { "AuthnCacheTimeout", "keyword" },
			  { "LDAPConnectionPoolTTL", "keyword" },
			  { "LocationMatch", "keyword" },
			  { "CacheLockPath", "keyword" },
			  { "ProxyHTMLDoctype", "keyword" },
			  { "AuthnCacheEnable", "keyword" },
			  { "Append", "literal" },
			  { "AuthLDAPRemoteUserIsDN", "keyword" },
			  { "Anonymous", "keyword" },
			  { "AuthLDAPSearchAsUser", "keyword" },
			  { "H2WindowSize", "keyword" },
			  { "StartThreads", "keyword" },
			  { "CacheMaxFileSize", "keyword" },
			  { "AuthFormMethod", "keyword" },
			  { "LimitExcept", "keyword" },
			  { "LimitRequestFieldSize", "keyword" },
			  { "MetaDir", "keyword" },
			  { "ProxyHTMLBufSize", "keyword" },
			  { "AuthLDAPSubGroupAttribute", "keyword" },
			  { "LogIOTrackTTFB", "keyword" },
			  { "AuthLDAPURL", "keyword" },
			  { "LDAPTrustedGlobalCert", "keyword" },
			  { "ChildperUserID", "keyword" },
			  { "StartServers", "keyword" },
			  { "AuthzOwnerAuthoritative", "keyword" },
			  { "DirectoryIndex", "keyword" },
			  { "SecureListen", "keyword" },
			  { "FallbackResource", "keyword" },
			  { "FileETag", "keyword" },
			  { "ExtFilterOptions", "keyword" },
			  { "H2MaxSessionStreams", "keyword" },
			  { "MCacheMaxStreamingBuffer", "keyword" },
			  { "Files", "keyword" },
			  { "FilesMatch", "keyword" },
			  { "FilterDeclare", "keyword" },
			  { "FilterProvider", "keyword" },
			  { "ProxyPassInterpolateEnv", "keyword" },
			  { "FilterTrace", "keyword" },
			  { "MinSpareServers", "keyword" },
			  { "GprofDir", "keyword" },
			  { "Group", "keyword" },
			  { "H2AltSvcMaxAge", "keyword" },
			  { "RemoteIPTrustedProxyList", "keyword" },
			  { "VirtualScriptAliasIP", "keyword" },
			  { "ScoreboardFile", "keyword" },
			  { "AuthzDBDRedirectQuery", "keyword" },
			  { "H2MaxWorkers", "keyword" },
			  { "H2MinWorkers", "keyword" },
			  { "LogMessage", "keyword" },
			  { "ProxyHCTemplate", "keyword" },
			  { "xml2EncAlias", "keyword" },
			  { "CacheLastModifiedFactor", "keyword" },
			  { "H2Push", "keyword" },
			  { "H2PushPriority", "keyword" },
			  { "SubstituteMaxLineLength", "keyword" },
			  { "ProxyExpressEnable", "keyword" },
			  { "H2SerializeHeaders", "keyword" },
			  { "ServerPath", "keyword" },
			  { "ProxyHTMLInterp", "keyword" },
			  { "SSLLog", "keyword" },
			  { "H2TLSCoolDownSecs", "keyword" },
			  { "IndexHeadInsert", "keyword" },
			  { "H2Upgrade", "keyword" },
			  { "HeaderName", "keyword" },
			  { "Script", "keyword" },
			  { "ForceType", "keyword" },
			  { "HeartbeatStorage", "keyword" },
			  { "SSIAccessEnable", "keyword" },
			  { "HostnameLookups", "keyword" },
			  { "H2ModernTLSOnly", "keyword" },
			  { "ProxyPassReverse", "keyword" },
			  { "AuthFormLogoutLocation", "keyword" },
			  { "ISAPIAppendLogToErrors", "keyword" },
			  { "ISAPIAppendLogToQuery", "keyword" },
			  { "ISAPICacheFile", "keyword" },
			  { "set", "literal" },
			  { "ISAPIFakeAsync", "keyword" },
			  { "ISAPILogNotSupported", "keyword" },
			  { "IdentityCheck", "keyword" },
			  { "MaxRanges", "keyword" },
			  { "H2StreamMaxMemSize", "keyword" },
			  { "ImapBase", "keyword" },
			  { "LDAPTrustedCAType", "keyword" },
			  { "ImapDefault", "keyword" },
			  { "Include", "keyword" },
			  { "IncludeOptional", "keyword" },
			  { "IfDefine", "keyword" },
			  { "IndexIgnore", "keyword" },
			  { "MaxRangeReversals", "keyword" },
			  { "cachefile", "keyword" },
			  { "IndexIgnoreReset", "keyword" },
			  { "IndexOptions", "keyword" },
			  { "On", "literal" },
			  { "KeepAlive", "keyword" },
			  { "KeptBodySize", "keyword" },
			  { "LDAPCacheEntries", "keyword" },
			  { "MaxThreadsPerChild", "keyword" },
			  { "AuthLDAPMaxSubGroupDepth", "keyword" },
			  { "LDAPConnectionTimeout", "keyword" },
			  { "LDAPOpCacheEntries", "keyword" },
			  { "ProxySCGISendfile", "keyword" },
			  { "LDAPReferralHopLimit", "keyword" },
			  { "LDAPRetries", "keyword" },
			  { "RLimitMEM", "keyword" },
			  { "LDAPRetryDelay", "keyword" },
			  { "AuthType", "keyword" },
			  { "LDAPTimeout", "keyword" },
			  { "LDAPTrustedMode", "keyword" },
			  { "LDAPVerifyServerCert", "keyword" },
			  { "LuaInputFilter", "keyword" },
			  { "VirtualDocumentRoot", "keyword" },
			  { "LanguagePriority", "keyword" },
			  { "CacheStorePrivate", "keyword" },
			  { "DBDPrepareSQL", "keyword" },
			  { "MaxKeepAliveRequests", "keyword" },
			  { "AddHandler", "keyword" },
			  { "LimitRequestBody", "keyword" },
			  { "LimitRequestFields", "keyword" },
			  { "ServerName", "keyword" },
			  { "LimitRequestFieldsize", "keyword" },
			  { "ProxyPreserveHost", "keyword" },
			  { "LimitRequestLine", "keyword" },
			  { "LimitXMLRequestBody", "keyword" },
			  { "DefaultRuntimeDir", "keyword" },
			  { "LoadFile", "keyword" },
			  { "LoadModule", "keyword" },
			  { "LogFormat", "keyword" },
			  { "LuaAuthzProvider", "keyword" },
			  { "Denied", "literal" },
			  { "LuaCodeCache", "keyword" },
			  { "LuaHookAccessChecker", "keyword" },
			  { "ProxySCGIInternalRedirect", "keyword" },
			  { "MaxThreads", "keyword" },
			  { "LuaHookAuthChecker", "keyword" },
			  { "RewriteBase", "keyword" },
			  { "LuaHookFixups", "keyword" },
			  { "ExpiresActive", "keyword" },
			  { "Anonymous_NoUserId", "keyword" },
			  { "LuaHookInsertFilter", "keyword" },
			  { "SSLRequireSSL", "keyword" },
			  { "AuthnzFcgiDefineProvider", "keyword" },
			  { "LuaHookMapToStorage", "keyword" },
			  { "LuaInherit", "keyword" },
			  { "CacheReadSize", "keyword" },
			  { "LuaOutputFilter", "keyword" },
			  { "Protocol", "keyword" },
			  { "MCacheRemovalAlgorithm", "keyword" },
			  { "ProxyBadHeader", "keyword" },
			  { "RedirectPermanent", "keyword" },
			  { "LuaPackageCPath", "keyword" },
			  { "LuaRoot", "keyword" },
			  { "H2TLSWarmUpSize", "keyword" },
			  { "MCacheMaxObjectCount", "keyword" },
			  { "MCacheMaxObjectSize", "keyword" },
			  { "MaxConnectionsPerChild", "keyword" },
			  { "MCacheMinObjectSize", "keyword" },
			  { "MaxMemFree", "keyword" },
			  { "MaxRequestsPerThread", "keyword" },
			  { "MemcacheConnTTL", "keyword" },
			  { "MergeTrailers", "keyword" },
			  { "MetaFiles", "keyword" },
			  { "MetaSuffix", "keyword" },
			  { "MinSpareThreads", "keyword" },
			  { "ProxyRequests", "keyword" },
			  { "CharsetDefault", "keyword" },
			  { "AuthLDAPBindPassword", "keyword" },
			  { "ModemStandard", "keyword" },
			  { "Mutex", "keyword" },
			  { "NameVirtualHost", "keyword" },
			  { "LDAPTrustedClientCert", "keyword" },
			  { "NumServers", "keyword" },
			  { "Off", "literal" },
			  { "AuthDigestShmemSize", "keyword" },
			  { "AuthMerging", "keyword" },
			  { "Order", "keyword" },
			  { "RLimitNPROC", "keyword" },
			  { "LuaPackagePath", "keyword" },
			  { "OutputSed", "keyword" },
			  { "Port", "keyword" },
			  { "NoProxy", "keyword" },
			  { "DeflateInflateRatioLimit", "keyword" },
			  { "PrivilegesMode", "keyword" },
			  { "from", "keyword" },
			  { "ProtocolsHonorOrder", "keyword" },
			  { "deny", "literal" },
			  { "ProxyAddHeaders", "keyword" },
			  { "ProxyHTMLEvents", "keyword" },
			  { "ProxyBlock", "keyword" },
			  { "ProxyHTMLMeta", "keyword" },
			  { "ProxyDomain", "keyword" },
			  { "ProxyErrorOverride", "keyword" },
			  { "DumpIOInput", "keyword" },
			  { "ProxyExpressDBMType", "keyword" },
			  { "MaxRequestsPerChild", "keyword" },
			  { "ProxyFtpListOnWildcard", "keyword" },
			  { "BalancerInherit", "keyword" },
			  { "ProxyHCExpr", "keyword" },
			  { "ProxyHTMLCharsetOut", "keyword" },
			  { "SessionDBDCookieRemove", "keyword" },
			  { "ProxyHTMLEnable", "keyword" },
			  { "ProxyHTMLURLMap", "keyword" },
			  { "ProxyPassReverseCookieDomain", "keyword" },
			  { "ProxyRemote", "keyword" },
			  { "CacheLock", "keyword" },
			  { "ProxyRemoteMatch", "keyword" },
			  { "ImapMenu", "keyword" },
			  { "ProxySet", "keyword" },
			  { "ProxyStatus", "keyword" },
			  { "SerfCluster", "keyword" },
			  { "IfVersion", "keyword" },
			  { "Lua_____ByteCodeHack", "keyword" },
			  { "RLimitCPU", "keyword" },
			  { "SessionHeader", "keyword" },
			  { "RedirectTemp", "keyword" },
			  { "ReadmeName", "keyword" },
			  { "SSIStartTag", "keyword" },
			  { "LogLevel", "keyword" },
			  { "RemoteIPHeader", "keyword" },
			  { "AuthnzFcgiCheckAuthnProvider", "keyword" },
			  { "PassEnv", "keyword" },
			  { "RequestHeader", "keyword" },
			  { "SSLOptions", "keyword" },
			  { "RemoteIPTrustedProxy", "keyword" },
			  { "RemoveCharset", "keyword" },
			  { "RemoveEncoding", "keyword" },
			  { "RemoveHandler", "keyword" },
			  { "RemoveInputFilter", "keyword" },
			  { "SessionInclude", "keyword" },
			  { "RemoveType", "keyword" },
			  { "RequestReadTimeout", "keyword" },
			  { "RequestTimeout", "keyword" },
			  { "AllowMethods", "keyword" },
			  { "Require", "keyword" },
			  { "AuthFormSitePassphrase", "keyword" },
			  { "RewriteCond", "keyword" },
			  { "DBDExptime", "keyword" },
			  { "CacheForceCompletion", "keyword" },
			  { "RewriteEngine", "keyword" },
			  { "any", "literal" },
			  { "HeartbeatMaxServers", "keyword" },
			  { "Satisfy", "keyword" },
			  { "RewriteLock", "keyword" },
			  { "SessionCryptoCipher", "keyword" },
			  { "RewriteLog", "keyword" },
			  { "RewriteMap", "keyword" },
			  { "CacheSocacheReadTime", "keyword" },
			  { "RemoteIPProxiesHeader", "keyword" },
			  { "LockFile", "keyword" },
			  { "RewriteOptions", "keyword" },
			  { "SessionDBDCookieName2", "keyword" },
			  { "SSIEndTag", "keyword" },
			  { "InputSed", "keyword" },
			  { "SSIEtag", "keyword" },
			  { "SSILastModified", "keyword" },
			  { "SSIUndefinedEcho", "keyword" },
			  { "AuthName", "keyword" },
			  { "ScriptInterpreterSource", "keyword" },
			  { "ScriptLog", "keyword" },
			  { "ScriptLogBuffer", "keyword" },

		  },
		  "#",
		  {} } );
}

}}}} // namespace EE::UI::Doc::Language
