#include <eepp/ui/doc/languages/pony.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addPony() {

	auto& sd = SyntaxDefinitionManager::instance()->add(

		{ "pony",
		  { "%.pony$" },
		  {
			  { { "//.-\n" }, "comment" },
			  { { "/%*", "%*/" }, "comment" },
			  { { "\"\"\"", "\"\"\"" }, "comment" },
			  { { "/%g", "/", "\\" }, "string" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'.+'" }, "string" },
			  { { "`", "`", "\\" }, "string" },
			  { { "0x[%da-fA-F]+" }, "number" },
			  { { "0b[%da-fA-F]+" }, "number" },
			  { { "-?%d+[%d%_.eE]*" }, "number" },
			  { { "-?%.?[%d]+" }, "number" },
			  { { "^[0-9]{1,3}((_[0-9]{3})+)?$" }, "number" },
			  { { "[%+%-=/%*%^%%<>!~|&?]" }, "operator" },
			  { { "[%a_][%w_]*%f[(]" }, "function" },
			  { { "[%a_][%w_]*" }, "symbol" },
			  { { "%s+" }, "normal" },
			  { { "%w+%f[%s]" }, "normal" },

		  },
		  {
			  { "then", "keyword" },
			  { "new", "keyword" },
			  { "continue", "keyword2" },
			  { "ifdef", "keyword" },
			  { "&", "keyword2" },
			  { "val", "keyword" },
			  { "I32", "keyword" },
			  { "this", "keyword2" },
			  { "Pointer", "keyword" },
			  { "consume", "keyword2" },
			  { "Array", "keyword" },
			  { "String", "keyword" },
			  { "F64", "keyword" },
			  { "xor", "keyword2" },
			  { "end", "keyword" },
			  { "addressof", "keyword2" },
			  { "U128", "keyword" },
			  { "object", "keyword" },
			  { "match", "keyword" },
			  { "with", "keyword" },
			  { "false", "keyword2" },
			  { "for", "keyword" },
			  { "while", "keyword" },
			  { "iso", "keyword" },
			  { "Stringable", "keyword" },
			  { "Iterator", "keyword" },
			  { "else", "keyword" },
			  { "recover", "keyword2" },
			  { "compile_intrinsic", "keyword" },
			  { "digestof", "keyword2" },
			  { "actor", "keyword" },
			  { "U32", "keyword" },
			  { "primitive", "keyword" },
			  { "iftype", "keyword" },
			  { "struct", "keyword" },
			  { "break", "keyword2" },
			  { "is", "keyword2" },
			  { "use", "keyword" },
			  { "or", "keyword2" },
			  { "until", "keyword" },
			  { "if", "keyword" },
			  { "let", "keyword" },
			  { "isnt", "keyword2" },
			  { "Any", "keyword" },
			  { "elseif", "keyword" },
			  { "in", "keyword" },
			  { "USize", "keyword" },
			  { "#alias", "keyword2" },
			  { "Env", "keyword" },
			  { "and", "keyword2" },
			  { "trn", "keyword" },
			  { "tag", "keyword" },
			  { "box", "keyword" },
			  { "None", "keyword2" },
			  { "trait", "keyword" },
			  { "return", "keyword" },
			  { "var", "keyword" },
			  { "U8", "keyword" },
			  { "error", "keyword2" },
			  { "try", "keyword" },
			  { "as", "keyword2" },
			  { "class", "keyword" },
			  { "ILong", "keyword" },
			  { "I8", "keyword" },
			  { "repeat", "keyword" },
			  { "U16", "keyword" },
			  { "#send", "keyword2" },
			  { "#any", "keyword2" },
			  { "#share", "keyword2" },
			  { "I128", "keyword" },
			  { "#read", "keyword2" },
			  { "F32", "keyword" },
			  { "compile_error", "keyword" },
			  { "embed", "keyword" },
			  { "where", "keyword2" },
			  { "true", "keyword2" },
			  { "not", "keyword2" },
			  { "Bool", "keyword" },
			  { "|", "keyword2" },
			  { "I64", "keyword" },
			  { "U64", "keyword" },
			  { "ULong", "keyword" },
			  { "I16", "keyword" },
			  { "interface", "keyword" },
			  { "be", "keyword" },
			  { "do", "keyword" },
			  { "fun", "keyword" },
			  { "ref", "keyword" },
			  { "ISize", "keyword" },
			  { "type", "keyword" },

		  },
		  "//",
		  {}

		} );

	sd.setFoldRangeType( FoldRangeType::Indentation );
}

}}}} // namespace EE::UI::Doc::Language
