#include <eepp/ui/doc/languages/ring.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addRing() {

	SyntaxDefinitionManager::instance()->add(

		{ "Ring",
		  { "%.ring$", "%.rh$", "%.rform$" },
		  {
			  { { "#.*" }, "comment" },
			  { { "//.*" }, "comment" },
			  { { "/%*", "%*/" }, "comment" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'", "'", "\\" }, "string" },
			  { { "`", "`", "\\" }, "string" },
			  { { "-?%d+[%d%.]*f?" }, "number" },
			  { { "-?0x%x+" }, "number" },
			  { { "[%+%-=/%*%^%%<>!~|&]" }, "operator" },
			  { { "[%a_][%w_]*%f[(]" }, "function" },
			  { { "([Dd][Ee][Ff])(%s+)([%a_][%w_]*)" },
				{ "normal", "keyword", "normal", "function" } },
			  { { "([Ff][Uu][Nn][Cc])(%s+)([%a_][%w_]*)" },
				{ "normal", "keyword", "normal", "function" } },
			  { { "([Cc][Ll][Aa][Ss][Ss])(%s+)([%a_][%w_]*)" },
				{ "normal", "keyword", "normal", "function" } },
			  { { "[%a_][%w_]*" }, "symbol" },
			  { { "%?" }, "keyword" },
			  { { ":[%a_][%w_]*" }, "literal" },
			  { { "%s+" }, "normal" },
			  { { "%w+%f[%s]" }, "normal" },

		  },
		  {
			  { "int", "keyword2" },
			  { "BREAK", "keyword" },
			  { "new", "keyword" },
			  { "IF", "keyword" },
			  { "Override", "keyword2" },
			  { "End", "keyword" },
			  { "endfor", "keyword" },
			  { "Catch", "keyword" },
			  { "loop", "keyword" },
			  { "OTHER", "keyword" },
			  { "CASE", "keyword" },
			  { "long", "keyword2" },
			  { "foreach", "keyword" },
			  { "LOAD", "keyword" },
			  { "String", "keyword2" },
			  { "give", "keyword" },
			  { "STEP", "keyword" },
			  { "Give", "keyword" },
			  { "FALSE", "literal" },
			  { "end", "keyword" },
			  { "Loadsyntax", "keyword" },
			  { "short", "keyword2" },
			  { "while", "keyword" },
			  { "bye", "keyword" },
			  { "endclass", "keyword" },
			  { "FOREACH", "keyword" },
			  { "VOID", "keyword2" },
			  { "OBJECT", "keyword2" },
			  { "break", "keyword" },
			  { "Object", "keyword2" },
			  { "ENDCLASS", "keyword" },
			  { "BUT", "keyword" },
			  { "IMPORT", "keyword" },
			  { "Other", "keyword" },
			  { "changeringkeyword", "keyword" },
			  { "Enablehashcomments", "keyword" },
			  { "False", "literal" },
			  { "WHILE", "keyword" },
			  { "abstract", "keyword2" },
			  { "ELSEIF", "keyword" },
			  { "CATCH", "keyword" },
			  { "Int", "keyword2" },
			  { "Nl", "keyword" },
			  { "BOOLEAN", "keyword2" },
			  { "SIGNED", "keyword2" },
			  { "Break", "keyword" },
			  { "class", "keyword" },
			  { "void", "keyword2" },
			  { "DOUBLE", "keyword2" },
			  { "byte", "keyword2" },
			  { "Changeringkeyword", "keyword" },
			  { "boolean", "keyword2" },
			  { "Step", "keyword" },
			  { "ENDWHILE", "keyword" },
			  { "DO", "keyword" },
			  { "LOOP", "keyword" },
			  { "AGAIN", "keyword" },
			  { "other", "keyword" },
			  { "Return", "keyword" },
			  { "float", "keyword2" },
			  { "see", "function" },
			  { "loadsyntax", "keyword" },
			  { "do", "keyword" },
			  { "to", "keyword" },
			  { "Abstract", "keyword2" },
			  { "default", "keyword" },
			  { "but", "keyword" },
			  { "char", "keyword2" },
			  { "BYTE", "keyword2" },
			  { "Call", "keyword" },
			  { "Next", "keyword" },
			  { "get", "keyword" },
			  { "call", "keyword" },
			  { "from", "keyword" },
			  { "Static", "keyword2" },
			  { "else", "keyword" },
			  { "next", "keyword" },
			  { "For", "keyword" },
			  { "Loop", "keyword" },
			  { "Foreach", "keyword" },
			  { "FUNC", "keyword" },
			  { "SEE", "function" },
			  { "ENDFUNCTION", "keyword" },
			  { "string", "keyword2" },
			  { "Endfor", "keyword" },
			  { "DEFAULT", "keyword" },
			  { "Number", "keyword2" },
			  { "Char", "keyword2" },
			  { "elseif", "keyword" },
			  { "in", "keyword" },
			  { "NUMBER", "keyword2" },
			  { "Float", "keyword2" },
			  { "private", "keyword" },
			  { "signed", "keyword2" },
			  { "DEF", "keyword" },
			  { "switch", "keyword" },
			  { "OVERRIDE", "keyword2" },
			  { "Get", "keyword" },
			  { "LOADSYNTAX", "keyword" },
			  { "Exit", "keyword" },
			  { "import", "keyword" },
			  { "try", "keyword" },
			  { "Unsigned", "keyword2" },
			  { "See", "function" },
			  { "In", "keyword" },
			  { "Short", "keyword2" },
			  { "endtry", "keyword" },
			  { "LIST", "keyword2" },
			  { "FLOAT", "keyword2" },
			  { "DISABLEHASHCOMMENTS", "keyword" },
			  { "list", "keyword2" },
			  { "Try", "keyword" },
			  { "catch", "keyword" },
			  { "LONG", "keyword2" },
			  { "Endpackage", "keyword" },
			  { "EXIT", "keyword" },
			  { "SHORT", "keyword2" },
			  { "done", "keyword" },
			  { "Done", "keyword" },
			  { "again", "keyword" },
			  { "on", "keyword" },
			  { "nl", "keyword" },
			  { "CLASS", "keyword" },
			  { "Disablehashcomments", "keyword" },
			  { "Long", "keyword2" },
			  { "ENDSWITCH", "keyword" },
			  { "TRY", "keyword" },
			  { "Do", "keyword" },
			  { "for", "keyword" },
			  { "FROM", "keyword" },
			  { "Package", "keyword" },
			  { "OFF", "keyword" },
			  { "DONE", "keyword" },
			  { "RETURN", "keyword" },
			  { "IN", "keyword" },
			  { "null", "literal" },
			  { "PRINT", "function" },
			  { "CHANGERINGKEYWORD", "keyword" },
			  { "func", "keyword" },
			  { "INT", "keyword2" },
			  { "NEXT", "keyword" },
			  { "disablehashcomments", "keyword" },
			  { "If", "keyword" },
			  { "CHAR", "keyword2" },
			  { "Bye", "keyword" },
			  { "enablehashcomments", "keyword" },
			  { "endfunc", "keyword" },
			  { "STRING", "keyword2" },
			  { "exit", "keyword" },
			  { "Endswitch", "keyword" },
			  { "ENDTRY", "keyword" },
			  { "Off", "keyword" },
			  { "On", "keyword" },
			  { "CALL", "keyword" },
			  { "ENDPACKAGE", "keyword" },
			  { "Else", "keyword" },
			  { "END", "keyword" },
			  { "Byte", "keyword2" },
			  { "Elseif", "keyword" },
			  { "Default", "keyword" },
			  { "Changeringoperator", "keyword" },
			  { "static", "keyword2" },
			  { "Endfunc", "keyword" },
			  { "CONTINUE", "keyword" },
			  { "off", "keyword" },
			  { "def", "keyword" },
			  { "true", "literal" },
			  { "Void", "keyword2" },
			  { "endfunction", "keyword" },
			  { "Signed", "keyword2" },
			  { "ENDFUNC", "keyword" },
			  { "PROTECTED", "keyword2" },
			  { "Endtry", "keyword" },
			  { "Class", "keyword" },
			  { "case", "keyword" },
			  { "protected", "keyword2" },
			  { "ON", "keyword" },
			  { "Switch", "keyword" },
			  { "STATIC", "keyword2" },
			  { "Func", "keyword" },
			  { "PACKAGE", "keyword" },
			  { "continue", "keyword" },
			  { "While", "keyword" },
			  { "Put", "function" },
			  { "True", "literal" },
			  { "Print", "function" },
			  { "CHANGERINGOPERATOR", "keyword" },
			  { "Continue", "keyword" },
			  { "Endwhile", "keyword" },
			  { "BYE", "keyword" },
			  { "SWITCH", "keyword" },
			  { "load", "keyword" },
			  { "Endclass", "keyword" },
			  { "object", "keyword2" },
			  { "false", "literal" },
			  { "Public", "keyword2" },
			  { "GIVE", "keyword" },
			  { "ok", "keyword" },
			  { "ENDFOR", "keyword" },
			  { "Private", "keyword" },
			  { "endwhile", "keyword" },
			  { "print", "function" },
			  { "GET", "keyword" },
			  { "List", "keyword2" },
			  { "TRUE", "literal" },
			  { "NL", "keyword" },
			  { "Import", "keyword" },
			  { "if", "keyword" },
			  { "TO", "keyword" },
			  { "ELSE", "keyword" },
			  { "NEW", "keyword" },
			  { "step", "keyword" },
			  { "public", "keyword2" },
			  { "unsigned", "keyword2" },
			  { "New", "keyword" },
			  { "number", "keyword2" },
			  { "Case", "keyword" },
			  { "changeringoperator", "keyword" },
			  { "put", "function" },
			  { "PRIVATE", "keyword" },
			  { "double", "keyword2" },
			  { "Load", "keyword" },
			  { "PUBLIC", "keyword2" },
			  { "return", "keyword" },
			  { "NULL", "literal" },
			  { "But", "keyword" },
			  { "PUT", "function" },
			  { "Double", "keyword2" },
			  { "Ok", "keyword" },
			  { "Null", "literal" },
			  { "endpackage", "keyword" },
			  { "From", "keyword" },
			  { "ABSTRACT", "keyword2" },
			  { "ENABLEHASHCOMMENTS", "keyword" },
			  { "FOR", "keyword" },
			  { "Boolean", "keyword2" },
			  { "OK", "keyword" },
			  { "package", "keyword" },
			  { "override", "keyword2" },
			  { "Protected", "keyword2" },
			  { "To", "keyword" },
			  { "Again", "keyword" },
			  { "Def", "keyword" },
			  { "UNSIGNED", "keyword2" },
			  { "Endfunction", "keyword" },
			  { "endswitch", "keyword" },

		  },
		  "//",
		  {}

		} );
}

}}}} // namespace EE::UI::Doc::Language
