#include <eepp/ui/doc/languages/sass.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addSass() {

	SyntaxDefinitionManager::instance()->add(

		{ "Sass",
		  { "%.sass$", "%.scss$" },
		  {
			  { { "/[/%*].-\n" }, "comment" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'", "'", "\\" }, "string" },
			  { { "$%w+" }, "keyword" },
			  { { "@%w+" }, "literal" },
			  { { "&" }, "keyword2" },
			  { { "[:%/%*%-]" }, "operator" },
			  { { "[%a][%w-]*%s*%f[:]" }, "keyword2" },
			  { { "-?%d+[%d%.]*p[xt]" }, "number" },
			  { { "-?%d+[%d%.]*deg" }, "number" },
			  { { "-?%d+[%d%.]*[s%%]" }, "number" },
			  { { "-?%d+[%d%.]*" }, "number" },
			  { { "^%s*#[%a%_%-][%w%_%-]*" }, "keyword2" },
			  { { ",%s*#[%a%_%-][%w%_%-]*" }, "keyword2" },
			  { { "#%x%x?%x?%x?%x?%x?%x?%x?" }, "string" },
			  { { "#[%a%_%-][%w%_%-]*" }, "keyword2" },
			  { { "%-%-%a[%w%-%_]*" }, "keyword2" },
			  { { "-?%d+[%d%.]*p[xt]" }, "number" },
			  { { "-?%d+[%d%.]*deg" }, "number" },
			  { { "-?%d+[%d%.]*" }, "number" },
			  { { "@[%a][%w%_%-]*" }, "keyword2" },
			  { { "%.[%a%_%-][%w%_%-]*" }, "keyword2" },
			  { { "(:)(hover)" }, { "normal", "operator", "literal" } },
			  { { "(:)(focus%-within)" }, { "normal", "operator", "literal" } },
			  { { "(:)(focus)" }, { "normal", "operator", "literal" } },
			  { { "(:)(selected)" }, { "normal", "operator", "literal" } },
			  { { "(:)(pressed)" }, { "normal", "operator", "literal" } },
			  { { "(:)(disabled)" }, { "normal", "operator", "literal" } },
			  { { "(:)(checked)" }, { "normal", "operator", "literal" } },
			  { { "(:)(root)" }, { "normal", "operator", "link" } },
			  { { "(%a+)(%()" }, { "normal", "function", "normal" } },
			  { { "[%a][%w-]*%s*%f[:]" }, "keyword" },
			  { { "[{}:>~!]" }, "operator" },
			  { { "[#,]%w+" }, "function" },
			  { { "[%a_][%w_]*" }, "symbol" },

		  },
		  {
			  { "orange", "literal" },
			  { "olivedrab", "literal" },
			  { "olive", "literal" },
			  { "navajowhite", "literal" },
			  { "mistyrose", "literal" },
			  { "midnightblue", "literal" },
			  { "darkseagreen", "literal" },
			  { "mediumseagreen", "literal" },
			  { "lavenderblush", "literal" },
			  { "mediumaquamarine", "literal" },
			  { "limegreen", "literal" },
			  { "mediumspringgreen", "literal" },
			  { "lightgreen", "literal" },
			  { "lime", "literal" },
			  { "mediumorchid", "literal" },
			  { "gray", "literal" },
			  { "black", "literal" },
			  { "lightyellow", "literal" },
			  { "mediumblue", "literal" },
			  { "lightslategray", "literal" },
			  { "lightseagreen", "literal" },
			  { "lightpink", "literal" },
			  { "lightslategrey", "literal" },
			  { "lightgrey", "literal" },
			  { "lightgoldenrodyellow", "literal" },
			  { "lightblue", "literal" },
			  { "lemonchiffon", "literal" },
			  { "lawngreen", "literal" },
			  { "mintcream", "literal" },
			  { "khaki", "literal" },
			  { "ivory", "literal" },
			  { "moccasin", "literal" },
			  { "indigo", "literal" },
			  { "transparent", "literal" },
			  { "oldlace", "literal" },
			  { "indianred", "literal" },
			  { "hotpink", "literal" },
			  { "sizenwse", "literal" },
			  { "wait", "literal" },
			  { "deeppink", "literal" },
			  { "antiquewhite", "literal" },
			  { "crosshair", "literal" },
			  { "arrow", "literal" },
			  { "coral", "literal" },
			  { "peachpuff", "literal" },
			  { "darkgreen", "literal" },
			  { "firebrick", "literal" },
			  { "burlywood", "literal" },
			  { "darkblue", "literal" },
			  { "darkcyan", "literal" },
			  { "darkturquoise", "literal" },
			  { "paleturquoise", "literal" },
			  { "whitesmoke", "literal" },
			  { "sienna", "literal" },
			  { "tan", "literal" },
			  { "grey", "literal" },
			  { "darkolivegreen", "literal" },
			  { "slategrey", "literal" },
			  { "springgreen", "literal" },
			  { "gold", "literal" },
			  { "darkgrey", "literal" },
			  { "darkviolet", "literal" },
			  { "yellowgreen", "literal" },
			  { "linen", "literal" },
			  { "white", "literal" },
			  { "dodgerblue", "literal" },
			  { "thistle", "literal" },
			  { "sandybrown", "literal" },
			  { "tomato", "literal" },
			  { "violet", "literal" },
			  { "palevioletred", "literal" },
			  { "chartreuse", "literal" },
			  { "turquoise", "literal" },
			  { "azure", "literal" },
			  { "lightsteelblue", "literal" },
			  { "seashell", "literal" },
			  { "navy", "literal" },
			  { "darkmagenta", "literal" },
			  { "silver", "literal" },
			  { "teal", "literal" },
			  { "darkorchid", "literal" },
			  { "seagreen", "literal" },
			  { "wheat", "literal" },
			  { "darkred", "literal" },
			  { "slateblue", "literal" },
			  { "red", "literal" },
			  { "orchid", "literal" },
			  { "salmon", "literal" },
			  { "lightcoral", "literal" },
			  { "center", "literal" },
			  { "royalblue", "literal" },
			  { "snow", "literal" },
			  { "palegreen", "literal" },
			  { "greenyellow", "literal" },
			  { "saddlebrown", "literal" },
			  { "goldenrod", "literal" },
			  { "plum", "literal" },
			  { "cornsilk", "literal" },
			  { "lavender", "literal" },
			  { "rosybrown", "literal" },
			  { "waitarrow", "literal" },
			  { "powderblue", "literal" },
			  { "darkslateblue", "literal" },
			  { "chocolate", "literal" },
			  { "cadetblue", "literal" },
			  { "yellow", "literal" },
			  { "ghostwhite", "literal" },
			  { "aquamarine", "literal" },
			  { "darkslategray", "literal" },
			  { "mediumpurple", "literal" },
			  { "darksalmon", "literal" },
			  { "pink", "literal" },
			  { "darkkhaki", "literal" },
			  { "mediumslateblue", "literal" },
			  { "cyan", "literal" },
			  { "hand", "literal" },
			  { "purple", "literal" },
			  { "brown", "literal" },
			  { "aqua", "literal" },
			  { "sizenesw", "literal" },
			  { "papayawhip", "literal" },
			  { "darkgoldenrod", "literal" },
			  { "darkslategrey", "literal" },
			  { "nocursor", "literal" },
			  { "blue", "literal" },
			  { "slategray", "literal" },
			  { "bisque", "literal" },
			  { "orangered", "literal" },
			  { "ibeam", "literal" },
			  { "darkorange", "literal" },
			  { "true", "literal" },
			  { "sizens", "literal" },
			  { "magenta", "literal" },
			  { "important", "literal" },
			  { "blanchedalmond", "literal" },
			  { "lightskyblue", "literal" },
			  { "aliceblue", "literal" },
			  { "sizeall", "literal" },
			  { "dimgrey", "literal" },
			  { "crimson", "literal" },
			  { "darkgray", "literal" },
			  { "beige", "literal" },
			  { "lightsalmon", "literal" },
			  { "skyblue", "literal" },
			  { "blueviolet", "literal" },
			  { "none", "literal" },
			  { "sizewe", "literal" },
			  { "deepskyblue", "literal" },
			  { "peru", "literal" },
			  { "dimgray", "literal" },
			  { "mediumvioletred", "literal" },
			  { "floralwhite", "literal" },
			  { "maroon", "literal" },
			  { "palegoldenrod", "literal" },
			  { "forestgreen", "literal" },
			  { "fuchsia", "literal" },
			  { "gainsboro", "literal" },
			  { "lightcyan", "literal" },
			  { "lightgray", "literal" },
			  { "mediumturquoise", "literal" },
			  { "cornflowerblue", "literal" },
			  { "steelblue", "literal" },
			  { "green", "literal" },
			  { "false", "literal" },
			  { "honeydew", "literal" },

		  },
		  "//",
		  {}

		} );
}

}}}} // namespace EE::UI::Doc::Language
