#include <eepp/ui/doc/languages/x86assembly.hpp>
#include <eepp/ui/doc/syntaxdefinitionmanager.hpp>

namespace EE { namespace UI { namespace Doc { namespace Language {

void addX86Assembly() {
	SyntaxDefinitionManager::instance()->add(

		{ "x86 Assembly",
		  { "%.asm$", "%.[sS]$" },
		  {
			  { { ";.-\n" }, "comment" },
			  { { "\"", "\"", "\\" }, "string" },
			  { { "'", "'", "\\" }, "string" },
			  { { "0[bB][0-1]+%W" }, "number" },
			  { { "[0-1]+[bB]%W" }, "number" },
			  { { "0[xX]%x+" }, "number" },
			  { { "%x+[hH]%W" }, "number" },
			  { { "%d+[%d%.eE]*f?" }, "number" },
			  { { "%.?%d+f?" }, "number" },
			  { { "%%+[%a_][%w_]*" }, "keyword" },
			  { { "[%+%-=/%*%^%%<>!~|&%$]" }, "operator" },
			  { { "[%a_][%w_]*:%W" }, "function" },
			  { { "[%a_][%w_]*" }, "symbol" },
			  { { "%.%.%a+" }, "normal" },
			  { { "%s+" }, "normal" },
			  { { "%w+%f[%s]" }, "normal" },

		  },
		  {
			  { "zword", "keyword2" },
			  { "zmm6", "literal" },
			  { "zmm28", "literal" },
			  { "zmm26", "literal" },
			  { "zmm25", "literal" },
			  { "zmm24", "literal" },
			  { "zmm23", "literal" },
			  { "zmm22", "literal" },
			  { "zmm21", "literal" },
			  { "zmm20", "literal" },
			  { "zmm16", "literal" },
			  { "zmm14", "literal" },
			  { "zmm11", "literal" },
			  { "ymm9", "literal" },
			  { "ymm8", "literal" },
			  { "ymm4", "literal" },
			  { "ymm24", "literal" },
			  { "ymm22", "literal" },
			  { "ymm21", "literal" },
			  { "ymm20", "literal" },
			  { "ymm18", "literal" },
			  { "ymm17", "literal" },
			  { "ymm14", "literal" },
			  { "ymm0", "literal" },
			  { "xstore", "keyword" },
			  { "xsha1", "keyword" },
			  { "xsetbv", "keyword" },
			  { "xsaveopt", "keyword" },
			  { "xsave", "keyword" },
			  { "xrstors", "keyword" },
			  { "xrstor64", "keyword" },
			  { "xor", "keyword" },
			  { "xmm30", "literal" },
			  { "xmm26", "literal" },
			  { "xmm23", "literal" },
			  { "xmm21", "literal" },
			  { "xmm20", "literal" },
			  { "xmm2", "literal" },
			  { "xmm19", "literal" },
			  { "xmm17", "literal" },
			  { "xmm16", "literal" },
			  { "xmm15", "literal" },
			  { "xmm13", "literal" },
			  { "xmm11", "literal" },
			  { "xgetbv", "keyword" },
			  { "xcryptofb", "keyword" },
			  { "xchg", "keyword" },
			  { "xbts", "keyword" },
			  { "xbegin", "keyword" },
			  { "xadd", "keyword" },
			  { "xabort", "keyword" },
			  { "wrt", "keyword2" },
			  { "wrshr", "keyword" },
			  { "wrmsr", "keyword" },
			  { "wrfsbase", "keyword" },
			  { "word", "keyword2" },
			  { "wait", "keyword" },
			  { "zmm13", "literal" },
			  { "vxorpd", "keyword" },
			  { "vunpcklpd", "keyword" },
			  { "vunpckhpd", "keyword" },
			  { "vucomisd", "keyword" },
			  { "vtestps", "keyword" },
			  { "vtestpd", "keyword" },
			  { "vsubsd", "keyword" },
			  { "vsubpd", "keyword" },
			  { "vstmxcsr", "keyword" },
			  { "vsqrtss", "keyword" },
			  { "vsqrtsd", "keyword" },
			  { "vshufps", "keyword" },
			  { "xmm6", "literal" },
			  { "vshufpd", "keyword" },
			  { "vshufi64x2", "keyword" },
			  { "vshufi32x4", "keyword" },
			  { "vscatterpf1qps", "keyword" },
			  { "vscatterpf1qpd", "keyword" },
			  { "vscatterpf1dps", "keyword" },
			  { "vscatterpf0dps", "keyword" },
			  { "vscatterpf0dpd", "keyword" },
			  { "vscatterdps", "keyword" },
			  { "vrsqrt28sd", "keyword" },
			  { "vrsqrt28pd", "keyword" },
			  { "vrsqrt14ps", "keyword" },
			  { "vrndscalesd", "keyword" },
			  { "vrndscalepd", "keyword" },
			  { "vreducess", "keyword" },
			  { "vreducesd", "keyword" },
			  { "vrcpss", "keyword" },
			  { "vrcp28ss", "keyword" },
			  { "vrcp14ss", "keyword" },
			  { "vrcp14sd", "keyword" },
			  { "vrcp14ps", "keyword" },
			  { "vrcp14pd", "keyword" },
			  { "vrangesd", "keyword" },
			  { "vrangeps", "keyword" },
			  { "vrangepd", "keyword" },
			  { "vpunpcklwd", "keyword" },
			  { "vpunpcklqdq", "keyword" },
			  { "vpunpckldq", "keyword" },
			  { "vpunpcklbw", "keyword" },
			  { "vpunpckhdq", "keyword" },
			  { "vptestnmd", "keyword" },
			  { "vptestmw", "keyword" },
			  { "zmm18", "literal" },
			  { "vptestmd", "keyword" },
			  { "vpsubusb", "keyword" },
			  { "vpsubsw", "keyword" },
			  { "vpsubsb", "keyword" },
			  { "vpsubq", "keyword" },
			  { "vpsubb", "keyword" },
			  { "vpsrlvw", "keyword" },
			  { "vpsrlvq", "keyword" },
			  { "vpsrlvd", "keyword" },
			  { "vpsrldq", "keyword" },
			  { "vpsrld", "keyword" },
			  { "vpsravq", "keyword" },
			  { "vpsraq", "keyword" },
			  { "vpsllvw", "keyword" },
			  { "vpslld", "keyword" },
			  { "vpshuflw", "keyword" },
			  { "vpshufhw", "keyword" },
			  { "vpshufb", "keyword" },
			  { "vpshlw", "keyword" },
			  { "vpshaw", "keyword" },
			  { "vpshab", "keyword" },
			  { "vpscatterdd", "keyword" },
			  { "vprotw", "keyword" },
			  { "vprorvq", "keyword" },
			  { "vprorvd", "keyword" },
			  { "vprord", "keyword" },
			  { "yword", "keyword2" },
			  { "vprolvq", "keyword" },
			  { "vprolvd", "keyword" },
			  { "ymm7", "literal" },
			  { "vprolq", "keyword" },
			  { "vpperm", "keyword" },
			  { "vporq", "keyword" },
			  { "vpor", "keyword" },
			  { "vpmuludq", "keyword" },
			  { "vpmultishiftqb", "keyword" },
			  { "vpmullw", "keyword" },
			  { "vpmulhrsw", "keyword" },
			  { "vpmuldq", "keyword" },
			  { "vpmovzxwd", "keyword" },
			  { "vpmovzxdq", "keyword" },
			  { "vpmovzxbw", "keyword" },
			  { "vpmovwb", "keyword" },
			  { "vpmovuswb", "keyword" },
			  { "vpmovsxwq", "keyword" },
			  { "vpmovsxbq", "keyword" },
			  { "vpmovsqd", "keyword" },
			  { "vpmovsqb", "keyword" },
			  { "vpmovsdb", "keyword" },
			  { "vpmovqw", "keyword" },
			  { "vpmovqd", "keyword" },
			  { "vpmovq2m", "keyword" },
			  { "vpmovmskb", "keyword" },
			  { "vpmovm2q", "keyword" },
			  { "vpmovm2d", "keyword" },
			  { "vpmovm2b", "keyword" },
			  { "vpmovdb", "keyword" },
			  { "vpunpckhbw", "keyword" },
			  { "vpminsw", "keyword" },
			  { "vpminsd", "keyword" },
			  { "vpminsb", "keyword" },
			  { "vpmaxuw", "keyword" },
			  { "vpmaxuq", "keyword" },
			  { "vpmaxud", "keyword" },
			  { "vpmaxub", "keyword" },
			  { "vpmaskmovd", "keyword" },
			  { "vpmaddubsw", "keyword" },
			  { "vpmadd52luq", "keyword" },
			  { "vpmadd52huq", "keyword" },
			  { "ymm26", "literal" },
			  { "vpmadcswd", "keyword" },
			  { "vpmulld", "keyword" },
			  { "vpmacssww", "keyword" },
			  { "vpmacssdqh", "keyword" },
			  { "vpmacssdd", "keyword" },
			  { "zmm3", "literal" },
			  { "vpmacsdd", "keyword" },
			  { "vplzcntd", "keyword" },
			  { "vpsubusw", "keyword" },
			  { "vpinsrw", "keyword" },
			  { "vpinsrq", "keyword" },
			  { "vpscatterdq", "keyword" },
			  { "vpinsrd", "keyword" },
			  { "vphsubwd", "keyword" },
			  { "vphsubw", "keyword" },
			  { "vphsubsw", "keyword" },
			  { "vphsubdq", "keyword" },
			  { "vphsubbw", "keyword" },
			  { "vpmovusqw", "keyword" },
			  { "vphminposuw", "keyword" },
			  { "vphaddwq", "keyword" },
			  { "ymm2", "literal" },
			  { "vphaddw", "keyword" },
			  { "vphadduwd", "keyword" },
			  { "vphaddubq", "keyword" },
			  { "vphaddubd", "keyword" },
			  { "vphaddsw", "keyword" },
			  { "vphaddd", "keyword" },
			  { "vscalefpd", "keyword" },
			  { "vpmovd2m", "keyword" },
			  { "vpgatherqq", "keyword" },
			  { "vpgatherqd", "keyword" },
			  { "vpgatherdd", "keyword" },
			  { "vpextrw", "keyword" },
			  { "vpextrd", "keyword" },
			  { "vpextrb", "keyword" },
			  { "vpexpandq", "keyword" },
			  { "ymm15", "literal" },
			  { "vpexpandd", "keyword" },
			  { "vpermt2w", "keyword" },
			  { "vpermt2d", "keyword" },
			  { "vsqrtps", "keyword" },
			  { "vpermq", "keyword" },
			  { "vpermps", "keyword" },
			  { "vpermpd", "keyword" },
			  { "xsaveopt64", "keyword" },
			  { "vpermilpd", "keyword" },
			  { "vpermi2w", "keyword" },
			  { "vpmovzxbq", "keyword" },
			  { "vpermi2ps", "keyword" },
			  { "vpermi2d", "keyword" },
			  { "vpermi2b", "keyword" },
			  { "vrndscaleps", "keyword" },
			  { "vperm2f128", "keyword" },
			  { "vpmaskmovq", "keyword" },
			  { "vpconflictq", "keyword" },
			  { "vpconflictd", "keyword" },
			  { "vpcomud", "keyword" },
			  { "zmm17", "literal" },
			  { "vpcompressq", "keyword" },
			  { "vpcomd", "keyword" },
			  { "vpcmpw", "keyword" },
			  { "vpcmpuw", "keyword" },
			  { "vpcmpub", "keyword" },
			  { "vpcmpgtw", "keyword" },
			  { "vpcmpestrm", "keyword" },
			  { "vpcmpestri", "keyword" },
			  { "vpcmpeqq", "keyword" },
			  { "vpcmpeqd", "keyword" },
			  { "vpcmpeqb", "keyword" },
			  { "vpcmpd", "keyword" },
			  { "vpcmov", "keyword" },
			  { "vpbroadcastw", "keyword" },
			  { "vpbroadcastq", "keyword" },
			  { "vpbroadcastmw2d", "keyword" },
			  { "vpbroadcastmb2q", "keyword" },
			  { "vpblendw", "keyword" },
			  { "vpblendmq", "keyword" },
			  { "vpermt2b", "keyword" },
			  { "vpblendmw", "keyword" },
			  { "vpblendmb", "keyword" },
			  { "vpblendd", "keyword" },
			  { "vpavgw", "keyword" },
			  { "vpavgb", "keyword" },
			  { "vpandq", "keyword" },
			  { "xsaves", "keyword" },
			  { "vpandnq", "keyword" },
			  { "vpandn", "keyword" },
			  { "vphadddq", "keyword" },
			  { "vpand", "keyword" },
			  { "vpaddw", "keyword" },
			  { "vpaddusb", "keyword" },
			  { "vpaddsw", "keyword" },
			  { "vpaddq", "keyword" },
			  { "vpaddb", "keyword" },
			  { "vpackuswb", "keyword" },
			  { "vpackusdw", "keyword" },
			  { "ymm28", "literal" },
			  { "vpabsw", "keyword" },
			  { "vpabsq", "keyword" },
			  { "vorps", "keyword" },
			  { "zmm27", "literal" },
			  { "vorpd", "keyword" },
			  { "vpcomw", "keyword" },
			  { "vmwrite", "keyword" },
			  { "vmulsd", "keyword" },
			  { "vmulps", "keyword" },
			  { "vmrun", "keyword" },
			  { "vmresume", "keyword" },
			  { "zmm5", "literal" },
			  { "vpermd", "keyword" },
			  { "vmread", "keyword" },
			  { "vmptrld", "keyword" },
			  { "vmovups", "keyword" },
			  { "vmovsldup", "keyword" },
			  { "vmovqqa", "keyword" },
			  { "vmovq", "keyword" },
			  { "vmovlps", "keyword" },
			  { "vmovhps", "keyword" },
			  { "vphaddwd", "keyword" },
			  { "vmovhpd", "keyword" },
			  { "vmovdqu8", "keyword" },
			  { "vmovdqu64", "keyword" },
			  { "vmovdqu16", "keyword" },
			  { "vmovdqu", "keyword" },
			  { "vpscatterqq", "keyword" },
			  { "vmovdqa32", "keyword" },
			  { "vmovd", "keyword" },
			  { "vmclear", "keyword" },
			  { "vmcall", "keyword" },
			  { "vmaskmovq", "keyword" },
			  { "vmaskmovps", "keyword" },
			  { "vinserti64x2", "keyword" },
			  { "vinsertf64x4", "keyword" },
			  { "vmaskmovpd", "keyword" },
			  { "vinsertf64x2", "keyword" },
			  { "vinsertf32x4", "keyword" },
			  { "vpaddd", "keyword" },
			  { "vhsubps", "keyword" },
			  { "vhsubpd", "keyword" },
			  { "vgetmantps", "keyword" },
			  { "vgetmantpd", "keyword" },
			  { "vgetexpss", "keyword" },
			  { "xmm24", "literal" },
			  { "vgetexpps", "keyword" },
			  { "vgetexppd", "keyword" },
			  { "vpcmpgtb", "keyword" },
			  { "vgatherqps", "keyword" },
			  { "vgatherqpd", "keyword" },
			  { "vpmaxsd", "keyword" },
			  { "vgatherpf1qps", "keyword" },
			  { "vgatherpf1dps", "keyword" },
			  { "vgatherpf1dpd", "keyword" },
			  { "vgatherpf0qps", "keyword" },
			  { "vgatherpf0qpd", "keyword" },
			  { "vgatherdq", "keyword" },
			  { "vgatherdd", "keyword" },
			  { "vfrczsd", "keyword" },
			  { "xlat", "keyword" },
			  { "vfrczps", "keyword" },
			  { "vfrczpd", "keyword" },
			  { "vfpclassss", "keyword" },
			  { "vpshlq", "keyword" },
			  { "vfpclasssd", "keyword" },
			  { "vfpclassps", "keyword" },
			  { "vfnmsubss", "keyword" },
			  { "zmm15", "literal" },
			  { "vfnmsubsd", "keyword" },
			  { "vpclmulhqhqdq", "keyword" },
			  { "vfnmsub321ss", "keyword" },
			  { "zmm9", "literal" },
			  { "vfnmsub321sd", "keyword" },
			  { "vmpsadbw", "keyword" },
			  { "vfnmsub321pd", "keyword" },
			  { "vfnmsub312ps", "keyword" },
			  { "vfnmsub312pd", "keyword" },
			  { "ymm10", "literal" },
			  { "vfnmsub231sd", "keyword" },
			  { "vfnmsub213sd", "keyword" },
			  { "vfnmsub213ps", "keyword" },
			  { "vfnmsub213pd", "keyword" },
			  { "vfnmsub132ss", "keyword" },
			  { "vfnmsub132ps", "keyword" },
			  { "vmovss", "keyword" },
			  { "vinsertps", "keyword" },
			  { "vfnmsub123ss", "keyword" },
			  { "vfnmsub123sd", "keyword" },
			  { "vfnmsub123ps", "keyword" },
			  { "vfnmsub123pd", "keyword" },
			  { "vfnmaddsd", "keyword" },
			  { "vpmovsxdq", "keyword" },
			  { "vfnmaddps", "keyword" },
			  { "vfnmadd321ss", "keyword" },
			  { "vpscatterqd", "keyword" },
			  { "vldqqu", "keyword" },
			  { "vfnmadd321sd", "keyword" },
			  { "vfnmadd321pd", "keyword" },
			  { "vfnmadd312sd", "keyword" },
			  { "vgetmantsd", "keyword" },
			  { "vfnmadd312ps", "keyword" },
			  { "vfnmadd231sd", "keyword" },
			  { "vfnmadd231ps", "keyword" },
			  { "vfnmadd213ss", "keyword" },
			  { "vfrczss", "keyword" },
			  { "vfnmadd213sd", "keyword" },
			  { "vfnmadd213ps", "keyword" },
			  { "ymm27", "literal" },
			  { "vfnmadd213pd", "keyword" },
			  { "vfnmadd132ss", "keyword" },
			  { "vfnmadd132sd", "keyword" },
			  { "vfnmadd123ss", "keyword" },
			  { "vrcp28pd", "keyword" },
			  { "vfnmadd123sd", "keyword" },
			  { "vfnmadd123ps", "keyword" },
			  { "vfnmadd123pd", "keyword" },
			  { "vfmsubss", "keyword" },
			  { "vfmsubsd", "keyword" },
			  { "vfmsubps", "keyword" },
			  { "vfmsubpd", "keyword" },
			  { "vfmsubaddps", "keyword" },
			  { "vfmsubadd321ps", "keyword" },
			  { "vpminud", "keyword" },
			  { "vfmsubadd321pd", "keyword" },
			  { "vfmsubadd312ps", "keyword" },
			  { "vfmsubadd231pd", "keyword" },
			  { "vfmsubadd213pd", "keyword" },
			  { "vfmsubadd132ps", "keyword" },
			  { "vprotd", "keyword" },
			  { "vfmsubadd132pd", "keyword" },
			  { "vfmsubadd123pd", "keyword" },
			  { "vfmsub321ss", "keyword" },
			  { "vfmsubaddpd", "keyword" },
			  { "vfmsub321ps", "keyword" },
			  { "vroundps", "keyword" },
			  { "vfmsub321pd", "keyword" },
			  { "zmm12", "literal" },
			  { "vfmsub312sd", "keyword" },
			  { "vfmsub231sd", "keyword" },
			  { "vfmsub231ps", "keyword" },
			  { "xmm4", "literal" },
			  { "vfmsub213pd", "keyword" },
			  { "vfmsub132ss", "keyword" },
			  { "vfmsub132sd", "keyword" },
			  { "vfmsub132pd", "keyword" },
			  { "vfmsub123ss", "keyword" },
			  { "vpsravd", "keyword" },
			  { "vmovshdup", "keyword" },
			  { "vfmsub123ps", "keyword" },
			  { "vfmaddsubpd", "keyword" },
			  { "vfmaddsub321pd", "keyword" },
			  { "vprorq", "keyword" },
			  { "vfmaddsub312ps", "keyword" },
			  { "vfmaddsub231ps", "keyword" },
			  { "vfmaddsub213ps", "keyword" },
			  { "vfmaddsub132ps", "keyword" },
			  { "vfmaddsub123ps", "keyword" },
			  { "zmm10", "literal" },
			  { "vfmaddsub123pd", "keyword" },
			  { "vfmaddss", "keyword" },
			  { "vfmaddsd", "keyword" },
			  { "vfmaddps", "keyword" },
			  { "vfmaddpd", "keyword" },
			  { "vfmadd321ss", "keyword" },
			  { "vfmadd312ss", "keyword" },
			  { "vfmadd312ps", "keyword" },
			  { "vfmadd231sd", "keyword" },
			  { "vfmadd231pd", "keyword" },
			  { "vscatterpf0qpd", "keyword" },
			  { "vfmadd213ss", "keyword" },
			  { "vpcmpeqw", "keyword" },
			  { "vfmadd213sd", "keyword" },
			  { "vfmadd132ss", "keyword" },
			  { "vfmadd132sd", "keyword" },
			  { "vpsignw", "keyword" },
			  { "vfmadd132ps", "keyword" },
			  { "vfmadd132pd", "keyword" },
			  { "vfmadd123sd", "keyword" },
			  { "vfixupimmsd", "keyword" },
			  { "vfixupimmps", "keyword" },
			  { "vfixupimmpd", "keyword" },
			  { "ymm23", "literal" },
			  { "vextractps", "keyword" },
			  { "vextracti32x8", "keyword" },
			  { "vextracti32x4", "keyword" },
			  { "vextracti128", "keyword" },
			  { "ymm1", "literal" },
			  { "vextractf64x4", "keyword" },
			  { "vfixupimmss", "keyword" },
			  { "vextractf64x2", "keyword" },
			  { "xmm28", "literal" },
			  { "vextractf32x4", "keyword" },
			  { "vexpandps", "keyword" },
			  { "vexp2ps", "keyword" },
			  { "verw", "keyword" },
			  { "vdppd", "keyword" },
			  { "vdivsd", "keyword" },
			  { "vdivps", "keyword" },
			  { "vdivpd", "keyword" },
			  { "vdbpsadbw", "keyword" },
			  { "vcvtusi2ss", "keyword" },
			  { "vcvtuqq2pd", "keyword" },
			  { "vcvtudq2ps", "keyword" },
			  { "vcvtudq2pd", "keyword" },
			  { "vcvttss2usi", "keyword" },
			  { "vcvttss2si", "keyword" },
			  { "vcvttps2uqq", "keyword" },
			  { "vcvttpd2udq", "keyword" },
			  { "vcvttpd2qq", "keyword" },
			  { "vcvttpd2dq", "keyword" },
			  { "vcvtss2usi", "keyword" },
			  { "vcvtsd2usi", "keyword" },
			  { "zmm30", "literal" },
			  { "vcvtsd2ss", "keyword" },
			  { "vcvtsd2si", "keyword" },
			  { "vcvtqq2ps", "keyword" },
			  { "vcvtqq2pd", "keyword" },
			  { "vcvtps2udq", "keyword" },
			  { "vpmaxsb", "keyword" },
			  { "vcvtpd2uqq", "keyword" },
			  { "vcvtpd2udq", "keyword" },
			  { "vcvtpd2ps", "keyword" },
			  { "vcvtpd2dq", "keyword" },
			  { "vpmovusdw", "keyword" },
			  { "vcvtdq2pd", "keyword" },
			  { "vcompresspd", "keyword" },
			  { "vpunpckhqdq", "keyword" },
			  { "vcomiss", "keyword" },
			  { "ymm3", "literal" },
			  { "vcmpunordps", "keyword" },
			  { "vcmpunordpd", "keyword" },
			  { "vcmpunord_sss", "keyword" },
			  { "vcmpunord_ssd", "keyword" },
			  { "vcmpunord_sps", "keyword" },
			  { "vcmpunord_qss", "keyword" },
			  { "vplzcntq", "keyword" },
			  { "vcmpunord_qpd", "keyword" },
			  { "vgatherpf0dps", "keyword" },
			  { "vcmptruesd", "keyword" },
			  { "vpbroadcastb", "keyword" },
			  { "vcmptrueps", "keyword" },
			  { "vcvttps2qq", "keyword" },
			  { "vcmptruepd", "keyword" },
			  { "vpinsrb", "keyword" },
			  { "vcmptrue_usss", "keyword" },
			  { "wbinvd", "keyword" },
			  { "vpxord", "keyword" },
			  { "vcmptrue_usps", "keyword" },
			  { "vcmptrue_uqss", "keyword" },
			  { "vpsubw", "keyword" },
			  { "vcmptrue_uqpd", "keyword" },
			  { "vcmpsd", "keyword" },
			  { "vcmpps", "keyword" },
			  { "vcmpordsd", "keyword" },
			  { "vpmullq", "keyword" },
			  { "vcmpord_sss", "keyword" },
			  { "vpsravw", "keyword" },
			  { "vcmpord_ssd", "keyword" },
			  { "vcmpord_spd", "keyword" },
			  { "vshuff32x4", "keyword" },
			  { "vcmpord_qss", "keyword" },
			  { "vcmpord_qsd", "keyword" },
			  { "vcmpord_qps", "keyword" },
			  { "vcmpnltps", "keyword" },
			  { "vpandnd", "keyword" },
			  { "vcmpnltpd", "keyword" },
			  { "vcmpnlt_ussd", "keyword" },
			  { "vzeroupper", "keyword" },
			  { "vcmpnlt_usps", "keyword" },
			  { "zmm31", "literal" },
			  { "vcmpnlt_uqss", "keyword" },
			  { "vcmpnlt_uqpd", "keyword" },
			  { "vcmpnleps", "keyword" },
			  { "vcmpnlepd", "keyword" },
			  { "vcmpnle_usps", "keyword" },
			  { "xorpd", "keyword" },
			  { "vpermi2q", "keyword" },
			  { "vcmpnle_uspd", "keyword" },
			  { "vcmpngtss", "keyword" },
			  { "vcmpngt_usss", "keyword" },
			  { "vcmpngt_ussd", "keyword" },
			  { "vcmpngt_usps", "keyword" },
			  { "xsha256", "keyword" },
			  { "xend", "keyword" },
			  { "vcmpngt_uspd", "keyword" },
			  { "vcmpngt_uqss", "keyword" },
			  { "vcvtsi2ss", "keyword" },
			  { "vcmpngt_uqsd", "keyword" },
			  { "vcmpngt_uqps", "keyword" },
			  { "vcmpngt_uqpd", "keyword" },
			  { "vcmpngesd", "keyword" },
			  { "vcmpngeps", "keyword" },
			  { "vphsubd", "keyword" },
			  { "vcmpnge_usss", "keyword" },
			  { "vcmpnge_ussd", "keyword" },
			  { "vcmpnge_usps", "keyword" },
			  { "vcmpnge_uqss", "keyword" },
			  { "vcmpneqsd", "keyword" },
			  { "vucomiss", "keyword" },
			  { "vcmpneqps", "keyword" },
			  { "xmm29", "literal" },
			  { "vcmpneqpd", "keyword" },
			  { "vcompressps", "keyword" },
			  { "vcmpneq_usss", "keyword" },
			  { "vcmpneq_ussd", "keyword" },
			  { "vpmovsxwd", "keyword" },
			  { "vcmpneq_uspd", "keyword" },
			  { "vcmpneq_uqss", "keyword" },
			  { "vcmpneq_uqpd", "keyword" },
			  { "vcmpneq_osss", "keyword" },
			  { "ymm30", "literal" },
			  { "vcmpneq_ossd", "keyword" },
			  { "vcmpneq_osps", "keyword" },
			  { "vcmpneq_ospd", "keyword" },
			  { "vcmpneq_oqss", "keyword" },
			  { "vcmpneq_oqpd", "keyword" },
			  { "vcmpltss", "keyword" },
			  { "vcmpltsd", "keyword" },
			  { "vcmpnle_uqss", "keyword" },
			  { "vcmpltpd", "keyword" },
			  { "vcvtss2sd", "keyword" },
			  { "vcmplt_osss", "keyword" },
			  { "vcmplt_ossd", "keyword" },
			  { "vphadduwq", "keyword" },
			  { "vcmplt_osps", "keyword" },
			  { "vfmaddsub321ps", "keyword" },
			  { "vcmplt_ospd", "keyword" },
			  { "vcmplt_oqss", "keyword" },
			  { "vcmpleps", "keyword" },
			  { "vcmplepd", "keyword" },
			  { "vcmple_osss", "keyword" },
			  { "vcmpordps", "keyword" },
			  { "vcmple_ossd", "keyword" },
			  { "vcmple_ospd", "keyword" },
			  { "vcmple_oqsd", "keyword" },
			  { "vcmple_oqps", "keyword" },
			  { "vcmple_oqpd", "keyword" },
			  { "vcmpgtss", "keyword" },
			  { "vcmpgtps", "keyword" },
			  { "vcmpgt_osss", "keyword" },
			  { "vinserti32x4", "keyword" },
			  { "vcmpless", "keyword" },
			  { "vcmpgt_ossd", "keyword" },
			  { "vcmpgt_osps", "keyword" },
			  { "vhaddps", "keyword" },
			  { "vcmpgt_oqsd", "keyword" },
			  { "vpmovdw", "keyword" },
			  { "vcmpgt_oqpd", "keyword" },
			  { "vcmpgeps", "keyword" },
			  { "vpermb", "keyword" },
			  { "vfmsub213sd", "keyword" },
			  { "vcmpge_osss", "keyword" },
			  { "vcmpge_ossd", "keyword" },
			  { "vcmpge_osps", "keyword" },
			  { "vcmpge_ospd", "keyword" },
			  { "vcmpfalsess", "keyword" },
			  { "vcmpss", "keyword" },
			  { "vcmpfalsepd", "keyword" },
			  { "vcmpfalse_ossd", "keyword" },
			  { "vpmovusqd", "keyword" },
			  { "vcmpfalse_osps", "keyword" },
			  { "vrcp28ps", "keyword" },
			  { "vcmpfalse_oqss", "keyword" },
			  { "vcmpfalse_oqsd", "keyword" },
			  { "vcmpfalse_oqpd", "keyword" },
			  { "vcmpeqss", "keyword" },
			  { "xsavec", "keyword" },
			  { "vcmpeqsd", "keyword" },
			  { "vcmpnge_uqsd", "keyword" },
			  { "vcmpeqps", "keyword" },
			  { "vcmpeq_usps", "keyword" },
			  { "vcmpeq_uspd", "keyword" },
			  { "vcmpeq_ossd", "keyword" },
			  { "vcmpfalseps", "keyword" },
			  { "vcmpeq_osps", "keyword" },
			  { "vbroadcastw", "keyword" },
			  { "vbroadcastss", "keyword" },
			  { "vbroadcastsd", "keyword" },
			  { "vbroadcasti64x4", "keyword" },
			  { "vbroadcasti32x4", "keyword" },
			  { "vbroadcasti32x2", "keyword" },
			  { "vmaxsd", "keyword" },
			  { "vbroadcastf64x4", "keyword" },
			  { "vfmadd213pd", "keyword" },
			  { "vbroadcastf64x2", "keyword" },
			  { "vbroadcastf32x4", "keyword" },
			  { "vpmovsqw", "keyword" },
			  { "vbroadcastf32x2", "keyword" },
			  { "vbroadcastf128", "keyword" },
			  { "vcmpfalsesd", "keyword" },
			  { "vcmpeq_osss", "keyword" },
			  { "vbroadcastb", "keyword" },
			  { "vblendvps", "keyword" },
			  { "vblendvpd", "keyword" },
			  { "vblendps", "keyword" },
			  { "vblendpd", "keyword" },
			  { "vandps", "keyword" },
			  { "vandpd", "keyword" },
			  { "vcvtss2si", "keyword" },
			  { "vandnpd", "keyword" },
			  { "valignd", "keyword" },
			  { "vcvtps2ph", "keyword" },
			  { "vaeskeygenassist", "keyword" },
			  { "vroundss", "keyword" },
			  { "vaesimc", "keyword" },
			  { "vaesenclast", "keyword" },
			  { "vaesdec", "keyword" },
			  { "ymm12", "literal" },
			  { "vaddsubps", "keyword" },
			  { "vgatherpf1qpd", "keyword" },
			  { "vaddsubpd", "keyword" },
			  { "vaddss", "keyword" },
			  { "vrsqrt28ps", "keyword" },
			  { "vmovdqa", "keyword" },
			  { "vaddps", "keyword" },
			  { "vaddpd", "keyword" },
			  { "use64", "keyword2" },
			  { "use32", "keyword2" },
			  { "use16", "keyword2" },
			  { "vpabsd", "keyword" },
			  { "unpcklps", "keyword" },
			  { "vphaddbd", "keyword" },
			  { "hint_nop51", "keyword" },
			  { "kandnd", "keyword" },
			  { "maskmovq", "keyword" },
			  { "setpe", "keyword" },
			  { "vfnmsub231ps", "keyword" },
			  { "kaddw", "keyword" },
			  { "kaddq", "keyword" },
			  { "js", "keyword" },
			  { "jns", "keyword" },
			  { "repne", "keyword" },
			  { "blcfill", "keyword" },
			  { "vcvtps2uqq", "keyword" },
			  { "pmulhrwc", "keyword" },
			  { "prefetchwt1", "keyword" },
			  { "vfmsubadd213ps", "keyword" },
			  { "jnl", "keyword" },
			  { "jnge", "keyword" },
			  { "jne", "keyword" },
			  { "jnae", "keyword" },
			  { "xcryptecb", "keyword" },
			  { "vfnmsub132sd", "keyword" },
			  { "kaddd", "keyword" },
			  { "vpermt2ps", "keyword" },
			  { "jge", "keyword" },
			  { "vinserti32x8", "keyword" },
			  { "dt", "keyword2" },
			  { "cmovng", "keyword" },
			  { "setge", "keyword" },
			  { "t1mskc", "keyword" },
			  { "kaddb", "keyword" },
			  { "USE64", "keyword2" },
			  { "sahf", "keyword" },
			  { "setbe", "keyword" },
			  { "vpmacsdqh", "keyword" },
			  { "umov", "keyword" },
			  { "vcmpgess", "keyword" },
			  { "iretq", "keyword" },
			  { "iretd", "keyword" },
			  { "vmovddup", "keyword" },
			  { "vfmsub312pd", "keyword" },
			  { "iret", "keyword" },
			  { "pshuflw", "keyword" },
			  { "ip", "literal" },
			  { "zmm7", "literal" },
			  { "dq", "keyword2" },
			  { "vfmadd321sd", "keyword" },
			  { "cmpnltpd", "keyword" },
			  { "invlpg", "keyword" },
			  { "cmovz", "keyword" },
			  { "int3", "keyword" },
			  { "ymm25", "literal" },
			  { "dz", "keyword2" },
			  { "int03", "keyword" },
			  { "hint_nop37", "keyword" },
			  { "insertq", "keyword" },
			  { "ud1", "keyword" },
			  { "vpcmpgtq", "keyword" },
			  { "vpalignr", "keyword" },
			  { "incbin", "keyword2" },
			  { "jmpe", "keyword" },
			  { "vpcmpq", "keyword" },
			  { "istruc", "keyword2" },
			  { "dd", "keyword2" },
			  { "vinserti64x4", "keyword" },
			  { "vcmpordpd", "keyword" },
			  { "bndmov", "keyword" },
			  { "inc", "keyword" },
			  { "xcryptcfb", "keyword" },
			  { "popcnt", "keyword" },
			  { "kandb", "keyword" },
			  { "pmovsxdq", "keyword" },
			  { "hsubps", "keyword" },
			  { "hint_nop63", "keyword" },
			  { "cmovb", "keyword" },
			  { "hint_nop60", "keyword" },
			  { "vfnmadd231pd", "keyword" },
			  { "skinit", "keyword" },
			  { "hint_nop6", "keyword" },
			  { "hint_nop57", "keyword" },
			  { "hint_nop53", "keyword" },
			  { "vmovlpd", "keyword" },
			  { "vfmaddsub132pd", "keyword" },
			  { "pcmpgtb", "keyword" },
			  { "jnb", "keyword" },
			  { "vpcompressd", "keyword" },
			  { "vfnmsub132pd", "keyword" },
			  { "vfnmadd132ps", "keyword" },
			  { "hint_nop14", "keyword" },
			  { "vmmcall", "keyword" },
			  { "setng", "keyword" },
			  { "rdi", "literal" },
			  { "vpshaq", "keyword" },
			  { "vcmpgtsd", "keyword" },
			  { "hint_nop5", "keyword" },
			  { "vmaskmovdqu", "keyword" },
			  { "vcmptrue_uspd", "keyword" },
			  { "fisub", "keyword" },
			  { "vpmulhuw", "keyword" },
			  { "vpackssdw", "keyword" },
			  { "pblendvb", "keyword" },
			  { "vpmovsxbw", "keyword" },
			  { "hint_nop48", "keyword" },
			  { "vmovntdqa", "keyword" },
			  { "vfnmsub321ps", "keyword" },
			  { "hint_nop52", "keyword" },
			  { "fxrstor", "keyword" },
			  { "cmovnz", "keyword" },
			  { "common", "keyword2" },
			  { "strict", "keyword2" },
			  { "vpcmpistrm", "keyword" },
			  { "jc", "keyword" },
			  { "hint_nop40", "keyword" },
			  { "cvtdq2pd", "keyword" },
			  { "hint_nop39", "keyword" },
			  { "vmovntdq", "keyword" },
			  { "hint_nop34", "keyword" },
			  { "vpermi2pd", "keyword" },
			  { "vmsave", "keyword" },
			  { "phaddw", "keyword" },
			  { "vpmovsdw", "keyword" },
			  { "hint_nop33", "keyword" },
			  { "cmpxchg486", "keyword" },
			  { "vpsadbw", "keyword" },
			  { "rcl", "keyword" },
			  { "vfmadd321pd", "keyword" },
			  { "rsldt", "keyword" },
			  { "hint_nop3", "keyword" },
			  { "cmpltps", "keyword" },
			  { "vcvttpd2uqq", "keyword" },
			  { "hint_nop29", "keyword" },
			  { "vmovntps", "keyword" },
			  { "pi2fd", "keyword" },
			  { "setnge", "keyword" },
			  { "idiv", "keyword" },
			  { "vxorps", "keyword" },
			  { "mm3", "literal" },
			  { "vpsllvq", "keyword" },
			  { "vcmpfalse_osss", "keyword" },
			  { "endstruc", "keyword2" },
			  { "invlpga", "keyword" },
			  { "hint_nop24", "keyword" },
			  { "vpclmullqlqdq", "keyword" },
			  { "hint_nop22", "keyword" },
			  { "vcmpgesd", "keyword" },
			  { "movss", "keyword" },
			  { "hint_nop18", "keyword" },
			  { "pminub", "keyword" },
			  { "hint_nop17", "keyword" },
			  { "xmm1", "literal" },
			  { "vfmadd123pd", "keyword" },
			  { "hint_nop50", "keyword" },
			  { "r8d", "literal" },
			  { "hint_nop1", "keyword" },
			  { "psubsw", "keyword" },
			  { "pmovsxwd", "keyword" },
			  { "haddps", "keyword" },
			  { "getsec", "keyword" },
			  { "jo", "keyword" },
			  { "vsubps", "keyword" },
			  { "hsubpd", "keyword" },
			  { "psrlq", "keyword" },
			  { "section", "keyword2" },
			  { "xrstor", "keyword" },
			  { "fyl2xp1", "keyword" },
			  { "cvtsd2ss", "keyword" },
			  { "fxsave", "keyword" },
			  { "vdpps", "keyword" },
			  { "pfmul", "keyword" },
			  { "fprem1", "keyword" },
			  { "fxrstor64", "keyword" },
			  { "rdm", "keyword" },
			  { "lods", "keyword" },
			  { "fsubrp", "keyword" },
			  { "fsubr", "keyword" },
			  { "hint_nop10", "keyword" },
			  { "hint_nop58", "keyword" },
			  { "fsub", "keyword" },
			  { "vpshad", "keyword" },
			  { "vfnmsub312ss", "keyword" },
			  { "dword", "keyword2" },
			  { "movups", "keyword" },
			  { "vroundsd", "keyword" },
			  { "fstsw", "keyword" },
			  { "fscale", "keyword" },
			  { "pand", "keyword" },
			  { "dec", "keyword" },
			  { "bsf", "keyword" },
			  { "fprem", "keyword" },
			  { "fnstcw", "keyword" },
			  { "vscatterqpd", "keyword" },
			  { "sysret", "keyword" },
			  { "fxtract", "keyword" },
			  { "cvtps2pi", "keyword" },
			  { "setz", "keyword" },
			  { "kxnord", "keyword" },
			  { "vcmplt_oqps", "keyword" },
			  { "vandnps", "keyword" },
			  { "__BITS__", "keyword2" },
			  { "fldln2", "keyword" },
			  { "fldl2t", "keyword" },
			  { "fldenv", "keyword" },
			  { "movntps", "keyword" },
			  { "kxnorb", "keyword" },
			  { "vpminuq", "keyword" },
			  { "fld", "keyword" },
			  { "vextracti64x2", "keyword" },
			  { "cwd", "keyword" },
			  { "hint_nop38", "keyword" },
			  { "fisubr", "keyword" },
			  { "cvtpi2ps", "keyword" },
			  { "vmxoff", "keyword" },
			  { "test", "keyword" },
			  { "fimul", "keyword" },
			  { "ficomp", "keyword" },
			  { "vfnmadd312ss", "keyword" },
			  { "fiadd", "keyword" },
			  { "vpmaddwd", "keyword" },
			  { "ffree", "keyword" },
			  { "__NASM_MINOR__", "keyword2" },
			  { "jnbe", "keyword" },
			  { "vextracti64x4", "keyword" },
			  { "pfadd", "keyword" },
			  { "fyl2x", "keyword" },
			  { "fdivp", "keyword" },
			  { "cx", "literal" },
			  { "xmm14", "literal" },
			  { "fsincos", "keyword" },
			  { "vcmpnlt_uqps", "keyword" },
			  { "fmulp", "keyword" },
			  { "cmpnleps", "keyword" },
			  { "prefetchnta", "keyword" },
			  { "xcryptcbc", "keyword" },
			  { "vrsqrtps", "keyword" },
			  { "fcompp", "keyword" },
			  { "fcomip", "keyword" },
			  { "jp", "keyword" },
			  { "fsetpm", "keyword" },
			  { "fcomi", "keyword" },
			  { "xmm22", "literal" },
			  { "push", "keyword" },
			  { "vcmpge_oqss", "keyword" },
			  { "fnsave", "keyword" },
			  { "fcmovnu", "keyword" },
			  { "ymm16", "literal" },
			  { "vmaxps", "keyword" },
			  { "rdgsbase", "keyword" },
			  { "vcmpnle_uqps", "keyword" },
			  { "vcmpnle_uqpd", "keyword" },
			  { "seto", "keyword" },
			  { "jno", "keyword" },
			  { "fcmovbe", "keyword" },
			  { "hint_nop25", "keyword" },
			  { "punpcklbw", "keyword" },
			  { "faddp", "keyword" },
			  { "__LINE__", "keyword2" },
			  { "popfd", "keyword" },
			  { "vpcomuw", "keyword" },
			  { "vbroadcasti128", "keyword" },
			  { "fabs", "keyword" },
			  { "aas", "keyword" },
			  { "f2xm1", "keyword" },
			  { "xsavec64", "keyword" },
			  { "retf", "keyword" },
			  { "aesenclast", "keyword" },
			  { "vpsrlq", "keyword" },
			  { "vcmpngess", "keyword" },
			  { "fxsave64", "keyword" },
			  { "extrq", "keyword" },
			  { "xmm27", "literal" },
			  { "esp", "literal" },
			  { "adc", "keyword" },
			  { "st5", "literal" },
			  { "vextractf128", "keyword" },
			  { "equ", "keyword2" },
			  { "vpbroadcastd", "keyword" },
			  { "vminss", "keyword" },
			  { "hint_nop54", "keyword" },
			  { "paddw", "keyword" },
			  { "pfpnacc", "keyword" },
			  { "r13", "literal" },
			  { "vcvttps2udq", "keyword" },
			  { "enter", "keyword" },
			  { "vpminsq", "keyword" },
			  { "vpcomuq", "keyword" },
			  { "hlt", "keyword" },
			  { "vpcmpud", "keyword" },
			  { "hint_nop2", "keyword" },
			  { "vmxon", "keyword" },
			  { "pmulhuw", "keyword" },
			  { "r10d", "literal" },
			  { "emms", "keyword" },
			  { "cmpsd", "keyword" },
			  { "fldcw", "keyword" },
			  { "pmvnzb", "keyword" },
			  { "vcmple_oqss", "keyword" },
			  { "hint_nop15", "keyword" },
			  { "ecx", "literal" },
			  { "dy", "keyword2" },
			  { "vbroadcastd", "keyword" },
			  { "movdq2q", "keyword" },
			  { "vcmplt_oqpd", "keyword" },
			  { "paddusw", "keyword" },
			  { "vpclmullqhqdq", "keyword" },
			  { "ja", "keyword" },
			  { "vpcomb", "keyword" },
			  { "hint_nop62", "keyword" },
			  { "loope", "keyword" },
			  { "vscatterdpd", "keyword" },
			  { "vbroadcastf32x8", "keyword" },
			  { "maxss", "keyword" },
			  { "vpmaxsq", "keyword" },
			  { "hint_nop36", "keyword" },
			  { "blendpd", "keyword" },
			  { "dw", "keyword2" },
			  { "maxpd", "keyword" },
			  { "xmm31", "literal" },
			  { "vblendmpd", "keyword" },
			  { "fstp", "keyword" },
			  { "vscatterpf1dpd", "keyword" },
			  { "vmovhlps", "keyword" },
			  { "bndstx", "keyword" },
			  { "cmpneqss", "keyword" },
			  { "vfmaddsubps", "keyword" },
			  { "dr6", "literal" },
			  { "ymm29", "literal" },
			  { "bb1_reset", "keyword" },
			  { "rdtsc", "keyword" },
			  { "xmm9", "literal" },
			  { "vldmxcsr", "keyword" },
			  { "fpatan", "keyword" },
			  { "vcvtdq2ps", "keyword" },
			  { "dr3", "literal" },
			  { "rcr", "keyword" },
			  { "cmovc", "keyword" },
			  { "vpmacssdql", "keyword" },
			  { "cmovbe", "keyword" },
			  { "vminsd", "keyword" },
			  { "std", "keyword" },
			  { "cqo", "keyword" },
			  { "ebx", "literal" },
			  { "vcmpnltsd", "keyword" },
			  { "bl", "literal" },
			  { "cmova", "keyword" },
			  { "vpshufd", "keyword" },
			  { "fbld", "keyword" },
			  { "bzhi", "keyword" },
			  { "ptr", "keyword2" },
			  { "fdisi", "keyword" },
			  { "cmplepd", "keyword" },
			  { "vpshld", "keyword" },
			  { "pfrsqrtv", "keyword" },
			  { "vunpcklps", "keyword" },
			  { "bpl", "literal" },
			  { "vcmpnle_usss", "keyword" },
			  { "fndisi", "keyword" },
			  { "cmpnless", "keyword" },
			  { "vpabsb", "keyword" },
			  { "ABSOLUTE", "keyword2" },
			  { "rsdc", "keyword" },
			  { "addsubps", "keyword" },
			  { "popa", "keyword" },
			  { "hint_nop16", "keyword" },
			  { "cld", "keyword" },
			  { "vrndscaless", "keyword" },
			  { "addps", "keyword" },
			  { "pinsrb", "keyword" },
			  { "kmovw", "keyword" },
			  { "vptestnmb", "keyword" },
			  { "clc", "keyword" },
			  { "vprold", "keyword" },
			  { "clac", "keyword" },
			  { "cbw", "keyword" },
			  { "icebp", "keyword" },
			  { "dr1", "literal" },
			  { "r11d", "literal" },
			  { "vgatherqd", "keyword" },
			  { "insw", "keyword" },
			  { "cmpeqpd", "keyword" },
			  { "pmaddwd", "keyword" },
			  { "vcmpneq_oqsd", "keyword" },
			  { "cmpps", "keyword" },
			  { "fcmovnbe", "keyword" },
			  { "stac", "keyword" },
			  { "xrstors64", "keyword" },
			  { "vfmsub312ss", "keyword" },
			  { "aaa", "keyword" },
			  { "psadbw", "keyword" },
			  { "vmaxpd", "keyword" },
			  { "ud0", "keyword" },
			  { "movq2dq", "keyword" },
			  { "eax", "literal" },
			  { "bts", "keyword" },
			  { "movlps", "keyword" },
			  { "cmpnlepd", "keyword" },
			  { "packsswb", "keyword" },
			  { "xmm18", "literal" },
			  { "btr", "keyword" },
			  { "blsfill", "keyword" },
			  { "vrsqrt14pd", "keyword" },
			  { "bswap", "keyword" },
			  { "vfmaddsub231pd", "keyword" },
			  { "feni", "keyword" },
			  { "alignb", "keyword2" },
			  { "vptest", "keyword" },
			  { "vcmpneq_uqps", "keyword" },
			  { "phsubw", "keyword" },
			  { "loadall286", "keyword" },
			  { "cmpunordps", "keyword" },
			  { "fdivr", "keyword" },
			  { "vcmpeq_ospd", "keyword" },
			  { "minps", "keyword" },
			  { "xsave64", "keyword" },
			  { "edi", "literal" },
			  { "vinserti128", "keyword" },
			  { "psignb", "keyword" },
			  { "bndcl", "keyword" },
			  { "hint_nop13", "keyword" },
			  { "blsr", "keyword" },
			  { "fnop", "keyword" },
			  { "fxam", "keyword" },
			  { "ktestw", "keyword" },
			  { "sets", "keyword" },
			  { "vpord", "keyword" },
			  { "SEGMENT", "keyword2" },
			  { "fcomp", "keyword" },
			  { "absolute", "keyword2" },
			  { "jnp", "keyword" },
			  { "fdiv", "keyword" },
			  { "vcmpnge_uspd", "keyword" },
			  { "fptan", "keyword" },
			  { "lss", "keyword" },
			  { "vpermt2pd", "keyword" },
			  { "vcmpunordsd", "keyword" },
			  { "phaddd", "keyword" },
			  { "cmc", "keyword" },
			  { "ch", "literal" },
			  { "vcmpneq_uqsd", "keyword" },
			  { "cmpneqps", "keyword" },
			  { "vsubss", "keyword" },
			  { "vfmsub231pd", "keyword" },
			  { "cdq", "keyword" },
			  { "dl", "literal" },
			  { "hint_nop4", "keyword" },
			  { "clgi", "keyword" },
			  { "vfnmsub213ss", "keyword" },
			  { "clts", "keyword" },
			  { "lodsw", "keyword" },
			  { "swapgs", "keyword" },
			  { "bndcu", "keyword" },
			  { "in", "keyword" },
			  { "sfence", "keyword" },
			  { "jcc", "keyword" },
			  { "vfmsubadd123ps", "keyword" },
			  { "rip", "literal" },
			  { "bh", "literal" },
			  { "vcmpge_oqsd", "keyword" },
			  { "lock", "keyword" },
			  { "frstor", "keyword" },
			  { "vpermt2q", "keyword" },
			  { "lzcnt", "keyword" },
			  { "vpmovzxwq", "keyword" },
			  { "cvttps2pi", "keyword" },
			  { "ax", "literal" },
			  { "psrldq", "keyword" },
			  { "vmulpd", "keyword" },
			  { "jz", "keyword" },
			  { "fincstp", "keyword" },
			  { "fbstp", "keyword" },
			  { "cli", "keyword" },
			  { "cl", "literal" },
			  { "hint_nop56", "keyword" },
			  { "vpshlb", "keyword" },
			  { "sar", "keyword" },
			  { "__NASM_MAJOR__", "keyword2" },
			  { "pfcmpeq", "keyword" },
			  { "cvttpd2dq", "keyword" },
			  { "vaddsd", "keyword" },
			  { "SECTION", "keyword2" },
			  { "hint_nop0", "keyword" },
			  { "finit", "keyword" },
			  { "setc", "keyword" },
			  { "vrsqrt28ss", "keyword" },
			  { "st1", "literal" },
			  { "__NASM_SUBMINOR__", "keyword2" },
			  { "salc", "keyword" },
			  { "hint_nop55", "keyword" },
			  { "hint_nop61", "keyword" },
			  { "al", "literal" },
			  { "xorps", "keyword" },
			  { "vgatherqq", "keyword" },
			  { "jnle", "keyword" },
			  { "dr7", "literal" },
			  { "hint_nop42", "keyword" },
			  { "vfmsub312ps", "keyword" },
			  { "hint_nop45", "keyword" },
			  { "pmovzxwd", "keyword" },
			  { "ltr", "keyword" },
			  { "imul", "keyword" },
			  { "vpclmulhqlqdq", "keyword" },
			  { "blendps", "keyword" },
			  { "cvtsi2ss", "keyword" },
			  { "fcom", "keyword" },
			  { "insd", "keyword" },
			  { "hint_nop44", "keyword" },
			  { "setns", "keyword" },
			  { "..plt", "keyword2" },
			  { "fstenv", "keyword" },
			  { "pmovsxbw", "keyword" },
			  { "dr2", "literal" },
			  { "bndcn", "keyword" },
			  { "kandd", "keyword" },
			  { "resq", "keyword2" },
			  { "fclex", "keyword" },
			  { "cvtsi2sd", "keyword" },
			  { "punpcklwd", "keyword" },
			  { "vcmpnlt_uqsd", "keyword" },
			  { "into", "keyword" },
			  { "cmovpe", "keyword" },
			  { "vpacksswb", "keyword" },
			  { "psubusw", "keyword" },
			  { "cpu_write", "keyword" },
			  { "vcmppd", "keyword" },
			  { "pshufhw", "keyword" },
			  { "sub", "keyword" },
			  { "SEG", "keyword2" },
			  { "vcmptrue_ussd", "keyword" },
			  { "cmovp", "keyword" },
			  { "cmpltpd", "keyword" },
			  { "addsd", "keyword" },
			  { "vcvtpd2qq", "keyword" },
			  { "pmachriw", "keyword" },
			  { "fsin", "keyword" },
			  { "hint_nop21", "keyword" },
			  { "vcmpgt_oqps", "keyword" },
			  { "__NASM_VER__", "keyword2" },
			  { "dpps", "keyword" },
			  { "sarx", "keyword" },
			  { "cmovna", "keyword" },
			  { "jrcxz", "keyword" },
			  { "fidivr", "keyword" },
			  { "vmload", "keyword" },
			  { "bound", "keyword" },
			  { "mm2", "literal" },
			  { "xmm8", "literal" },
			  { "psubw", "keyword" },
			  { "hint_nop47", "keyword" },
			  { "psraw", "keyword" },
			  { "cvtpd2dq", "keyword" },
			  { "cr1", "literal" },
			  { "int1", "keyword" },
			  { "bt", "keyword" },
			  { "llwpcb", "keyword" },
			  { "fucompp", "keyword" },
			  { "vpmacswd", "keyword" },
			  { "jae", "keyword" },
			  { "fnclex", "keyword" },
			  { "setnp", "keyword" },
			  { "USE16", "keyword2" },
			  { "kortestq", "keyword" },
			  { "fcmovb", "keyword" },
			  { "blcmsk", "keyword" },
			  { "lds", "keyword" },
			  { "andpd", "keyword" },
			  { "ymm5", "literal" },
			  { "vcmpgt_oqss", "keyword" },
			  { "cmovnle", "keyword" },
			  { "vfnmsub231pd", "keyword" },
			  { "blsmsk", "keyword" },
			  { "pcmpeqb", "keyword" },
			  { "__NASM_VERSION_ID__", "keyword2" },
			  { "movsldup", "keyword" },
			  { "xmm3", "literal" },
			  { "vblendmps", "keyword" },
			  { "cmovg", "keyword" },
			  { "vphaddudq", "keyword" },
			  { "invpcid", "keyword" },
			  { "IEND", "keyword2" },
			  { "vdivss", "keyword" },
			  { "vcmpngtsd", "keyword" },
			  { "vcmpeqpd", "keyword" },
			  { "andnps", "keyword" },
			  { "vpmacsdql", "keyword" },
			  { "fldlg2", "keyword" },
			  { "vfnmsub231ss", "keyword" },
			  { "setno", "keyword" },
			  { "EXTERN", "keyword2" },
			  { "vfmadd321ps", "keyword" },
			  { "call", "keyword" },
			  { "ebp", "literal" },
			  { "lwpval", "keyword" },
			  { "jpo", "keyword" },
			  { "STRICT", "keyword2" },
			  { "at", "keyword2" },
			  { "vcmpgt_ospd", "keyword" },
			  { "pfsub", "keyword" },
			  { "vzeroall", "keyword" },
			  { "vfnmadd321ps", "keyword" },
			  { "r12w", "literal" },
			  { "bb0_reset", "keyword" },
			  { "vcmpneq_usps", "keyword" },
			  { "clflush", "keyword" },
			  { "maxsd", "keyword" },
			  { "hint_nop8", "keyword" },
			  { "eip", "literal" },
			  { "addsubpd", "keyword" },
			  { "fucom", "keyword" },
			  { "fxch", "keyword" },
			  { "monitorx", "keyword" },
			  { "cr4", "literal" },
			  { "ibts", "keyword" },
			  { "pminsd", "keyword" },
			  { "fninit", "keyword" },
			  { "mwaitx", "keyword" },
			  { "hint_nop20", "keyword" },
			  { "scasd", "keyword" },
			  { "rax", "literal" },
			  { "bsr", "keyword" },
			  { "cdqe", "keyword" },
			  { "divss", "keyword" },
			  { "vgetexpsd", "keyword" },
			  { "vcvtps2qq", "keyword" },
			  { "lwpins", "keyword" },
			  { "cvttps2dq", "keyword" },
			  { "fsave", "keyword" },
			  { "vmovntpd", "keyword" },
			  { "montmul", "keyword" },
			  { "pfrcp", "keyword" },
			  { "vcmpnlt_uspd", "keyword" },
			  { "vcmple_osps", "keyword" },
			  { "cmpnltss", "keyword" },
			  { "cmovne", "keyword" },
			  { "vprotb", "keyword" },
			  { "fild", "keyword" },
			  { "fnstsw", "keyword" },
			  { "pcmpgtw", "keyword" },
			  { "hint_nop28", "keyword" },
			  { "cmpordpd", "keyword" },
			  { "paddusb", "keyword" },
			  { "adox", "keyword" },
			  { "GLOBAL", "keyword2" },
			  { "prefetcht1", "keyword" },
			  { "fmul", "keyword" },
			  { "ud2b", "keyword" },
			  { "add", "keyword" },
			  { "roundsd", "keyword" },
			  { "shufpd", "keyword" },
			  { "blendvps", "keyword" },
			  { "vpminuw", "keyword" },
			  { "vinsertf32x8", "keyword" },
			  { "rsi", "literal" },
			  { "ORG", "keyword2" },
			  { "vminpd", "keyword" },
			  { "setb", "keyword" },
			  { "pcmpistri", "keyword" },
			  { "fisttp", "keyword" },
			  { "fcmovu", "keyword" },
			  { "jecxz", "keyword" },
			  { "blcic", "keyword" },
			  { "fwait", "keyword" },
			  { "hint_nop49", "keyword" },
			  { "aeskeygenassist", "keyword" },
			  { "hint_nop35", "keyword" },
			  { "vreducepd", "keyword" },
			  { "cmpltss", "keyword" },
			  { "ds", "literal" },
			  { "cmpunordpd", "keyword" },
			  { "vrsqrt14sd", "keyword" },
			  { "dx", "literal" },
			  { "sal", "keyword" },
			  { "iend", "keyword2" },
			  { "fistp", "keyword" },
			  { "rdpmc", "keyword" },
			  { "repnz", "keyword" },
			  { "vpsignb", "keyword" },
			  { "vfmsubadd312pd", "keyword" },
			  { "align", "keyword2" },
			  { "blsic", "keyword" },
			  { "vfnmadd231ss", "keyword" },
			  { "fld1", "keyword" },
			  { "fst", "keyword" },
			  { "vcmpunordss", "keyword" },
			  { "aesenc", "keyword" },
			  { "vfmadd231ss", "keyword" },
			  { "and", "keyword" },
			  { "ymm31", "literal" },
			  { "pinsrw", "keyword" },
			  { "vfmsub213ps", "keyword" },
			  { "vcvtph2ps", "keyword" },
			  { "comiss", "keyword" },
			  { "rdshr", "keyword" },
			  { "rep", "keyword" },
			  { "vcmpfalse_oqps", "keyword" },
			  { "tword", "keyword2" },
			  { "blci", "keyword" },
			  { "vpminub", "keyword" },
			  { "cmove", "keyword" },
			  { "pmovsxbq", "keyword" },
			  { "jbe", "keyword" },
			  { "xtest", "keyword" },
			  { "hint_nop41", "keyword" },
			  { "hint_nop31", "keyword" },
			  { "zmm0", "literal" },
			  { "xmm10", "literal" },
			  { "rcx", "literal" },
			  { "vpslldq", "keyword" },
			  { "vfmaddsub312pd", "keyword" },
			  { "cmovl", "keyword" },
			  { "movs", "keyword" },
			  { "cmovnbe", "keyword" },
			  { "mov", "keyword" },
			  { "cmovnc", "keyword" },
			  { "divsd", "keyword" },
			  { "jnc", "keyword" },
			  { "fneni", "keyword" },
			  { "cmovnp", "keyword" },
			  { "fsqrt", "keyword" },
			  { "es", "literal" },
			  { "movnti", "keyword" },
			  { "bndmk", "keyword" },
			  { "pcommit", "keyword" },
			  { "bx", "literal" },
			  { "vcmpeq_usss", "keyword" },
			  { "cmovnl", "keyword" },
			  { "comisd", "keyword" },
			  { "cmpsq", "keyword" },
			  { "vpermw", "keyword" },
			  { "vcmpnge_uqpd", "keyword" },
			  { "hint_nop32", "keyword" },
			  { "vcmpge_oqps", "keyword" },
			  { "do", "keyword2" },
			  { "pextrb", "keyword" },
			  { "default", "keyword2" },
			  { "esi", "literal" },
			  { "cvtps2dq", "keyword" },
			  { "vfmsub213ss", "keyword" },
			  { "pfrsqrt", "keyword" },
			  { "cmovo", "keyword" },
			  { "cmpunordss", "keyword" },
			  { "cmovpo", "keyword" },
			  { "palignr", "keyword" },
			  { "jna", "keyword" },
			  { "fchs", "keyword" },
			  { "hint_nop7", "keyword" },
			  { "pcmpistrm", "keyword" },
			  { "vpternlogq", "keyword" },
			  { "resb", "keyword2" },
			  { "bp", "literal" },
			  { "vfmsubadd231ps", "keyword" },
			  { "edx", "literal" },
			  { "movhlps", "keyword" },
			  { "r15w", "literal" },
			  { "ficom", "keyword" },
			  { "vcomisd", "keyword" },
			  { "stmxcsr", "keyword" },
			  { "mm6", "literal" },
			  { "vpcmpb", "keyword" },
			  { "phsubsw", "keyword" },
			  { "cmpeqsd", "keyword" },
			  { "vlddqu", "keyword" },
			  { "pmaxsw", "keyword" },
			  { "femms", "keyword" },
			  { "shlx", "keyword" },
			  { "cmpeqss", "keyword" },
			  { "hint_nop23", "keyword" },
			  { "hint_nop9", "keyword" },
			  { "cmpneqsd", "keyword" },
			  { "cmpleps", "keyword" },
			  { "DEFAULT", "keyword2" },
			  { "global", "keyword2" },
			  { "vpmovm2w", "keyword" },
			  { "vcmptruess", "keyword" },
			  { "pmovzxbw", "keyword" },
			  { "fstcw", "keyword" },
			  { "aesimc", "keyword" },
			  { "dh", "literal" },
			  { "andnpd", "keyword" },
			  { "cvtpd2ps", "keyword" },
			  { "fucomi", "keyword" },
			  { "cmpless", "keyword" },
			  { "cmovno", "keyword" },
			  { "vsqrtpd", "keyword" },
			  { "cmpltsd", "keyword" },
			  { "vcmpunord_spd", "keyword" },
			  { "aad", "keyword" },
			  { "fucomip", "keyword" },
			  { "jpe", "keyword" },
			  { "ymm6", "literal" },
			  { "vcmpngepd", "keyword" },
			  { "cmovae", "keyword" },
			  { "cmpxchg16b", "keyword" },
			  { "vmovmskpd", "keyword" },
			  { "vfmadd123ps", "keyword" },
			  { "vexpandpd", "keyword" },
			  { "cmpnlesd", "keyword" },
			  { "clflushopt", "keyword" },
			  { "cmpnltsd", "keyword" },
			  { "paddsiw", "keyword" },
			  { "fcmove", "keyword" },
			  { "kmovd", "keyword" },
			  { "fist", "keyword" },
			  { "cwde", "keyword" },
			  { "bndldx", "keyword" },
			  { "vreduceps", "keyword" },
			  { "das", "keyword" },
			  { "vpmadcsswd", "keyword" },
			  { "kxorq", "keyword" },
			  { "cmovs", "keyword" },
			  { "movlhps", "keyword" },
			  { "vfmsub123pd", "keyword" },
			  { "cmpordsd", "keyword" },
			  { "vpextrq", "keyword" },
			  { "vmovntqq", "keyword" },
			  { "pblendw", "keyword" },
			  { "r13b", "literal" },
			  { "vperm2i128", "keyword" },
			  { "cmpss", "keyword" },
			  { "vgatherdps", "keyword" },
			  { "cmpsb", "keyword" },
			  { "sqrtsd", "keyword" },
			  { "ktestd", "keyword" },
			  { "aesdec", "keyword" },
			  { "vfmsub123sd", "keyword" },
			  { "cmpunordsd", "keyword" },
			  { "cmpnltps", "keyword" },
			  { "ptest", "keyword" },
			  { "xcryptctr", "keyword" },
			  { "ret", "keyword" },
			  { "vrcp28sd", "keyword" },
			  { "cmpordss", "keyword" },
			  { "insb", "keyword" },
			  { "fucomp", "keyword" },
			  { "vptestmb", "keyword" },
			  { "vmfunc", "keyword" },
			  { "..got", "keyword2" },
			  { "xmm7", "literal" },
			  { "vpcmpuq", "keyword" },
			  { "movntpd", "keyword" },
			  { "cmppd", "keyword" },
			  { "vcmpnlesd", "keyword" },
			  { "cpu_read", "keyword" },
			  { "cmps", "keyword" },
			  { "cmp", "keyword" },
			  { "jle", "keyword" },
			  { "vfpclasspd", "keyword" },
			  { "cvtsd2si", "keyword" },
			  { "vpsrlw", "keyword" },
			  { "r9w", "literal" },
			  { "fdecstp", "keyword" },
			  { "je", "keyword" },
			  { "fs", "literal" },
			  { "USE32", "keyword2" },
			  { "cmovle", "keyword" },
			  { "jng", "keyword" },
			  { "hint_nop59", "keyword" },
			  { "vrangess", "keyword" },
			  { "cmpneqpd", "keyword" },
			  { "cpuid", "keyword" },
			  { "cmovge", "keyword" },
			  { "pmvgezb", "keyword" },
			  { "pushf", "keyword" },
			  { "vfmaddsub213pd", "keyword" },
			  { "hint_nop46", "keyword" },
			  { "cr2", "literal" },
			  { "cr3", "literal" },
			  { "zmm19", "literal" },
			  { "cs", "literal" },
			  { "vptestmq", "keyword" },
			  { "cvttpd2pi", "keyword" },
			  { "rsp", "literal" },
			  { "cvtdq2ps", "keyword" },
			  { "vcmpgepd", "keyword" },
			  { "ftst", "keyword" },
			  { "cvttsd2si", "keyword" },
			  { "aesdeclast", "keyword" },
			  { "si", "literal" },
			  { "ffreep", "keyword" },
			  { "cvtpd2pi", "keyword" },
			  { "rdmsr", "keyword" },
			  { "haddpd", "keyword" },
			  { "cvtss2sd", "keyword" },
			  { "punpcklqdq", "keyword" },
			  { "vpmovzxbd", "keyword" },
			  { "fldz", "keyword" },
			  { "blcs", "keyword" },
			  { "pfacc", "keyword" },
			  { "cvttss2si", "keyword" },
			  { "vfnmadd132pd", "keyword" },
			  { "cmovnb", "keyword" },
			  { "mul", "keyword" },
			  { "movdqu", "keyword" },
			  { "ymm11", "literal" },
			  { "vscatterpf0qps", "keyword" },
			  { "vfnmsubpd", "keyword" },
			  { "adcx", "keyword" },
			  { "daa", "keyword" },
			  { "vfnmaddpd", "keyword" },
			  { "byte", "keyword2" },
			  { "knotq", "keyword" },
			  { "vprotq", "keyword" },
			  { "db", "keyword2" },
			  { "di", "literal" },
			  { "pdep", "keyword" },
			  { "dil", "literal" },
			  { "div", "keyword" },
			  { "divpd", "keyword" },
			  { "divps", "keyword" },
			  { "ror", "keyword" },
			  { "r14d", "literal" },
			  { "fnwait", "keyword" },
			  { "andn", "keyword" },
			  { "vpcomub", "keyword" },
			  { "invvpid", "keyword" },
			  { "bits", "keyword2" },
			  { "dmint", "keyword" },
			  { "r9", "literal" },
			  { "resd", "keyword2" },
			  { "vscatterqps", "keyword" },
			  { "vfmadd123ss", "keyword" },
			  { "kandnw", "keyword" },
			  { "vfmsub231ss", "keyword" },
			  { "kandq", "keyword" },
			  { "vcmpneq_oqps", "keyword" },
			  { "lfs", "keyword" },
			  { "kmovb", "keyword" },
			  { "vgetmantss", "keyword" },
			  { "vcmplt_oqsd", "keyword" },
			  { "pmullw", "keyword" },
			  { "kmovq", "keyword" },
			  { "pmovmskb", "keyword" },
			  { "knotb", "keyword" },
			  { "vptestnmq", "keyword" },
			  { "knotd", "keyword" },
			  { "fldpi", "keyword" },
			  { "knotw", "keyword" },
			  { "vfnmsubps", "keyword" },
			  { "kandnq", "keyword" },
			  { "dr0", "literal" },
			  { "korb", "keyword" },
			  { "vpaddsb", "keyword" },
			  { "vmptrst", "keyword" },
			  { "pmaxud", "keyword" },
			  { "cvtps2pd", "keyword" },
			  { "r15", "literal" },
			  { "vpsrad", "keyword" },
			  { "vpmacsswd", "keyword" },
			  { "kord", "keyword" },
			  { "korq", "keyword" },
			  { "kunpckdq", "keyword" },
			  { "r13d", "literal" },
			  { "kortestd", "keyword" },
			  { "lfence", "keyword" },
			  { "kortestw", "keyword" },
			  { "korw", "keyword" },
			  { "vcmpnlt_usss", "keyword" },
			  { "btc", "keyword" },
			  { "movapd", "keyword" },
			  { "kshiftlb", "keyword" },
			  { "lidt", "keyword" },
			  { "mwait", "keyword" },
			  { "kshiftlq", "keyword" },
			  { "pmulhriw", "keyword" },
			  { "vpmulhw", "keyword" },
			  { "hint_nop43", "keyword" },
			  { "kshiftlw", "keyword" },
			  { "vaesenc", "keyword" },
			  { "lgs", "keyword" },
			  { "vpxor", "keyword" },
			  { "pabsb", "keyword" },
			  { "kshiftrb", "keyword" },
			  { "kshiftrd", "keyword" },
			  { "kshiftrq", "keyword" },
			  { "pfrcpv", "keyword" },
			  { "ins", "keyword" },
			  { "kshiftrw", "keyword" },
			  { "pextrq", "keyword" },
			  { "movsx", "keyword" },
			  { "vpermilps", "keyword" },
			  { "cvtss2si", "keyword" },
			  { "ktestb", "keyword" },
			  { "cmpordps", "keyword" },
			  { "ktestq", "keyword" },
			  { "addss", "keyword" },
			  { "movsw", "keyword" },
			  { "kunpckwd", "keyword" },
			  { "vfmadd231ps", "keyword" },
			  { "lgdt", "keyword" },
			  { "vcmpnge_uqps", "keyword" },
			  { "hint_nop30", "keyword" },
			  { "outsb", "keyword" },
			  { "clzero", "keyword" },
			  { "kxnorw", "keyword" },
			  { "vpmovqb", "keyword" },
			  { "vcmpge_oqpd", "keyword" },
			  { "fsubp", "keyword" },
			  { "kxord", "keyword" },
			  { "kxorw", "keyword" },
			  { "lahf", "keyword" },
			  { "oword", "keyword2" },
			  { "mm7", "literal" },
			  { "lar", "keyword" },
			  { "lddqu", "keyword" },
			  { "qword", "keyword2" },
			  { "ldmxcsr", "keyword" },
			  { "lea", "keyword" },
			  { "xmm5", "literal" },
			  { "les", "keyword" },
			  { "vmovdqa64", "keyword" },
			  { "vcmpeq_uqpd", "keyword" },
			  { "lldt", "keyword" },
			  { "cr0", "literal" },
			  { "lmsw", "keyword" },
			  { "vpternlogd", "keyword" },
			  { "loadall", "keyword" },
			  { "fcmovne", "keyword" },
			  { "addpd", "keyword" },
			  { "outsd", "keyword" },
			  { "lodsb", "keyword" },
			  { "movhpd", "keyword" },
			  { "vmovqqu", "keyword" },
			  { "lodsd", "keyword" },
			  { "lodsq", "keyword" },
			  { "vpxorq", "keyword" },
			  { "mm0", "literal" },
			  { "loop", "keyword" },
			  { "vcmpunord_qps", "keyword" },
			  { "loopne", "keyword" },
			  { "loopnz", "keyword" },
			  { "fcmovnb", "keyword" },
			  { "sete", "keyword" },
			  { "blsi", "keyword" },
			  { "loopz", "keyword" },
			  { "lsl", "keyword" },
			  { "vcmpord_qpd", "keyword" },
			  { "maskmovdqu", "keyword" },
			  { "vrcpps", "keyword" },
			  { "vphaddbq", "keyword" },
			  { "valignq", "keyword" },
			  { "r15d", "literal" },
			  { "maxps", "keyword" },
			  { "mfence", "keyword" },
			  { "pminsw", "keyword" },
			  { "vcvtuqq2ps", "keyword" },
			  { "minpd", "keyword" },
			  { "pmaxub", "keyword" },
			  { "psubsb", "keyword" },
			  { "vmovapd", "keyword" },
			  { "vfnmaddss", "keyword" },
			  { "minsd", "keyword" },
			  { "movq", "keyword" },
			  { "vrsqrtss", "keyword" },
			  { "vcmpeq_uqss", "keyword" },
			  { "invd", "keyword" },
			  { "mm1", "literal" },
			  { "mm4", "literal" },
			  { "vmovaps", "keyword" },
			  { "paddq", "keyword" },
			  { "mm5", "literal" },
			  { "monitor", "keyword" },
			  { "movaps", "keyword" },
			  { "ALIGNB", "keyword2" },
			  { "movbe", "keyword" },
			  { "movd", "keyword" },
			  { "zmm1", "literal" },
			  { "wrpkru", "keyword" },
			  { "movddup", "keyword" },
			  { "fcos", "keyword" },
			  { "movdqa", "keyword" },
			  { "gs", "literal" },
			  { "movhps", "keyword" },
			  { "vpmaxsw", "keyword" },
			  { "vfmsub321sd", "keyword" },
			  { "vcmpnle_uqsd", "keyword" },
			  { "movmskps", "keyword" },
			  { "vpblendmd", "keyword" },
			  { "vcmpeq_ussd", "keyword" },
			  { "movntdq", "keyword" },
			  { "pextrw", "keyword" },
			  { "pfnacc", "keyword" },
			  { "movntdqa", "keyword" },
			  { "vcmptrue_uqps", "keyword" },
			  { "movntq", "keyword" },
			  { "psubusb", "keyword" },
			  { "movntsd", "keyword" },
			  { "cvtpi2pd", "keyword" },
			  { "outsw", "keyword" },
			  { "BITS", "keyword2" },
			  { "setnae", "keyword" },
			  { "kxnorq", "keyword" },
			  { "movntss", "keyword" },
			  { "movsd", "keyword" },
			  { "movshdup", "keyword" },
			  { "insertps", "keyword" },
			  { "movupd", "keyword" },
			  { "st6", "literal" },
			  { "psllw", "keyword" },
			  { "st2", "literal" },
			  { "movzx", "keyword" },
			  { "xmm25", "literal" },
			  { "vpsllvd", "keyword" },
			  { "kunpckbw", "keyword" },
			  { "mpsadbw", "keyword" },
			  { "vcmpnltss", "keyword" },
			  { "shl", "keyword" },
			  { "vphaddubw", "keyword" },
			  { "vgatherdpd", "keyword" },
			  { "mulpd", "keyword" },
			  { "COMMON", "keyword2" },
			  { "mulps", "keyword" },
			  { "vmovsd", "keyword" },
			  { "kshiftld", "keyword" },
			  { "mulsd", "keyword" },
			  { "mulss", "keyword" },
			  { "vcmpnless", "keyword" },
			  { "mulx", "keyword" },
			  { "vpcomq", "keyword" },
			  { "neg", "keyword" },
			  { "vpmacsww", "keyword" },
			  { "cmpxchg8b", "keyword" },
			  { "pmovsxbd", "keyword" },
			  { "zmm4", "literal" },
			  { "xmm0", "literal" },
			  { "nop", "keyword" },
			  { "setnz", "keyword" },
			  { "not", "keyword" },
			  { "vpsllq", "keyword" },
			  { "vcvttps2dq", "keyword" },
			  { "andps", "keyword" },
			  { "setg", "keyword" },
			  { "stc", "keyword" },
			  { "or", "keyword" },
			  { "vmovupd", "keyword" },
			  { "org", "keyword2" },
			  { "orpd", "keyword" },
			  { "pshufb", "keyword" },
			  { "vcmplesd", "keyword" },
			  { "orps", "keyword" },
			  { "out", "keyword" },
			  { "__SECT__", "keyword2" },
			  { "outs", "keyword" },
			  { "cmovnae", "keyword" },
			  { "struc", "keyword2" },
			  { "pabsd", "keyword" },
			  { "pabsw", "keyword" },
			  { "popfw", "keyword" },
			  { "packssdw", "keyword" },
			  { "zmm29", "literal" },
			  { "vmovdqu32", "keyword" },
			  { "packusdw", "keyword" },
			  { "sbb", "keyword" },
			  { "seg", "keyword2" },
			  { "cmpsw", "keyword" },
			  { "paddd", "keyword" },
			  { "popad", "keyword" },
			  { "paddsb", "keyword" },
			  { "arpl", "keyword" },
			  { "pxor", "keyword" },
			  { "vcmpltps", "keyword" },
			  { "vbroadcasti32x8", "keyword" },
			  { "paddsw", "keyword" },
			  { "pfrsqit1", "keyword" },
			  { "ah", "literal" },
			  { "pandn", "keyword" },
			  { "ymm13", "literal" },
			  { "pause", "keyword" },
			  { "pavgb", "keyword" },
			  { "vcvttsd2si", "keyword" },
			  { "cmplesd", "keyword" },
			  { "pavgusb", "keyword" },
			  { "dppd", "keyword" },
			  { "cmovns", "keyword" },
			  { "pclmulhqhqdq", "keyword" },
			  { "pclmulhqlqdq", "keyword" },
			  { "pclmullqhqdq", "keyword" },
			  { "vcmpngtpd", "keyword" },
			  { "fidiv", "keyword" },
			  { "pclmullqlqdq", "keyword" },
			  { "AT", "keyword2" },
			  { "pclmulqdq", "keyword" },
			  { "vpsubd", "keyword" },
			  { "pcmpeqd", "keyword" },
			  { "vpblendvb", "keyword" },
			  { "pcmpeqq", "keyword" },
			  { "pcmpeqw", "keyword" },
			  { "pcmpestri", "keyword" },
			  { "pcmpestrm", "keyword" },
			  { "vpclmulqdq", "keyword" },
			  { "prefetchw", "keyword" },
			  { "vroundpd", "keyword" },
			  { "pcmpgtd", "keyword" },
			  { "pdistib", "keyword" },
			  { "pext", "keyword" },
			  { "pextrd", "keyword" },
			  { "pmovsxwq", "keyword" },
			  { "pf2iw", "keyword" },
			  { "pswapd", "keyword" },
			  { "stosb", "keyword" },
			  { "pfcmpge", "keyword" },
			  { "vbroadcasti64x2", "keyword" },
			  { "leave", "keyword" },
			  { "psubsiw", "keyword" },
			  { "pfcmpgt", "keyword" },
			  { "vpaddusw", "keyword" },
			  { "movmskpd", "keyword" },
			  { "r12d", "literal" },
			  { "vcmpeq_uqsd", "keyword" },
			  { "pfmax", "keyword" },
			  { "subss", "keyword" },
			  { "pfmin", "keyword" },
			  { "minss", "keyword" },
			  { "pfrcpit1", "keyword" },
			  { "pfrcpit2", "keyword" },
			  { "pfsubr", "keyword" },
			  { "vpmovw2m", "keyword" },
			  { "pavgw", "keyword" },
			  { "paveb", "keyword" },
			  { "pmulhw", "keyword" },
			  { "vpcmpistri", "keyword" },
			  { "fadd", "keyword" },
			  { "phsubd", "keyword" },
			  { "vpsignd", "keyword" },
			  { "vinsertf128", "keyword" },
			  { "pi2fw", "keyword" },
			  { "pinsrd", "keyword" },
			  { "pinsrq", "keyword" },
			  { "pmaddubsw", "keyword" },
			  { "vmaxss", "keyword" },
			  { "pmagw", "keyword" },
			  { "pmaxsb", "keyword" },
			  { "vcmpnle_ussd", "keyword" },
			  { "pmaxsd", "keyword" },
			  { "pmaxuw", "keyword" },
			  { "blendvpd", "keyword" },
			  { "pminsb", "keyword" },
			  { "sysenter", "keyword" },
			  { "vphaddbw", "keyword" },
			  { "pminud", "keyword" },
			  { "extractps", "keyword" },
			  { "pminuw", "keyword" },
			  { "vcvttsd2usi", "keyword" },
			  { "psllq", "keyword" },
			  { "vunpckhps", "keyword" },
			  { "pmovzxbd", "keyword" },
			  { "rol", "keyword" },
			  { "pmovzxbq", "keyword" },
			  { "pmovzxwq", "keyword" },
			  { "crc32", "keyword" },
			  { "pmuldq", "keyword" },
			  { "vpsraw", "keyword" },
			  { "cmovnge", "keyword" },
			  { "pmulhrw", "keyword" },
			  { "xmm12", "literal" },
			  { "vgatherpf0dpd", "keyword" },
			  { "pmulhrwa", "keyword" },
			  { "pmulld", "keyword" },
			  { "movlpd", "keyword" },
			  { "pmuludq", "keyword" },
			  { "shrx", "keyword" },
			  { "pmvlzb", "keyword" },
			  { "pmvzb", "keyword" },
			  { "hint_nop12", "keyword" },
			  { "pop", "keyword" },
			  { "popaw", "keyword" },
			  { "vcvtps2pd", "keyword" },
			  { "popf", "keyword" },
			  { "vaesdeclast", "keyword" },
			  { "popfq", "keyword" },
			  { "vhaddpd", "keyword" },
			  { "por", "keyword" },
			  { "punpckhwd", "keyword" },
			  { "prefetch", "keyword" },
			  { "vscalefsd", "keyword" },
			  { "prefetcht0", "keyword" },
			  { "rcpss", "keyword" },
			  { "prefetcht2", "keyword" },
			  { "vbroadcastq", "keyword" },
			  { "pshufd", "keyword" },
			  { "kortestb", "keyword" },
			  { "pshufw", "keyword" },
			  { "cmpeqps", "keyword" },
			  { "subsd", "keyword" },
			  { "psignd", "keyword" },
			  { "vscalefss", "keyword" },
			  { "reso", "keyword2" },
			  { "setne", "keyword" },
			  { "st", "literal" },
			  { "vcmpfalse_ospd", "keyword" },
			  { "psignw", "keyword" },
			  { "xlatb", "keyword" },
			  { "vcmpeq_uqps", "keyword" },
			  { "pslld", "keyword" },
			  { "r11w", "literal" },
			  { "pslldq", "keyword" },
			  { "psrad", "keyword" },
			  { "vpmovusqb", "keyword" },
			  { "vmovlhps", "keyword" },
			  { "vfmsub132ps", "keyword" },
			  { "psrld", "keyword" },
			  { "vpmovswb", "keyword" },
			  { "vcmpord_sps", "keyword" },
			  { "psrlw", "keyword" },
			  { "zmm2", "literal" },
			  { "kxorb", "keyword" },
			  { "cmpxchg", "keyword" },
			  { "stos", "keyword" },
			  { "psubb", "keyword" },
			  { "psubd", "keyword" },
			  { "vmovmskps", "keyword" },
			  { "sldt", "keyword" },
			  { "psubq", "keyword" },
			  { "vpmovsxbd", "keyword" },
			  { "punpckhbw", "keyword" },
			  { "hint_nop27", "keyword" },
			  { "pusha", "keyword" },
			  { "rdpkru", "keyword" },
			  { "iretw", "keyword" },
			  { "..sym", "keyword2" },
			  { "setnb", "keyword" },
			  { "vrsqrt14ss", "keyword" },
			  { "vcmpgtpd", "keyword" },
			  { "sti", "keyword" },
			  { "ucomisd", "keyword" },
			  { "vmlaunch", "keyword" },
			  { "pushad", "keyword" },
			  { "pushaw", "keyword" },
			  { "wrgsbase", "keyword" },
			  { "pushfd", "keyword" },
			  { "vfmadd312sd", "keyword" },
			  { "pushfq", "keyword" },
			  { "times", "keyword2" },
			  { "pushfw", "keyword" },
			  { "jnz", "keyword" },
			  { "r10", "literal" },
			  { "r10w", "literal" },
			  { "jb", "keyword" },
			  { "r11", "literal" },
			  { "r11b", "literal" },
			  { "pmovzxdq", "keyword" },
			  { "r12", "literal" },
			  { "r13w", "literal" },
			  { "vcmptrue_uqsd", "keyword" },
			  { "r14", "literal" },
			  { "vmaskmovd", "keyword" },
			  { "r14b", "literal" },
			  { "r15b", "literal" },
			  { "fdivrp", "keyword" },
			  { "r8", "literal" },
			  { "pmulhrsw", "keyword" },
			  { "r8b", "literal" },
			  { "r9b", "literal" },
			  { "r9d", "literal" },
			  { "r14w", "literal" },
			  { "rbx", "literal" },
			  { "vcvtps2dq", "keyword" },
			  { "int01", "keyword" },
			  { "rcpps", "keyword" },
			  { "invept", "keyword" },
			  { "punpckldq", "keyword" },
			  { "rdfsbase", "keyword" },
			  { "hint_nop26", "keyword" },
			  { "sqrtpd", "keyword" },
			  { "ymm19", "literal" },
			  { "vexp2pd", "keyword" },
			  { "rdpid", "keyword" },
			  { "rdrand", "keyword" },
			  { "vpsllw", "keyword" },
			  { "verr", "keyword" },
			  { "fldl2e", "keyword" },
			  { "rdseed", "keyword" },
			  { "rdtscp", "keyword" },
			  { "xsaves64", "keyword" },
			  { "rdx", "literal" },
			  { "repe", "keyword" },
			  { "vextractf32x8", "keyword" },
			  { "repz", "keyword" },
			  { "rest", "keyword2" },
			  { "hint_nop19", "keyword" },
			  { "setna", "keyword" },
			  { "resw", "keyword2" },
			  { "frndint", "keyword" },
			  { "resy", "keyword2" },
			  { "resz", "keyword2" },
			  { "vpmovb2m", "keyword" },
			  { "movsb", "keyword" },
			  { "packuswb", "keyword" },
			  { "retn", "keyword" },
			  { "rorx", "keyword" },
			  { "vpunpckhwd", "keyword" },
			  { "roundpd", "keyword" },
			  { "paddb", "keyword" },
			  { "phminposuw", "keyword" },
			  { "roundps", "keyword" },
			  { "roundss", "keyword" },
			  { "roxr", "keyword" },
			  { "rsm", "keyword" },
			  { "rsqrtps", "keyword" },
			  { "vptestnmw", "keyword" },
			  { "vminps", "keyword" },
			  { "rsqrtss", "keyword" },
			  { "rsts", "keyword" },
			  { "vmulss", "keyword" },
			  { "scas", "keyword" },
			  { "scasb", "keyword" },
			  { "pcmpgtq", "keyword" },
			  { "scasq", "keyword" },
			  { "vshuff64x2", "keyword" },
			  { "kandw", "keyword" },
			  { "___NASM_PATCHLEVEL__", "keyword2" },
			  { "scasw", "keyword" },
			  { "svldt", "keyword" },
			  { "setl", "keyword" },
			  { "segment", "keyword2" },
			  { "seta", "keyword" },
			  { "setae", "keyword" },
			  { "jl", "keyword" },
			  { "setle", "keyword" },
			  { "vcvtsi2sd", "keyword" },
			  { "sgdt", "keyword" },
			  { "setnbe", "keyword" },
			  { "extern", "keyword2" },
			  { "setnc", "keyword" },
			  { "clwb", "keyword" },
			  { "setnl", "keyword" },
			  { "setnle", "keyword" },
			  { "vfnmsub312sd", "keyword" },
			  { "vcvtusi2sd", "keyword" },
			  { "vcmpneqss", "keyword" },
			  { "setp", "keyword" },
			  { "setpo", "keyword" },
			  { "shld", "keyword" },
			  { "zmm8", "literal" },
			  { "short", "keyword2" },
			  { "int", "keyword" },
			  { "shr", "keyword" },
			  { "rbp", "literal" },
			  { "shrd", "keyword" },
			  { "hint_nop11", "keyword" },
			  { "shufps", "keyword" },
			  { "sidt", "keyword" },
			  { "vpgatherdq", "keyword" },
			  { "vfmadd213ps", "keyword" },
			  { "sil", "literal" },
			  { "fnstenv", "keyword" },
			  { "slwpcb", "keyword" },
			  { "jcxz", "keyword" },
			  { "smi", "keyword" },
			  { "smint", "keyword" },
			  { "bextr", "keyword" },
			  { "smintold", "keyword" },
			  { "smsw", "keyword" },
			  { "aam", "keyword" },
			  { "kandnb", "keyword" },
			  { "sp", "literal" },
			  { "__FILE__", "keyword2" },
			  { "ALIGN", "keyword2" },
			  { "movsq", "keyword" },
			  { "phaddsw", "keyword" },
			  { "spl", "literal" },
			  { "sqrtps", "keyword" },
			  { "ss", "literal" },
			  { "r8w", "literal" },
			  { "st0", "literal" },
			  { "sqrtss", "keyword" },
			  { "st3", "literal" },
			  { "st4", "literal" },
			  { "vcmpngtps", "keyword" },
			  { "st7", "literal" },
			  { "stgi", "keyword" },
			  { "ucomiss", "keyword" },
			  { "stosd", "keyword" },
			  { "stosq", "keyword" },
			  { "vcmpunord_qsd", "keyword" },
			  { "stosw", "keyword" },
			  { "str", "keyword" },
			  { "subpd", "keyword" },
			  { "vpandd", "keyword" },
			  { "subps", "keyword" },
			  { "vpmovusdb", "keyword" },
			  { "vcmpordss", "keyword" },
			  { "r12b", "literal" },
			  { "svdc", "keyword" },
			  { "svts", "keyword" },
			  { "syscall", "keyword" },
			  { "movsxd", "keyword" },
			  { "sysexit", "keyword" },
			  { "jg", "keyword" },
			  { "tzcnt", "keyword" },
			  { "tzmsk", "keyword" },
			  { "jmp", "keyword" },
			  { "punpckhdq", "keyword" },
			  { "ud2", "keyword" },
			  { "vpcmpgtd", "keyword" },
			  { "punpckhqdq", "keyword" },
			  { "ud2a", "keyword" },
			  { "vfnmadd312pd", "keyword" },
			  { "unpckhpd", "keyword" },
			  { "vscalefps", "keyword" },
			  { "unpckhps", "keyword" },
			  { "vfmadd312pd", "keyword" },
			  { "pf2id", "keyword" },
			  { "r10b", "literal" },
			  { "unpcklpd", "keyword" },
		  },
		  ";",
		  {}

		} );
}

}}}} // namespace EE::UI::Doc::Language
